#!/usr/bin/perl
#  BigrammesUniques2Distance.pl

<<DOC; 
B. Habert
24/02/00


               BigrammesUniques2Distance.pl :


Format d'entre : 
     Un mot par ligne, suivi, aprs une tabulation, de ses bigrammes uniques. Exemple :
gadget\tga ad dg ge et 
gaffe\tga af ff fe 


Format de sortie :
<indice de Dice> <nombre de bigrammes partags> <nombre de bigrammes mot1 seulement> <nombre de bigrammes mot2 seulement>  <mot1> <mot2> <bigrammes mot1> <bigrammes mot2>
0.29    1 4 3           gadget  gaffe   ga ad dg ge et  ga af ff fe
0.80    2 3 2           gadget  gages   ga ad dg ge et  ga ag ge es

A faire :

Bugs et problmes :
     La valeur 0 est ambigu : elle peut correspondre  l'absence totale de proximit entre les deux mots, mais aussi  la comparaison du mot avec lui-mme.
DOC

# Tableaux aligns
@Mots                    = () ;
@BigrammesUniques        = () ;

$MinimumBigrammesUniques = 2 ;

# Mmorisation de tous les mots et de tous les bigrammes uniques

while ($Ligne =<>){
  $Ligne =~ /([^\t]+)\t(.*)/ ;
  $Mot = $1 ;
  $ChaineDeBigrammes = $2 ;
  @ListeBigrammes = split(/ /, $ChaineDeBigrammes) ;
  push(@Mots, $Mot) ;
  # La liste de bigrammes est mmorise comme une liste, 
  # pour ne pas avoir  la redcomposer  chaque comparaison.
  push(@BigrammesUniques, [ @ListeBigrammes ]) ;
  
}

# Pour chaque mot, calcul de la distance de ses bigrammes uniques 
# avec les bigrammes uniques de TOUS les autres mots
# Condition : chacun des mots compars a au moins le
# nombre minimal requis de bigrammes uniques.

for ($i = 0 ; $i <= $#Mots ; $i++)
 {@ListeBigrammesMot1 = @{ $BigrammesUniques[$i] } ;
  for ($j = $i + 1 ; $j <= $#Mots ; $j++)
   {@ListeBigrammesMot2 = @{ $BigrammesUniques[$j] } ;
    if ($#ListeBigrammesMot1 > $MinimumBigrammesUniques 
        && 
        $#ListeBigrammesMot2 > $MinimumBigrammesUniques)
    {DistanceEntreBigrammes() ;
    print "\t$Mots[$i]\t$Mots[$j]\t@ListeBigrammesMot1\t@ListeBigrammesMot2\n" ;
    }
   }
 }

# Un dictionnaire Bigramme / Emploi stocke les correspondances : 
#  1 - employ dans mot1 seulement ;
#  2 - employ dans mot1 et mot2 ;
#  0 - employ dans mot2 seulement.
# Le total de chacun des cas permet de calculer l'indice de Dice.

sub DistanceEntreBigrammes
{%Bigramme2Emploi = () ;
 for ($k = 0 ; $k <= $#ListeBigrammesMot1 ; $k++)
 {$Bigramme2Emploi{$ListeBigrammesMot1[$k]} = 1 ;
 }
 for ($l = 0 ; $l <= $#ListeBigrammesMot2 ; $l++)
 {if (exists $Bigramme2Emploi{$ListeBigrammesMot2[$l]})
      {$Bigramme2Emploi{$ListeBigrammesMot2[$l]} = 0 ; }
  else
      {$Bigramme2Emploi{$ListeBigrammesMot2[$l]} = 2 ; }
 }
  $BigrammesMot1Seulement = 0 ;
  $BigrammesMot2Seulement = 0 ;
  $BigrammesPartages = 0 ;
  for $Bigramme (keys %Bigramme2Emploi)
  {if ($Bigramme2Emploi{$Bigramme} == 0)
   { $BigrammesPartages++ ; }
   if ($Bigramme2Emploi{$Bigramme} == 1)
   { $BigrammesMot1Seulement++ ; }
  if ($Bigramme2Emploi{$Bigramme} == 2)
   { $BigrammesMot2Seulement++ ; }
  }
  if (($BigrammesMot1Seulement + $BigrammesMot2Seulement) > 0)
  {$IndiceDice = ($BigrammesPartages * 2)/ ($BigrammesMot1Seulement + $BigrammesMot2Seulement) ; }
  else
  {$IndiceDice = 0 ; }
  printf "%1.2f\t", $IndiceDice ;
  print "$BigrammesPartages $BigrammesMot1Seulement $BigrammesMot2Seulement\t" ;
}
