#!/usr/bin/perl
#  Cordialcnr2BLOCs.pl

<<DOC; 
B. Habert
17/02/00

               Cordialcnr2BLOCs.pl :


Format d'entre : 
     Sorties de Cordial 6 universits avec des tiquettes au format GRACE. Exemple :
N mot  mot     lemme   Codegram
        ==== DEBUT DE PHRASE ====
0       \r<#Art-513-1>\r
1       Repenser        repenser        Vmn--
2       la      le      Da-fs-d
3       loi     loi     Ncfs
4       de      de      Sp
5       fixation        fixation        Ncfs
6       des     de      Da-.p-i
7       prix    prix    Ncmp
8        
        ===== FIN DE PHRASE =====
        ==== DEBUT DE PHRASE ====
Attention, il s'agit d'un fichier Windows dont les fins de lignes sont marques par \r\n

Format de sortie :
     Chaque fin de phrase est remplace par la mention de <BLOC>. Pour chaque item, son lemme et sa catgorie, soudes par un sparateur dont il faut vrifier qu'il n'est pas employ dans le texte tiquet. Exemple :
repenser_V
le_D
loi_N
de_S
fixation_N
de_D
prix_N
<BLOC>
le_D
article_N
45_N

NB : pour ne pas parpiller les lemmes, on ne garde que la partie du discours et pas les traits supplmentaires. Sinon, on obtiendrait :

repenser_Vmn--
le_Da-fs-d
loi_Ncfs
de_Sp
fixation_Ncfs
de_Da-.p-i
prix_Ncmp
<BLOC>
le_Da-ms-d
article_Ncms
45_Ncm.

A faire :

Bugs et problmes :

DOC

$Forme      = "" ;
$Lemme      = "" ;
$Categorie  = "" ;
$Separateur = "_" ;

open(RES1,">format1.txt");
open(RES2,">format2.txt");
open(RES3,">format3.txt");
open(RES4,">format4.txt");
open(RES5,">format5.txt");


while ($Ligne = <>){
 if ($Ligne =~ /DEBUT DE PHRASE/ 
     ||
     $Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
     ||
     $Ligne =~ /^0\t/
     ||
     $Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
     ||
     $Ligne =~ /Mc\.\./
     ||
     $Ligne =~ /^[0-9]+[\t ]+\r/)
  # Ce sont des lignes qu'on limine
  { 
  }
  elsif ($Ligne =~ /FIN DE PHRASE/)
        {
         print RES1 "<BLOC>\n" ; 
         print RES2 "<BLOC>\n" ; 
         print RES3 "<BLOC>\n" ; 
         print RES4 "<BLOC>\n" ; 
         print RES5 "<BLOC>\n" ; 
        }
  elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t(.)([^\r]+)/)
        {$Forme = $1 ;
         $Lemme = $2 ;
         $Categorie = $3 ;
         $Traits    = $4 ;
         print RES1 "$Lemme$Separateur$Forme$Separateur$Categorie$Traits " ;
         print RES2 "$Lemme$Separateur$Categorie " ;
         print RES3 "$Forme$Separateur$Categorie " ;
         print RES4 "$Forme " ;
         print RES5 "$Categorie$Traits$Separateur$Lemme$Separateur$Forme " ;
        }
}


close RES1;
close RES2;
close RES3;
close RES4;
close RES5;
