#!/usr/bin/perl -w

use Tk;

$mw = MainWindow->new;
$mw->title("Quick Draw");

$f = $mw->Frame(-relief => 'groove', 
                -bd => 2, 
                -label => "Trac :")->pack(-side => 'left', -fill => 'y');
$element_trace = "rectangle";
$f->Radiobutton(-variable => \$element_trace,
                -text => "Rectangle",
                -value => "rectangle",
                -command => \&liaison)->pack(-anchor => 'w');
$f->Radiobutton(-variable => \$element_trace,
                -text => "Ovale",
                -value => "ovale",
                -command => \&liaison)->pack(-anchor => 'w');
$f->Radiobutton(-variable => \$element_trace,
                -text => "Ligne",
                -value => "ligne",
                -command => \&liaison)->pack(-anchor => 'w');
$f->Label(-text => "paisseur de la ligne :")->pack(-anchor => 'w');
$epaisseur = 1;
$f->Entry(-textvariable => \$epaisseur)->pack(-anchor => 'w');

$c = $mw->Scrolled("Canvas", -cursor => "crosshair")->pack(
              -side => "left", -fill => 'both', -expand => 1);
$canvas = $c->Subwidget("canvas");

&liaison();

MainLoop;

sub liaison {
  # S'il y une liaison "Motion", il faut autoriser l'utilisateur
  #  terminer de tracer l'lment avant de lier  nouveau Button-1
  # Cette fonction sera appele lorsque <FIXME : comprend pas la suite>
  @liaisons = $canvas->Tk::bind("<Motion>");
  return if ($#liaisons >= 0);
    
  if ($element_trace eq "rectangle"|| $element_trace eq "ovale"||
      $element_trace eq "ligne") {
    $canvas->Tk::bind("<Button-1>", [\&debut_dessin, Ev('x'), Ev('y')]);
  }
}

sub debut_dessin {
  my ($canv, $x, $y) = @_;
  $x = $canv->canvasx($x);
  $y = $canv->canvasy($y);
  
  # Petite vrification d'erreurs
  $epaisseur = 1 if ($epaisseur !~ /[0-9]+/);

  if ($element_trace eq "rectangle") {
    $canvas->createRectangle($x, $y, $x, $y, 
       -width => $epaisseur, -tags => "trace_moi");
  } elsif ($element_trace eq "ovale") {
    $canvas->createOval($x, $y, $x, $y,
       -width => $epaisseur, -tags => "trace_moi");
  } elsif ($element_trace eq "ligne") {
    $canvas->createLine($x, $y, $x, $y, 
       -width => $epaisseur, -tags => "trace_moi");
  }
  
  $debut_x = $x; $debut_y = $y;
  # Fait correspondre la liaison Button-1   &fin_dessin 
  # plutt que de commencer  tracer
  $canvas->Tk::bind("<Motion>", [\&taille_elt, Ev('x'), Ev('y')]);
  $canvas->Tk::bind("<Button-1>", [\&fin_dessin, Ev('x'), Ev('y')]);
}

sub taille_elt  {
  my ($canv, $x, $y) = @_;
  $x = $canv->canvasx($x);
  $y = $canv->canvasy($y);

  $canvas->coords("trace_moi", $debut_x, $debut_y, $x, $y);
}

sub fin_dessin {
  my ($canv, $x, $y) = @_;
  $x = $canv->canvasx($x);
  $y = $canv->canvasy($y);

  # finalise la taille de l'lment et te le marqueur
  $canvas->coords("trace_moi", $debut_x, $debut_y, $x, $y);
  $canvas->dtag("trace_moi");
  
  # Supprime la liaison <Motion>
  $canvas->Tk::bind("<Motion>", "");
  &liaison();
}
