package MyVisitor;

sub new {
    my $class = shift;

    return bless {}, $class;
}

sub visit_grove {
    my $self = shift; my $grove = shift;

    $grove->children_accept ($self, @_);
}

sub visit_element {
    my $self = shift; my $element = shift; my $context = shift;

    push @$context, $element->name;
    my @attributes = %{$element->attributes};
    print STDERR "@$context \\\\ (@attributes)\n";
    $element->children_accept ($self, $context, @_);
    print STDERR "@$context //\n";
    pop @$context;
}

sub visit_pi {
    my $self = shift; my $pi = shift; my $context = shift;

    my $target = $pi->target;
    my $data = $pi->data;
    print STDERR "@$context ?? $target($data)\n";
}

sub visit_scalar {
    my $self = shift; my $scalar = shift; my $context = shift;

    $scalar =~ s/([\x80-\xff])/sprintf "#x%X;", ord $1/eg;
    $scalar =~ s/([\t\n])/sprintf "#%d;", ord $1/eg;
    print STDERR "@$context || $scalar\n";
}

1;
