# ! /usr/bin/perl
use English;

<<DOC; 
S.Fleury
Juillet 2000

               ExtAndStatFrCorpTwb.pl :


Format d'entre : 

- le programme prend en entre un corpus XML gnr par mktipo.pl et produit :
  1. Une version textuelle du corpus : le texte brut de toutes les pages HTML
  2. Frquence de tous les mots par fichier html original et par site
  3. Une prsentation synthtique des frquences de chaque lment structurel par fichier HTML original
  4. Une prsentation synthtique des frquences des diffrents types de liens trouvs par fichier HTML original
  5. Un index de tous les fichiers par site

Format de sortie :

- un tat regroupant les infos pour tous les fichiers pris un  un
- un tat regroupant les infos pour tous les fichiers pris globalement


A faire :

Bugs et problmes :


Libell  retenir :

item                      balise

Name anchors found:       SITEWebDocumentAnchorFound
Name anchors not found:   SITEWebDocumentAnchorNotFound
Files not found:          SITEWebDocumentFileNotFound
External URLs:            SITEWebDocumentUrls
Mailto:                   SITEWebDocumentMailTo
Images:                   SITEWebDocumentImages
Web documents found:      SITEWebDocumentFound
Generated report files:   SITEWebDocumentDissected

LINK-INTERNAL-IMAGE:      INTImage
LINK-EXTERNAL-IMAGE:      EXTImage
LINK-INTERNAL-FILE:       SITEFileInternalLinks
LINK-EXTERNAL-HYPERTEXTUAL: SITEFileExtHypertextualLinks
LINK-INTERNAL-HYPERTEXTUAL: SITEFileIntHypertextualLinks
LINK-INTERNAL-HTMLFILE:   SITEFileHtmlFileLinks
LINK-INTERNAL-DOCFILE:    SITEFileIntDocFileLinks
LINK-INTERNAL-ANCHOR:     SITEFileInternalAnchor
LINK-EXTERNAL-ANCHOR:     SITEFileExternalAnchor
LINK-EXTERNAL-MAILTO:     SITEFileExternalMail
LINK-EXTERNAL-HTTP:       SITEFileExternalLinks
LINK-EXTERNAL-HTTP_CGI:   SITEFileExternalCgiLinks
LINK-EXTERNAL-HTTP_NEWS:  SITEFileExternalNewsLinks
LINK-EXTERNAL-HTTP_FTP:   SITEFileExternalFtpLinks
LINK-EXTERNAL-HTTP_GOPHER : SITEFileExternalGopherLinks

SITEFileLinksNumber est la somme de tous les liens


DOC

#--------------- SUB -----------------

sub lineCleaner     {
  my($line) = @_;

#correction ISO8859-1

$line=~s/&#34;/"/g;            
$line=~s/&quot;/"/g;
$line=~s/&#38;/&/g;            
$line=~s/&amp;/ET\$/g;
$line=~s/&#60;/</g;            
$line=~s/&lt;/</g;
$line=~s/&#62;/>/g;            
$line=~s/&gt;/>/g;
$line=~s/&#160;/ /g;            
$line=~s/&nbsp;/ /g;
$line=~s/&#161;//g;            
$line=~s/&iexcl;//g;
$line=~s/&#162;//g;            
$line=~s/&cent;//g;
$line=~s/&#163;//g;            
$line=~s/&pound;//g;
$line=~s/&#164;//g;            
$line=~s/&curren;//g;
$line=~s/&#165;//g;            
$line=~s/&yen;//g;
$line=~s/&#166;//g;            
$line=~s/&brkbar;//g;
$line=~s/&#167;//g;            
$line=~s/&sect;//g;
$line=~s/&#168;//g;            
$line=~s/&uml;//g;
$line=~s/&#169;//g;            
$line=~s/&copy;//g;
$line=~s/&#170;//g;            
$line=~s/&ordf;//g;
$line=~s/&#171;//g;            
$line=~s/&laquo;//g;
$line=~s/&#172;//g;            
$line=~s/&not;//g;
$line=~s/&#173;//g;            
$line=~s/&shy;//g;
$line=~s/&#174;//g;            
$line=~s/&reg;//g;
$line=~s/&#175;//g;            
$line=~s/&hibar;//g;
$line=~s/&#176;//g;            
$line=~s/&deg;//g;
$line=~s/&#177;//g;            
$line=~s/&plusmn;//g;
$line=~s/&#178;//g;            
$line=~s/&sup2;//g;
$line=~s/&#179;//g;            
$line=~s/&sup3;//g;
$line=~s/&#180;//g;            
$line=~s/&acute;//g;
$line=~s/&#181;//g;            
$line=~s/&micro;//g;
$line=~s/&#182;//g;            
$line=~s/&para;//g;
$line=~s/&#183;//g;            
$line=~s/&middot;//g;
$line=~s/&#184;//g;            
$line=~s/&cedil;//g;
$line=~s/&#185;//g;            
$line=~s/&sup1;//g;
$line=~s/&#186;//g;            
$line=~s/&ordm;//g;
$line=~s/&#187;//g;            
$line=~s/&raquo;//g;
$line=~s/&#188;//g;            
$line=~s/&frac14;//g;
$line=~s/&#189;//g;            
$line=~s/&frac12;//g;
$line=~s/&#190;//g;            
$line=~s/&frac34;//g;
$line=~s/&#191;//g;            
$line=~s/&iquest;//g;
$line=~s/&#192;//g;            
$line=~s/&Agrave;//g;
$line=~s/&#193;//g;            
$line=~s/&Aacute;//g;
$line=~s/&#194;//g;            
$line=~s/&Acirc;//g;
$line=~s/&#195;//g;            
$line=~s/&Atilde;//g;
$line=~s/&#196;//g;            
$line=~s/&Auml;//g;
$line=~s/&#197;//g;            
$line=~s/&Aring;//g;
$line=~s/&#198;//g;            
$line=~s/&AElig;//g;
$line=~s/&#199;//g;            
$line=~s/&Ccedil;//g;
$line=~s/&#200;//g;            
$line=~s/&Egrave;//g;
$line=~s/&#201;//g;            
$line=~s/&Eacute;//g;
$line=~s/&#202;//g;            
$line=~s/&Ecirc;//g;
$line=~s/&#203;//g;            
$line=~s/&Euml;//g;
$line=~s/&#204;//g;            
$line=~s/&Igrave;//g;
$line=~s/&#205;//g;            
$line=~s/&Iacute;//g;
$line=~s/&#206;//g;            
$line=~s/&Icirc;//g;
$line=~s/&#207;//g;            
$line=~s/&Iuml;//g;
$line=~s/&#208;//g;            
$line=~s/&Dstrok;//g;
$line=~s/&#209;//g;            
$line=~s/&Ntilde;//g;
$line=~s/&#210;//g;            
$line=~s/&Ograve;//g;
$line=~s/&#211;//g;            
$line=~s/&Oacute;//g;
$line=~s/&#212;//g;            
$line=~s/&Ocirc;//g;
$line=~s/&#213;//g;            
$line=~s/&Otilde;//g;
$line=~s/&#214;//g;            
$line=~s/&Ouml;//g;
$line=~s/&#215;//g;            
$line=~s/&times;//g;
$line=~s/&#216;//g;            
$line=~s/&Oslash;//g;
$line=~s/&#217;//g;            
$line=~s/&Ugrave;//g;
$line=~s/&#218;//g;            
$line=~s/&Uacute;//g;
$line=~s/&#219;//g;            
$line=~s/&Ucirc;//g;
$line=~s/&#220;//g;            
$line=~s/&Uuml;//g;
$line=~s/&#221;//g;            
$line=~s/&Yacute;//g;
$line=~s/&#222;//g;            
$line=~s/&THORN;//g;
$line=~s/&#223;//g;            
$line=~s/&szlig;//g;
$line=~s/&#224;//g;            
$line=~s/&agrave;//g;
$line=~s/&#225;//g;            
$line=~s/&aacute;//g;
$line=~s/&#226;//g;            
$line=~s/&acirc;//g;
$line=~s/&#227;//g;            
$line=~s/&atilde;//g;
$line=~s/&#228;//g;            
$line=~s/&auml;//g;
$line=~s/&#229;//g;            
$line=~s/&aring;//g;
$line=~s/&#230;//g;            
$line=~s/&aelig;//g;
$line=~s/&#231;//g;            
$line=~s/&ccedil;//g;
$line=~s/&#232;//g;            
$line=~s/&egrave;//g;
$line=~s/&#233;//g;            
$line=~s/&eacute;//g;
$line=~s/&#234;//g;            
$line=~s/&ecirc;//g;
$line=~s/&#235;//g;            
$line=~s/&euml;//g;
$line=~s/&#236;//g;            
$line=~s/&igrave;//g;
$line=~s/&#237;//g;            
$line=~s/&iacute;//g;
$line=~s/&#238;//g;            
$line=~s/&icirc;//g;
$line=~s/&#239;//g;            
$line=~s/&iuml;//g;
$line=~s/&#240;//g;            
$line=~s/&eth;//g;
$line=~s/&#241;//g;            
$line=~s/&ntilde;//g;
$line=~s/&#242;//g;            
$line=~s/&ograve;//g;
$line=~s/&#243;//g;            
$line=~s/&oacute;//g;
$line=~s/&#244;//g;            
$line=~s/&ocirc;//g;
$line=~s/&#245;//g;            
$line=~s/&otilde;//g;
$line=~s/&#246;//g;            
$line=~s/&ouml;//g;
$line=~s/&#247;//g;            
$line=~s/&divide;//g;
$line=~s/&#248;//g;            
$line=~s/&oslash;//g;
$line=~s/&#249;//g;            
$line=~s/&ugrave;//g;
$line=~s/&#250;//g;            
$line=~s/&uacute;//g;
$line=~s/&#251;//g;            
$line=~s/&ucirc;//g;
$line=~s/&#252;//g;            
$line=~s/&uuml;//g;
$line=~s/&#253;//g;            
$line=~s/&yacute;//g;
$line=~s/&#254;//g;            
$line=~s/&thorn;//g;
$line=~s/&#255;//g;            
$line=~s/&yuml;//g;

#les memes mal ecrits i.e sans le point-virgule  la fin...

$line=~s/&#34[^;]/"/g;            
$line=~s/&quot[^;]/"/g;
$line=~s/&#38[^;]/&/g;            
$line=~s/&amp[^;]/ET\$/g;
$line=~s/&#60[^;]/</g;            
$line=~s/&lt[^;]/</g;
$line=~s/&#62[^;]/>/g;            
$line=~s/&gt[^;]/>/g;
$line=~s/&#160[^;]/ /g;            
$line=~s/&nbsp[^;]/ /g;
$line=~s/&#161[^;]//g;            
$line=~s/&iexcl[^;]//g;
$line=~s/&#162[^;]//g;            
$line=~s/&cent[^;]//g;
$line=~s/&#163[^;]//g;            
$line=~s/&pound[^;]//g;
$line=~s/&#164[^;]//g;            
$line=~s/&curren[^;]//g;
$line=~s/&#165[^;]//g;            
$line=~s/&yen[^;]//g;
$line=~s/&#166[^;]//g;            
$line=~s/&brkbar[^;]//g;
$line=~s/&#167[^;]//g;            
$line=~s/&sect[^;]//g;
$line=~s/&#168[^;]//g;            
$line=~s/&uml[^;]//g;
$line=~s/&#169[^;]//g;            
$line=~s/&copy[^;]//g;
$line=~s/&#170[^;]//g;            
$line=~s/&ordf[^;]//g;
$line=~s/&#171[^;]//g;            
$line=~s/&#171[^;]//gi;
$line=~s/&laquo[^;]//g;
$line=~s/&#172[^;]//g;            
$line=~s/&not[^;]//g;
$line=~s/&#173[^;]//g;            
$line=~s/&shy[^;]//g;
$line=~s/&#174[^;]//g;            
$line=~s/&reg[^;]//g;
$line=~s/&#175[^;]//g;            
$line=~s/&hibar[^;]//g;
$line=~s/&#176[^;]//g;            
$line=~s/&deg[^;]//g;
$line=~s/&#177[^;]//g;            
$line=~s/&plusmn[^;]//g;
$line=~s/&#178[^;]//g;            
$line=~s/&sup2[^;]//g;
$line=~s/&#179[^;]//g;            
$line=~s/&sup3[^;]//g;
$line=~s/&#180[^;]//g;            
$line=~s/&acute[^;]//g;
$line=~s/&#181[^;]//g;            
$line=~s/&micro[^;]//g;
$line=~s/&#182[^;]//g;            
$line=~s/&para[^;]//g;
$line=~s/&#183[^;]//g;            
$line=~s/&middot[^;]//g;
$line=~s/&#184[^;]//g;            
$line=~s/&cedil[^;]//g;
$line=~s/&#185[^;]//g;            
$line=~s/&sup1[^;]//g;
$line=~s/&#186[^;]//g;            
$line=~s/&ordm[^;]//g;
$line=~s/&#187[^;]//g;            
$line=~s/&raquo[^;]//g;
$line=~s/&#188[^;]//g;            
$line=~s/&frac14[^;]//g;
$line=~s/&#189[^;]//g;            
$line=~s/&frac12[^;]//g;
$line=~s/&#190[^;]//g;            
$line=~s/&frac34[^;]//g;
$line=~s/&#191[^;]//g;            
$line=~s/&iquest[^;]//g;
$line=~s/&#192[^;]//g;            
$line=~s/&Agrave[^;]//g;
$line=~s/&#193[^;]//g;            
$line=~s/&Aacute[^;]//g;
$line=~s/&#194[^;]//g;            
$line=~s/&Acirc[^;]//g;
$line=~s/&#195[^;]//g;            
$line=~s/&Atilde[^;]//g;
$line=~s/&#196[^;]//g;            
$line=~s/&Auml[^;]//g;
$line=~s/&#197[^;]//g;            
$line=~s/&Aring[^;]//g;
$line=~s/&#198[^;]//g;            
$line=~s/&AElig[^;]//g;
$line=~s/&#199[^;]//g;            
$line=~s/&Ccedil[^;]//g;
$line=~s/&#200[^;]//g;            
$line=~s/&Egrave[^;]//g;
$line=~s/&#201[^;]//g;            
$line=~s/&Eacute[^;]//g;
$line=~s/&#202[^;]//g;            
$line=~s/&Ecirc[^;]//g;
$line=~s/&#203[^;]//g;            
$line=~s/&Euml[^;]//g;
$line=~s/&#204[^;]//g;            
$line=~s/&Igrave[^;]//g;
$line=~s/&#205[^;]//g;            
$line=~s/&Iacute[^;]//g;
$line=~s/&#206[^;]//g;            
$line=~s/&Icirc[^;]//g;
$line=~s/&#207[^;]//g;            
$line=~s/&Iuml[^;]//g;
$line=~s/&#208[^;]//g;            
$line=~s/&Dstrok[^;]//g;
$line=~s/&#209[^;]//g;            
$line=~s/&Ntilde[^;]//g;
$line=~s/&#210[^;]//g;            
$line=~s/&Ograve[^;]//g;
$line=~s/&#211[^;]//g;            
$line=~s/&Oacute[^;]//g;
$line=~s/&#212[^;]//g;            
$line=~s/&Ocirc[^;]//g;
$line=~s/&#213[^;]//g;            
$line=~s/&Otilde[^;]//g;
$line=~s/&#214[^;]//g;            
$line=~s/&Ouml[^;]//g;
$line=~s/&#215[^;]//g;            
$line=~s/&times[^;]//g;
$line=~s/&#216[^;]//g;            
$line=~s/&Oslash[^;]//g;
$line=~s/&#217[^;]//g;            
$line=~s/&Ugrave[^;]//g;
$line=~s/&#218[^;]//g;            
$line=~s/&Uacute[^;]//g;
$line=~s/&#219[^;]//g;            
$line=~s/&Ucirc[^;]//g;
$line=~s/&#220[^;]//g;            
$line=~s/&Uuml[^;]//g;
$line=~s/&#221[^;]//g;            
$line=~s/&Yacute[^;]//g;
$line=~s/&#222[^;]//g;            
$line=~s/&THORN[^;]//g;
$line=~s/&#223[^;]//g;            
$line=~s/&szlig[^;]//g;
$line=~s/&#224[^;]//g;            
$line=~s/&agrave[^;]//g;
$line=~s/&#225[^;]//g;            
$line=~s/&aacute[^;]//g;
$line=~s/&#226[^;]//g;            
$line=~s/&acirc[^;]//g;
$line=~s/&#227[^;]//g;            
$line=~s/&atilde[^;]//g;
$line=~s/&#228[^;]//g;            
$line=~s/&auml[^;]//g;
$line=~s/&#229[^;]//g;            
$line=~s/&aring[^;]//g;
$line=~s/&#230[^;]//g;            
$line=~s/&aelig[^;]//g;
$line=~s/&#231[^;]//g;            
$line=~s/&ccedil[^;]//g;
$line=~s/&#232[^;]//g;            
$line=~s/&egrave[^;]//g;
$line=~s/&#233[^;]//g;            
$line=~s/&eacute[^;]//g;
$line=~s/&#234[^;]//g;            
$line=~s/&ecirc[^;]//g;
$line=~s/&#235[^;]//g;            
$line=~s/&euml[^;]//g;
$line=~s/&#236[^;]//g;            
$line=~s/&igrave[^;]//g;
$line=~s/&#237[^;]//g;            
$line=~s/&iacute[^;]//g;
$line=~s/&#238[^;]//g;            
$line=~s/&icirc://g;
$line=~s/&icirc[^;]//g;
$line=~s/&#239[^;]//g;            
$line=~s/&iuml[^;]//g;
$line=~s/&#240[^;]//g;            
$line=~s/&eth[^;]//g;
$line=~s/&#241[^;]//g;            
$line=~s/&ntilde[^;]//g;
$line=~s/&#242[^;]//g;            
$line=~s/&ograve[^;]//g;
$line=~s/&#243[^;]//g;            
$line=~s/&oacute[^;]//g;
$line=~s/&#244[^;]//g;            
$line=~s/&ocirc[^;]//g;
$line=~s/&#245[^;]//g;            
$line=~s/&otilde[^;]//g;
$line=~s/&#246[^;]//g;            
$line=~s/&ouml[^;]//g;
$line=~s/&#247[^;]//g;            
$line=~s/&divide[^;]//g;
$line=~s/&#248[^;]//g;            
$line=~s/&oslash[^;]//g;
$line=~s/&#249[^;]//g;            
$line=~s/&ugrave[^;]//g;
$line=~s/&#250[^;]//g;            
$line=~s/&uacute[^;]//g;
$line=~s/&#251[^;]//g;            
$line=~s/&ucirc[^;]//g;
$line=~s/&#252[^;]//g;            
$line=~s/&uuml[^;]//g;
$line=~s/&#253[^;]//g;            
$line=~s/&yacute[^;]//g;
$line=~s/&#254[^;]//g;            
$line=~s/&thorn[^;]//g;
$line=~s/&#255[^;]//g;            
$line=~s/&yuml[^;]//g;


#Supplments divers  vrifier

 $line=~s/[^&]nbsp[;]*/ /gi;
 $line=~s/&nbsp$/ /gi;

 $line=~s/&oelig;/oe/g;
 $line=~s/&Oelig;/OE/g;
 $line=~s/&#156;/oe/g;
 $line=~s/&#140;/OE/g;
 $line=~s/&oelig[^;]/oe/g;
 $line=~s/&Oelig[^;]/OE/g;
 $line=~s/&#156[^;]/oe/g;
 $line=~s/&#140[^;]/OE/g;
 $line=~s/&OElig;/OE/g;

 $line=~s/&#91;/[/gi;
 $line=~s/&#93;/]/gi;
 $line=~s/&#126;/~/gi;
 $line=~s/&#45;/-/gi;
 $line=~s/&#151;//gi;
 $line=~s/&#124;/|/g;
 $line=~s/&#146;/'/gi;
 $line=~s/&#91[^;]/[/gi;
 $line=~s/&#93[^;]/]/gi;
 $line=~s/&#126[^;]/~/gi;
 $line=~s/&#45[^;]/-/gi;
 $line=~s/&#151[^;]//gi;
 $line=~s/&#124[^;]/|/g;
 $line=~s/&#146[^;]/'/gi;
 $line=~s/&#160;//gi;
 $line=~s/&#160[^;]//gi;
 $line=~s/&#153;//gi;
 $line=~s/&#9;//gi;
 $line=~s/&#128;//gi;
 $line=~s/&#39;/'/gi;
 $line=~s/&#153[^;]/TM/gi;
 $line=~s/&#9[^;]//gi;
 $line=~s/&#128[^;]//gi;
 $line=~s/&#39[^;]/'/gi;
 $line=~s/&#130;/'/gi;
 $line=~s/&#149;/-/gi;
 $line=~s/&#130[^;]/'/gi;
 $line=~s/&#149[^;]/-/gi;
 $line=~s/&#145;/`/gi;
 $line=~s/&#133;/\.\.\./gi;
 $line=~s/&#150;/-/gi;
 $line=~s/&#145[^;]/`/gi;
 $line=~s/&#133[^;]/\.\.\./gi;
 $line=~s/&#150[^;]/-/gi;
 $line=~s/&#147;/"/gi;
 $line=~s/&#148;/"/gi;
 $line=~s/&#147[^;]/"/gi;
 $line=~s/&#148[^;]/"/gi;
 $line=~s/&#37;/%/g;
 $line=~s/&#37[^;]/%/g;
 $line=~s/&#153//g;
 $line=~s/&#134;/;/g;
 $line=~s/&#40;/\(/g;
 $line=~s/&#42;/*/g;
 $line=~s/&#59;/;/g;
 $line=~s/&#153;//g;
 $line=~s/&#134/;/g;
 $line=~s/&#40/\(/g;
 $line=~s/&#42/*/g;
 $line=~s/&#59/;/g;
 $line=~s/&#44/,/g;
 $line=~s/&#34/\"/g;
 $line=~s/&#38/ET\$/g;
 $line=~s/&#139//g;
 $line=~s/&#32;//g;
 $line=~s/&#201;//g;
 $line=~s/&#133;//g;
 $line=~s/&#171;//g;
 $line=~s/&#187;//g;
 $line=~s/&#44;/,/g;
 $line=~s/&#34;/\"/g;
 $line=~s/&#38;/ET\$/g;
 $line=~s/&#139;//g;
 $line=~s/&#32//g;
 $line=~s/&#201//g;
 $line=~s/&#133//g;
 $line=~s/&#171//g;
 $line=~s/&#187//g;


 $line=~s/\
//gi;
 $line=~s/<[^>]*>//gi; 
 $line=~s/<[^>]+$//gi;
 $line=~s/^[^<]+>//gi;
 $line=~s/[\-]+/\-/gi;
 $line=~s/[ ]+/ /gi;
 $line=~s/ \& / ET\$ /gi;
 $line=~s/&&/ET\$ET\$/g;
 $line=~s/&\"/ET\$\"/g;

 $line=~s/drag&drop/dragET\$drop/gi;
 $line=~s/arts&craft/artsET\$craft/gi;
 $line=~s/ \&$/ ET\$/;
 $line=~s/^\&$/ET\$/;
 $line=~s/Netscape&/NetscapeET\$/gi; 
 $line=~s/&c./ET\$c\./gi;

 $line=~s/AD&D/ADET\$D/gi;
 $line=~s/AT&T/ATET\$T/gi;
 $line=~s/P&T/PET\$T/gi;
 $line=~s/f&w/fET\$w/gi;
 $line=~s/n&b/nET\$b/gi;
 $line=~s/y&t/YET\$T/gi;
 $line=~s/B&B/BET\$B/g;
 $line=~s/Zab&Stf/ZabET\$Stf/g;
 $line=~s/&Noble/ET\$Noble/g;
 $line=~s/&ecric;//g;
 $line=~s/&ecric//g;
 $line=~s/N\.&B/N\.ET\$B/g;
 $line=~s/&rapidit/ET\$rapidit/g;
 $line=~s/Costes&/CostesET\$/g;
 $line=~s/R&D/RET\$D/g;
 $line=~s/\(&\)/\(ET\$\)/g;
 $line=~s/Art&Frontires/ArtET\$Frontires/g;
 $line=~s/g&\#9484;om&\#9484;triques/gomtriques/g;
 $line=~s/Seine-&-Marne/Seine-ET\$-Marne/g;
 $line=~s/\(& J\.\)/\(ET\$ J\.\)/g;
 $line=~s/XV\-&/XV\-ET\$/g;
 $line=~s/&OACUTE;//g;
 $line=~s/&TABET/ET\$TABET/g;
 $line=~s/B&RD/BET\$RD/g;
 $line=~s/Z&A/ZET\$A/g;
 $line=~s/3\.1& 95/3\.1ET\$ 95/g;
 $line=~s/\)&\(/\)ET\$\(/g;
 $line=~s/ATZ&EXXXXS14/ATZET\$EXXXXS14/g;
 $line=~s/truc&astuce/trucET\$astuce/g;
 $line=~s/b&b/bET\$b/g;
 $line=~s/Zab&Stf/ZabET\$Stf/g;
 $line=~s/\(& logique\)\./\(ET\$ logique\)\./g;
 $line=~s/& Paris/ET\$ Paris/g;
 $line=~s/Ile-&-Vilaine/Ile-ET\$-Vilaine/g;
 $line=~s/Seine-&-Oise/Seine-ET\$-Oise/g;
 $line=~s/& Bernard/ET\$ Bernard/g;
 $line=~s/& Pasveer/ET\$ Pasveer/g;
 $line=~s/& /ET\$ /g;
 $line=~s/& sa /ET\$ sa /g;
 $line=~s/Arts&Frontieres/ArtsET\$Frontieres/g;
 $line=~s/Arts&Frontires/ArtsET\$Frontires/g;
 $line=~s/& FORMATION/ET\$ FORMATION/g;
 $line=~s/& Dominique/ET\$ Dominique/g;
 $line=~s/& de 13h30  17h30/ET\$ de 13h30  17h30/g;
 $line=~s/& the Mechanics/ET\$ the Mechanics/g;
 $line=~s/& Loisirs/ET\$ Loisirs/g;
 $line=~s/Tec&Doc/TecET\$Doc/g;
 $line=~s/& Musiques/ET\$ Musiques/g;
 $line=~s/& Thomas/ET\$ Thomas/g;
 $line=~s/& Musicians/ET\$ Musicians/g;
 $line=~s/& Mandolin/ET\$ Mandolin/g;
 $line=~s/& Community/ET\$ Community/g;
 $line=~s/& Queen/ET\$ Queen/g;
 $line=~s/& National/ET\$ National/g;
 $line=~s/& Music/ET\$ Music/g;
 $line=~s/& O\'Brien/ET\$ O\'Brien/g;
 $line=~s/& Bodhrn/ET\$ Bodhrn/g;
 $line=~s/& Mandola/ET\$ Mandola/g;
 $line=~s/& 2 /ET\$ 2 /g;
 $line=~s/& Mandole/ET\$ Mandole/g;
 $line=~s/& Bodhrn/ET\$ Bodhrn/g;
 $line=~s/& Tommy/ET\$ Tommy/g;
 $line=~s/& Television/ET\$ Television/g;
 $line=~s/Vol\. 1& 2/Vol\. 1ET\$ 2/g;
 $line=~s/& Baroque/ET\$ Baroque/g;
 $line=~s/& KENNEDY/ET\$ KENNEDY/g;
 $line=~s/&Galla/ET\$Galla/g;
 $line=~s/M\.&\.,/M\.ET\$\.,/g;
 $line=~s/&& score /ET\$& score /g;
 $line=~s/\) && \(/\) ET\$ET\$ \(/g;
 $line=~s/& /ET\$ /g;
 $line=~s/Diane&/DianeET\$/g;
 $line=~s/G&G/GET\$G/g;
 $line=~s/Netscape3&4/Netscape3ET\$4/g;
 $line=~s/IE 3&4/IE 3ET\$4/g;
 $line=~s/&M\. Dantec/ET\$M\. Dantec/g;
 $line=~s/&admirer/ET\$admirer/g;
 $line=~s/&endash;/ET\$endash;/g;
 $line=~s/&emdash;/ET\$emdash;/g;
 $line=~s/R&B/RET\$B/g;
 $line=~s/&hellip;/ET\$hellip;/g;
 $line=~s/Restoration&/RestorationET\$/g;
 $line=~s/J&ZZ/JET\$ZZ/g;
 $line=~s/BILL&JIM/BILLET\$JIM/g;
 $line=~s/& SCS/ET\$ SCS/g;
 $line=~s/&EXXX/ET\$EXXX/g;
 $line=~s/& Klaus Janson/ET\$ Klaus Janson/g;
 $line=~s/& Dusty Abel/ET\$ Dusty Abel/g;
 $line=~s/& Comics/ET\$ Comics/g;
 $line=~s/& rac/ET\$ rac/g;
 $line=~s/& Dim/ET\$ Dim/g;
 $line=~s/& Marie/ET\$ Marie/g;
 $line=~s/& pratiquait/ET\$/g;
 $line=~s/& Business/ET\$ Business/g;
 $line=~s/&ecric;//g;
 $line=~s/C&C/CET\$C/g;
 $line=~s/&laqno;/ET\$laqno;/g;
 $line=~s/&Scully/ET\$Scully/g;
 $line=~s/& 2/ET\$ 2/g;
 $line=~s/& Co/ET\$ Co/g;
 $line=~s/& CD-Rom/ET\$ CD-Rom/g;
 $line=~s/\(&i\) ;/\(ET\$i\) ;/g;
 $line=~s/\"&\"/\"ET\$\"/g;
 $line=~s/& \"positiony/ET\$ \"positiony/g;
 $line=~s/& : /ET\$ : /g;
 $line=~s/Guadeloupe &/Guadeloupe ET\$/g;
 $line=~s/&&/ET\$ET\$/g;
 $line=~s/&\"/ET\$\"/g;
 $line=~s/&eaacute;//g;
 $line=~s/&eaacute//g;


 $line=~s/^[ ]+$//;
 $line=~s/^$//;


 return($line);
		  }

sub by_count {

    $seen{$b} <=> $seen{$a}; 

}

sub by_count2 {

    $seen2{$b} <=> $seen2{$a}; 

}

sub by_count3 {

    $elements{$b} <=> $elements{$a}; 

}


#------------ PG PRINCIPAL ------------------

%seen = ();
%elements=();
$CORPUSNAME="$ARGV[0]";
$siteNameForFile="$ARGV[1]";

$i=0;
open(TRACEF,">StatWordFull\(".$siteNameForFile."\).txt");
open(TRACEf,">StatWordByFile\(".$siteNameForFile."\).txt");
open(INDEXFILE,">indexFile\(".$siteNameForFile."\).txt");
open(CORPBRUT,">corp-XML2TxtBrut\(".$siteNameForFile."\).txt");

$print_subform =
'@<<<<<<<<<<<<<<<<<<<<<<<<      @>>>>>>>>>>>>';

$print_subform2 =
'   @<<<<<<<<<<<<<<<<<<<<<<<<   @>>>>>>>>>>>>>>>>>>>>>>>>>>';

while($line = <>) { 
    if ($line =~ /<SITEName>([^<]+)<\/SITEName>/) 
    { 
	$j=1;
	$tmp=$1;
	if ($tmp=~/\/([^\/]+)$/) {$tmp= $1};
	$tmp=~s/\./\$/g;
	$tmp=~s/\(/\$/g;
	$tmp=~s/\)/\$/g;
	$tmp=~s/\-/\$/g;
	$i++;
	print CORPBRUT "<SiteName=site_$i>\n";
	formline($print_subform2, "", "");
	print INDEXFILE $ACCUMULATOR, "\n";
	$ACCUMULATOR = '';
	formline($print_subform2, "site_$i", $tmp);
	print INDEXFILE $ACCUMULATOR, "\n";
	$ACCUMULATOR = '';
	formline($print_subform2, "----------------", "(filename)");
	print INDEXFILE $ACCUMULATOR, "\n";
	$ACCUMULATOR = '';
	$sitename=$tmp;
	$sitenb=$i;
	$line = <>;
	until ($line =~ /<\/SITE>/) 
	{ 
	    if ($line =~ /<SITEFile>/i) 
	    { 
		$line = <>;
		if ($line =~ /<SITEFileName>([^<]+)<\/SITEFileName>/i) 
		{
		    $filename=$1;
		}
		$line = <>;
		if ($line =~ /<SITEReportFileName>([^<]+)<\/SITEReportFileName>/i) {
		    $tmpline=$1;
		    $tmpline=~/res1\([^\)]+\).*rep[0-9]+\(([^\)]+)\)/;
		    print CORPBRUT "<file=site_$i\$file_$j>\n";
		    formline($print_subform2, "site_$sitenb\$file_$j", $1);
		    $identFile = "site_$sitenb"."\$file_$j";
		    print INDEXFILE $ACCUMULATOR, "\n";
		    $ACCUMULATOR = '';
		    $j++;
#		    $filename=$1;
		}

		until ($line =~/<\/SITEFile>/){
		    if ($line =~ /<SITEFileElements>/i) 
		    {
			print TRACEf "<TAGS>\n"; 
			print TRACEf "<SITE>$sitename</SITE>\n<PAGE>$identFile</PAGE>\n"; 
			print TRACEf "<ELEMENTS>\n"; 
#			print TRACEf "\n----------\nStat Element for file : $sitename:$filename\n\n"; 
			$line=<>;
			until ($line =~/<\/SITEFileElements>/){
			    $line=~/<SiteFileElementDesc type=\"([^\"]+)\">([^<]+)<\/SiteFileElementDesc>/;
			    $ind1=$1;
			    $ind1=~s/ //g;
			    $ind2=$2;
			    $ind2=~s/ //g;
			    formline($print_subform, $ind1, $ind2);
			    if ($ind1 ne "") {print TRACEf $ACCUMULATOR, "\n";};
			    $ACCUMULATOR = '';
			    if ($ind1 ne "") {$elements{uc($ind1)}+=$ind2};
			    $line=<>;
			}
		    }
		    if ($line =~ /<SITEFileImageNb>([^<]+)</i) 
		    {
#			print TRACEf "\n-----\nStat Img for file : $sitename:$filename\n\n"; 
			    $ind2=$1;
			    $ind2=~s/ //g;
			    formline($print_subform,"ImgNb\(1\)", $ind2);
			    print TRACEf $ACCUMULATOR, "\n";
			    $ACCUMULATOR = '';
			$elements{"ImgNb\(1\)"}+=$ind2;
		    }
		    if ($line =~ /<SITEFileImageDesc>([^<]+)<EXTImage>([^<]+)<\/EXTImage><INTImage>([^<]+)<\/INTImage><\/SITEFileImageDesc>/i) 
		    {
			    $ind1=$1;
			    $ind1=~s/ //g;
			    $ind2=$2;
			    $ind2=~s/ //g;
			    $ind3=$3;
			    $ind3=~s/ //g;

			$elements{"ImgNb\(2\)"}+=$ind1;
			$elements{"ImgInterneNb"}+=$ind3;
			$elements{"ImgExterneNb"}+=$ind2;
			formline($print_subform,"ImgNb\(2\)", $ind1);
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			formline($print_subform,"ImgInterneNb", $ind3);
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			formline($print_subform,"ImgExterneNb", $ind2);
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
		    }
		    
		    if ($line =~ /<SITEFileLinks>/i) 
		    {
#			print TRACEf "\n-----\nStat Links for file : $sitename:$filename\n\n"; 
			$line=<>;
			until ($line =~/<\/SITEFileLinks>/){
			    $line=~/<SITEFile([^>]+)>([^>]+)</;
			    $ind1=$1;
			    $ind1=~s/ //g;
			    $ind2=$2;
			    $ind2=~s/ //g;

			    formline($print_subform,$ind1, $ind2);
			    print TRACEf $ACCUMULATOR, "\n";
			    $ACCUMULATOR = '';
			    if ($ind1 ne "") {$elements{$ind1}+=$ind2};
			    $line=<>;
			}
		    }
		    if ($line =~ /<SITEFileTxtBrut>/i) { 
			print TRACEf "</ELEMENTS>\n"; 
		        print TRACEf "<ELEMENTS_ATTR>\n"; 
		        print TRACEf "</ELEMENTS_ATTR>\n"; 
			print TRACEf "</TAGS>\n"; 
			%seen2 = ();
			$line = <>;
			until ($line =~/<\/SITEFileTxtBrut>/){
			    $line = lineCleaner($line);
			    $_=$line;
			    while ( /(\w[\w-]*)/g ) {
                                                             $seen{lc $1}++;
							     $seen2{lc $1}++;
							}
							if ($line !~ /^[ ]*$/) {print CORPBRUT "$line";}
							$line=<>;
						    }
			print TRACEf "<WORDS>\n"; 
			print TRACEf "<SITE>$sitename</SITE>\n<PAGE>$identFile</PAGE>\n"; 
#			print TRACEf "\n----------\nStat Word for file : $sitename:$filename\n\n";
			formline($print_subform,"WORD", "Freq");
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			formline($print_subform,"----", "----");
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			$tmpc=0;
			$tmpd=0;

			foreach $word (sort by_count2 keys %seen2) {
			    $tmpc++;
			    $tmpd+=$seen2{$word};
			    formline($print_subform,$word, $seen2{$word});
			    print TRACEf $ACCUMULATOR, "\n";
			    $ACCUMULATOR = '';
			}
			formline($print_subform,"-----", "-----");
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			formline($print_subform,"TOTAL", "TOTAL");
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			formline($print_subform,"WORD", "OCCURR");
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			formline($print_subform,$tmpc, $tmpd);
			print TRACEf $ACCUMULATOR, "\n";
			$ACCUMULATOR = '';
			print TRACEf "</WORDS>\n"; 
			
		    }
		    
		    $line = <>;
					    }
		
	    }
	    
	    $line = <>; 
	    
	}
    }
}

print TRACEF "\n-----\nStatWord & element on $CORPUSNAME\n"; 
print TRACEF "\n----------\nStatElement\n\n"; 
formline($print_subform,"Elt.", "Freq");
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';
formline($print_subform,"----", "----");
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';

foreach $element (sort by_count3 keys %elements) {
    formline($print_subform,$element, $elements{$element});
    print TRACEF $ACCUMULATOR, "\n";
    $ACCUMULATOR = '';    
    
}
print TRACEF "\n----------\nStat word\n\n"; 

formline($print_subform,"WORD", "Freq.");
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';
formline($print_subform,"----", "----");
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';
                                                    
$tmpc=0;
$tmpd=0;

foreach $word (sort by_count keys %seen) {
    formline($print_subform,$word, $seen{$word});
    print TRACEF $ACCUMULATOR, "\n";
    $ACCUMULATOR = '';    
    $tmpc++;
    $tmpd+=$seen{$word};
}

formline($print_subform,"-----", "-----");
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';
formline($print_subform,"TOTAL", "TOTAL");
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';
formline($print_subform,"WORD", "OCCURR");
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';
formline($print_subform,$tmpc, $tmpd);
print TRACEF $ACCUMULATOR, "\n";
$ACCUMULATOR = '';

close(TRACEf);
close(TRACEF);
close(INDEXFILE);
close(CORPBRUT);
