#/usr/local/bin

=head1 NAME

B<mkCorpus> - Outils d'dition et de manipulation de corpus baliss (SGML, XML, HTML)
pour leurs prparations aux outils du TAL tels Lexico,
Alceste, Cordial.


=head1 SYNOPSIS

mkCorpus-win32.pl

=cut

my $Usage;
{
	my($prog) = ($0 =~ m#([^/]+)$#);
	my $space = " " x length $prog;
	($Usage = <<EOF) =~ s/^\t\t//gm;
		Usage: $prog 

		Use ``perldoc $prog'' for more information.
EOF
}

=head1 DESCRIPTION

voir le fichier Doc/mkcorpusdoc.PDF


=head1 AUTHOR

Fleury Serge
ILPGA / Sorbonne nouvelle - Paris 3
19 rue des Bernardins 75005 Paris
Tl. : (33/0)1.44.32.05.84
Fax : (33/0)1.44.32.05.73
Email: fleury\@msh-paris.fr ou serge.fleury\@univ-paris3.fr
Hypertoile TAL-Paris 3 ILPGA : http://www.cavi.univ-paris3.fr/ilpga/ilpga/tal/
Hypertoile SFWeb : http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/


=cut

use Getopt::Long;
use English;
use File::Basename;
use File::Find;
use Cwd;
#use strict; 
use Getopt::Std;
use Text::Wrap; 

use Tk;
use Tk::Text;
use Tk::Balloon;
use Tk::ObjScanner;
use Tk::DirTree;
use Tk::WaitBox;
use Tk::ProgressBar;
use Tk::TextUndo;
use Tk::Date;
use Tk::XMLViewer;
use Tk::Animation;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::Toplevel;
use Tk::FileSelect;

use XML::Parser;
use XML::Parser::Grove;
use XML::Grove;
use XML::Grove::Visitor;
use XML::Grove::Iter;
use XML::XPath;
use XML::DOM;
use XML::EasyOBJ;

#use Net::FTP;

use LWP::UserAgent;
use HTML::Parser;
#use HTML::FormatText;
#use HTML::FormatPS;
use LWP::Simple;
use HTML::LinkExtor;
use URI::URL;

use mkCorpusModules::SubHandlers;
use mkCorpusModules::EliInfo;
use mkCorpusModules::MyVisitor;
use mkCorpusModules::DirSelect;

#use DTD_Parse;

<<DOC; 
S. Fleury
07/01/01

               mkCorpus-win32.pl :

Documentation gnrale sur : 
http://www.cvi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusproject.html
et aussi dans le document : mkcorpusdoc.PDF et mkcorpusdoc.doc

Format d'entre : 
mkCorpus-win32.pl

Format de sortie :

A faire :
--------

Bugs et problmes :
plusieurs variables locales ne sont pas bien gerees : 


DOC
#---------------------------------------------------------------------------------------
#Variables globales pour toutes les actions gnres par le programme
#---------------------------------------------------------------------------------------
$mw= MainWindow->new;
$mw->title("mkCorpus Tools (Tal Paris 3 - CLA2T) v.2001-05");
$mw->withdraw;

#------------------
my $splash = $mw->Toplevel(-title => "mkCorpus is coming soon..." , -visual => 'truecolor');
## Make the application exit if the splash window is closed...
$splash->protocol( 'WM_DELETE_WINDOW' => sub {exit} ) ;

my $img = $splash->Photo(-file=> 'Pics/Logo.xpm');
$splash->Label( -image => $img)->pack;
## Progress bar on splash screen...
my $pctComplete = 0;
my $progress = $splash->ProgressBar(-variable => \$pctComplete,
   -borderwidth => 7, -relief => 'flat', -width => 20, -length => 300,
	-padx => 0, -pady => 0,-gap => 0,
	-from => 0, -to => 100,
   -colors => [0 => 'green', 50 => 'yellow' , 80 => 'red'],
   -troughcolor => 'white',
)->pack;
my $progressText = "";
$splash->Label( -textvariable => \$progressText )->pack;


#------
#scalaires
$mkCorpusPath = &GetCWD;
$start_dir = &GetCWD;
$new_num_doc=0;
$nom_fic="Nouveau".$new_num_doc.".txt";
$max_num_doc=10;
$num_doc=0;
$winNb=0;
$winBalloon;
$info;
$saisie; 
$saisie2; 
$saisie3;
$search_string;
$replace_string; 
$cpt_file_balises;
$texte ;
$b_menu;
$mkTextXpath;
$levelxmlConverter1 ;
$indxmlConverter1 ;
$headxmlConverter1;
$levelxmlConverter2; 
$indxmlConverter2 ;
$headxmlConverter2;
$levelxmlConverter3; 
$indxmlConverter3 ;
$headxmlConverter3;
$resultEventXML ;
$resultEventXML1 ;
$resultEventXML2 ;
$resultEventXML3;
$levelEventXML ;
$levelEventXML1 ;
$levelEventXML2 ;
$levelEventXML3;
$mainXmlviewer2 ;
$listePn2SelectionMarkup ;
$listePn2SelectionMarkup2 ;
$search_string_map;
$listePn2 ;
$listePn2Map;
$position_search;
$waitBoxWidget;
#------------------
#Tableaux
@courant=();
%Courant=();
@liste_xmlBalise = ();
%Liste_xmlBalise = ();
@liste_xmlLexicoBalise =();
%Liste_xmlLexicoBalise=();
@liste_xmlLexicoBalise2 = ();
%Liste_xmlLexicoBalise2 = ();
%listeBaliseXmlLexico =();
%compteurBaliseXmlLexico=();
%compteurBaliseXml=() ;
%listeBaliseXml=();
%mapTextFull=() ;
@mapText=();
#---------------------------------------------------------------------------------------
#Variable pas utilise correctement
$cpt_file_balises=0;
#---------------------------------------------------------------------------------------
#Image Boutons
$imageSelectFile = $mw->Photo(-file => "icons/file_open.xpm");
$logoMKC = $mw->Photo(-file => "Pics/Logo.xpm");
$imageSearch = $mw->Photo(-file => "icons/search.xpm");
$imageLoad = $mw->Photo(-file => "icons/Open.xpm");
$imageExit = $mw->Photo(-file => "icons/small.exit.xpm");
$imageHelp = $mw->Photo(-file => "icons/small.help_3d.xpm");
$imageSave = $mw->Photo(-file => "icons/filesave.xpm");
$imageScan = $mw->Photo(-file => "icons/scan.xpm");
$imageSelect=$mw->Photo(-file => "icons/small.select_3d.xpm");
$imageText=$mw->Photo(-file => "icons/filenew.xpm");
$imageReplace=$mw->Photo(-file => "icons/small.icon_copy_3d.xpm");
$imageDelete=$mw->Photo(-file => "icons/cut.xpm");
$imageClearSearch=$mw->Photo(-file => "icons/small.no_entry_3d.xpm");
$imageNoHighlight=$mw->Photo(-file => "icons/refresh.xpm");

#---------------------------------------------------------------------------------------
#Lexical item
$Conjonctions  = "&|autant|comme|donc|dont|et|jusqu|lorsque|mais|ni|ou|o|par|parce|puis|puisque|qu|qu\'|quand|quant|que|qui|si|soit|tandis" ;
$Pronoms       = "c\'|ce|ceci|cela|celles|celui|ceux|elle|elles|il|ils|j|j\'|je|l\'|leur|lui|me|nous|on|s|s\'|se|te|tu|vous|y" ;
$Verbes        = "a|accompagnant|accompagn|adress|agit|ai|aller|apparait|apparue|appartiennent|applique|apportant|apporte|apporter|apprcier|associant|atteignant|atteindre|atteint|aura|aurait|avais|avait|avez|avoir|avons|avre|ayant|bnfici|comporte|comportent|concernant|confirme|conservent|considr|contrler|correspond|correspondant|correspondre|cdant|demande|devait|devrait|distinguer|dilater|dit|doit|doivent|donne|donn|dbordant|dbute|dcide|dclar|dclenche|dcrit|dpendant|dpister|d|envisager|es|espre|est|estime|eu|existe|explique|faire|fait|fut|inscrit|jouer|juger|justifiant|justifient|limiter|maintenir|mettait|mettre|mis|modifier|montre|montr|motivant|motivera|naissant|obtenir|ont|parait|permet|permettant|permettent|persiste|perturb|peut|peuvent|pourrait|poursuivre|prenant|prend|procder|proposer|provoque|prciser|prdisposant|prdispos|prsentant|prsente|prsent|prvoir|pu|quitte|quitter|quitt|rappelons|refaire|regagne|regagner|rendre|renvoient|repose|ressent|retrouve|raliser|rsultant|rvl|semble|sera|sert|servant|servent|servir|soit|sont|suis|supposer|survenant|survenue|surviennent|traite|transfr|va|vaut|venir|veut|veux|vient|voir|vu|taient|tait|tant|t|tre" ;
# Verbes problmatiques : fait|
$Adverbes      = "actuellement|ainsi|alors|angiographiquement|assez|aujourd\'|aussi|autrement|avant|beaucoup|bien|brivement|ci|cliniquement|comment|contrairement|discrtement|dj|encore|environ|extrmement|facilement|franchement|globalement|hautement|heureusement|hui|ici|imparfaitement|infra|lors|l|maintenant|mieux|modrment|moins|moyennement|n|n\'|ne|nettement|non|ores|parfaitement|partiellement|pas|peu|plus|plutt|pratiquement|probablement|prcocement|prcocment|rapidement|relativement|rellement|souvent|strictement|supra|tard|toujours|trop|trs|vraisemblablement|a|galement|lectriquement" ;
$Prepositions  = "aprs|au|auprs|autour|aux|avant|avec|chez|contre|d|d\'|dans|de|depuis|des|devant|du|ds|en|entre|hors|jusqu\'|malgr|par|parmi|pendant|pour|prs|sans|selon|sous|sur|vers||" ;
$Determinants  = "aucun|aucune|auquel|autre|autres|ce|celle|celles|cent|cents|certain|certaine|certaines|certains|ces|cet|cette|chaque|cinq|cinquante|de|des|deux|dix|douze|du|huit|l|la|laquelle|le|les|leurs|ma|mille|mon|mme|mmes|neuf|nos|notre|onze|plusieurs|quarante|quatorze|quatre|quelque|quelques|quinze|sa|seize|sept|ses|six|soixante|son|tel|telle|telles|tels|ton|tous|tout|toute|toutes|treize|trente|trois|un|une|vingt|vos|votre" ;
$MotsProblemes = "er|[0-9]|[+*=]|chapitre|lundi|mardi|mercredi|jeudi|vendredi|samedi|dimanche|janvier|fvrier|mars|avril|mai|juin|juillet|aot|septembre|octobre|novembre|dcembre|%|M\.|MM\.|[0-9]{1,3}" ;

$NomsPropres   = "Marie|Luc" ;
$Ponctuations   = "[?,.;:!\"()_\\-]" ;

$MotsAEnlever = "(" . $Conjonctions . "|" . $Pronoms . "|" . $Verbes  . "|" . $Adverbes . "|" . $Prepositions . "|" . $Determinants . "|" . $MotsProblemes . "|" . $NomsPropres . ")" ;

#---------------------------------------------------------------------------------------
$winBalloon = $mw->Balloon(
      -initwait => 400,
      -state    => 'balloon'
   );

#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit...", 5 );
sleep 2;

#---------------------------------------------------------------------------------------
$texte= $mw->Scrolled("TextUndo")->pack(-side => 'bottom',
			      -fill => 'both',
	    		      -expand => 1);
$texte->Text(-setgrid => 'true');

$mw->protocol('WM_DELETE_WINDOW'=>  sub{ConfirmExit2($texte);});
# my $scanner = $mw->ObjScanner( caller => $texte, title=>"windows") -> pack ;

#---------------------------------------------------------------------------------------
$cadreTop = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');

my $date = $cadreTop->Date(-editable => 0,
		     -variable => \$time,
		     -value => 'now',
		    )->pack(-side => 'left');

$date->repeat(999, sub { $time = time(); });

my $running;
my $camel=$mw->Animation('-format' => 'gif',
			   -file => Tk->findINC('anim.gif'));
my $l = $cadreTop->Label(-image => $camel)->pack(-side => 'right');
$cadreTop->Button(-text => 'Start/Stop',
	     -command => sub {
		 if (!$running) {
		     $camel->start_animation(80);
		 } else {
		     $camel->stop_animation();
		 }
		 $running = !$running;
	     })->pack(-side => 'right');

#---------------------------------------------------------------------------------------
$cadre = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
#---------------------------------------------------------------------------------------
$b_menu=$cadre->Menubutton(-text => "File",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "~View dir",
					  -command => \&open_dir],
                                          ['command' => "~View AND Select dir",
					  -command => \&viewAndSelectDir],
					  ['command' => "~Select File & open",
					  -command => \&query_file_dialog],
					  ['command' => "~Select File & not open",
					  -command => \&query_file_dialog3],
					  ['command' => "Open this file",
					  -command => \&lire_fic],
				          ['command' => "~Save this file",
					  -command => \&sauve_fic],
				          ['command' => "~Save this file as",
					  -command => \&query_file_dialog2],
					  ['command' =>"~Clear", 
					  -command => sub{ConfirmEmptyDocument2($texte);}],
				          ['command' => "Exit",
					   -command =>    sub{ConfirmExit2($texte);}
					  ]])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
$c0_menu=$cadre->Menubutton(-text => "Edit",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems =>
			   [
    ["command"=>'Undo', -command => [$texte => 'undo']],
    ["command"=>'Redo', -command => [$texte => 'redo']],
     "-",@{$texte->EditMenuItems}
  ])->pack(-side => 'left');

#---------------------------------------------------------------------------------------
$c_menu=$cadre->Menubutton(-text => "Search",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "I-Search",
					-command => \&i_search],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2],
				       ['command' => "Global Search",
					-command => \&search_in_fic],
				       ['command' => "I-Replace",
					-command => \&i_replace],
				       ['command' => "Repeat I-Replace",
					-command => \&i_replace2],
				       ['command' => "Global Replace",
					-command => \&replace]])->pack(-side => 'left');

$mw->bind(Tk::Text,"<Button-3>",sub{ $c_menu->Popup(-popover => 'cursor',
						    _popanchor => "nw")});

#---------------------------------------------------------------------------------------
$d0_menu=$cadre->Menubutton(-text => "Markup <[^>]+>",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "View all",
					-command => \&list_balise],
				       ['command' => "Delete all",
					-command => \&del_balise],
				       ['command' => "Search all",
					-command => \&search_balise],
				       ['command' => "I-Search",
					-command => \&i_search],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2],
				       ['command' => "Extract Text in Markups",
					-command => \&query_search_text_in_balise]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
$d1_menu=$cadre->Menubutton(-text => "Tools HTML",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "Html2Text (special)",
					-command => \&html0],
					  ['command' => "Html2Text",
					-command => \&html1],
				       ['command' => "Html2PostScript",
					-command => \&html2]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
$d2_menu=$cadre->Menubutton(-text => "Tools XML",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
				       ['command' => "XML as Tree (1)",
					-command => \&eventXML],
                                       ['command' => "XML as Tree (2)",
					-command => \&eventXML2],
                                       ['command' => "XML Viewver (1)",
					-command => \&xmlViewver],
                                       ['command' => "XML Viewver (2)",
					-command => \&xmlViewver_2],
				       ['command' => "Parse File",
					-command => \&parseXML],
				       ['command' => "Select Markup",
					-command => \&xmlMkListBalise],
				       ['command' => "XML Comment",
					-command => \&xmlComment],
				       ['command' => "XML Stat",
					-command => \&xmlStat],
				       ['command' => "PrintElt As Text",
					-command => \&printEltAsText],
				       ['command' => "Parse DTD",
					-command => \&parseDTD],
				       ['command' => "REX/XML",
					-command => \&xmlRex],
				       ['command' => "xmlGrove 1",
					-command => \&xmlGroveTool1],
				       ['command' => "xmlGrove 2",
					-command => \&xmlGroveTool2],
				       ['command' => "Xpath",
					-command => \&xmlXpath],
				       ['command' => "Xpath 2",
					-command => \&xmlXpath2]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
$d3_menu=$cadre->Menubutton(-text => "Tools SGML",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "item 1",
					-command => \&sgml1],
				       ['command' => "item2",
					-command => \&sgml2]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit...", 25 );
sleep 2;
#---------------------------------------------------------------------------------------
$d4_menu=$cadre->Menubutton(-text => "Tools Converters",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "XML2html",
					-command => \&xmlConverter1],
                                       ['command' => "XML2pod",
					-command => \&xmlConverter2],
                                        ['command' => "XML2txt",
					-command => \&xmlConverter3],
                                        ['command' => "rtf2html",
					-command => \&rtf2html],
				       ['command' => "rtf2xml",
					-command => \&rtf2xml],
				       ['command' => "ps2html",
					-command => \&ps2html],
				       ['command' => "txt2html",
					-command => \&txt2html],
				       ['command' => "perl2html",
					-command => \&perl2html]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
$e_menu=$cadre->Menubutton(-text => "Corpus Tools",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ["cascade" => "StatTools"],
					  ["cascade" => "CheckChar"],
					  ["cascade" => "PrepHTML2Txt"],
					  ["cascade" => "MapXMLCorpus"],
					  ["cascade" => "Lexico"],
				          ["cascade" => "Alceste"],
				          ["cascade" => "Cordial"]]
			   )->pack(-side => 'left');
$statCorpus=$e_menu->menu->Menu(-menuitems => [
                                           ['command' => "Stat File",
					    -command => \&statFile]
                                            ]);
$checkchar=$e_menu->menu->Menu(-menuitems => [
                                           ['command' => "Read Char",
					    -command => \&readCharInText],
				           ['command' => "Change Char",
					    -command => \&changeCharInText],
				           ['command' => "Change Ascii",
					    -command => \&changeAsciiInText],
				           ['command' => "Change UnrocognizedChar",
					    -command => \&changeUnrocognizedCharInText],
                                            ['command' => "Apply Change in TableCharacter (No Log)",
					    -command => \&applyChangeInTableCharacter1],
				           ['command' => "Apply Change in TableCharacter (Log)",
					    -command => \&applyChangeInTableCharacter2]
                                            ]);
$prepHtml=$e_menu->menu->Menu(-menuitems => [['command' => "Read One Dir",
					    -command => \&query_dir_prepOneDir],
				           ['command' => "Read One File",
					    -command => \&mkPrepHtml2txtOneFile]
                                            ]);
$corpusview=$e_menu->menu->Menu(-menuitems => [['command' => "Make TAG-Map",
					    -command => \&makeTextToMap],
				           ['command' => "Make TAG2-Map",
					    -command => \&maketagmap]]);
$lexico=$e_menu->menu->Menu(-menuitems => [['command' => "Extract Selected Markup For Lexico-Corpus (1)",
					    -command => \&lexico1],
                                           ['command' => "Extract Selected Markup For Lexico-Corpus (2)",
					    -command => \&lexico2],
				           ['command' => "Extract Selected Markup For Lexico-Corpus (3)",
					    -command => \&lexico3],
				           ['command' => "HELP Maj->Min",
					    -command => \&help_lexico4],
				           ['command' => "Change Maj->Min",
					    -command => \&lexico4],
				           ['command' => "HELP Specif-Sort",
					    -command => \&help_lexico5],
				           ['command' => "Specif-Sort",
					    -command => \&lexico5],
				           ['command' => "HELP DSR-Sort",
					    -command => \&help_lexico6],
				           ['command' => "DSR-Sort",
					    -command => \&lexico6]
                                           ]);
$alceste=$e_menu->menu->Menu(-menuitems => [['command' => "Make Corpus",
					    -command => \&alceste1],
				           ['command' => "Verify Corpus",
					    -command => \&alceste2]]);
$cordial=$e_menu->menu->Menu(-menuitems => [['command' => "help Cordial2MkCorpus",
					    -command => \&help_cordial],
					    ['command' => "Make Corpus-Tag",
					    -command => \&cordial],
					    ['command' => "Make Corpus-Tag For Lexico v.1",
					    -command => \&cordial2Lexico],
					    ['command' => "Make Corpus-Tag For Lexico v.2",
					    -command => \&cordial2Lexico2]
					    ]);
$e_menu->entryconfigure("StatTools",-menu =>$statCorpus);
$e_menu->entryconfigure("CheckChar",-menu =>$checkchar);
$e_menu->entryconfigure("PrepHTML2Txt",-menu =>$prepHtml);
$e_menu->entryconfigure("MapXMLCorpus",-menu =>$corpusview);
$e_menu->entryconfigure("Lexico",-menu =>$lexico);
$e_menu->entryconfigure("Alceste",-menu =>$alceste);
$e_menu->entryconfigure("Cordial",-menu =>$cordial);

#---------------------------------------------------------------------------------------
$g_menu=$cadre->Menubutton(-text => "NLP Tools",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ['command' => "xWords (Dict)",
					-command => \&mkXWord],
					  ['command' => "Concordance (one word) 1",
					-command => \&mkConcordanceOneWord],
					  ['command' => "Concordance (one word) 2",
					-command => \&mkConcordanceOneWord2],
					  ['command' => "Concordance (one string)",
					-command => \&mkConcordanceOneWord3],
					  ['command' => "Concordance (all word) 1",
					-command => \&mkConcordance],
					  ['command' => "Concordance (all word) 2",
					-command => \&concordanceFormat],
					  ['command' => "Word Position",
					-command => \&wordPosition],
					  ['command' => "Bigram (word)",
					-command => \&mkBigramWord],
					  ['command' => "FourGram (word)",
					-command => \&mkFourgramWord],
					  ['command' => "Collocate",
					-command => \&mkCollocate],
					  ['command' => "WordCount",
					-command => \&mkWordCount],
                                          ['command' => "help Bigram Char",
					-command => \&help_bigramChar],
					  ['command' => "Make-index (1)",
					-command => \&makeIndex],
					  ['command' => "Mots2BigramUniques (2)",
					-command => \&mots2BigramUniques],
					  ['command' => "BigrammesUniques2Distance (3)",
					-command => \&bigrammesUniques2Distance],
                                          ['command' => "mots2Distance (unix)",
					-command => \&mots2Distance]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
$f_menu=$cadre->Menubutton(-text => "Typweb",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [["cascade" => "DownloadSite"],
					  ["cascade" => "WebXref036"],
				          ["cascade" => "MkCorpusXML036"],
				          ["cascade" => "StatOnCorpXML036"],
				          ["cascade" => "ParseRegExp"],
				          ["cascade" => "ParseXML"],
					  ["cascade" => "WebXref038"],
					  ["cascade" => "WebXref038-homolWin32"],
					  ["cascade" => "WebXref038-homolUnix"],

					  ])->pack(-side => 'left');

$mirroringSite=$f_menu->menu->Menu(-menuitems => [
						  ['command' => "Page Mirror",
						   -command => \&query_loadPageMirroring],
						  ['command' => "Site Mirror",
						   -command => \&query_loadMirroring],
						  ['command' => "Wget",
						   -command => \&query_wget],
						  ['command' => "Site UpLoad",
						   -command => \&query_uploading]
						  ]);

$webxref=$f_menu->menu->Menu(-menuitems => [['command' => "Read Local Web Dir",
					    -command => \&webxref1],
				           ['command' => "Read Index File",
					    -command => \&webxref2]
					    ]);
$webxref2=$f_menu->menu->Menu(-menuitems => [['command' => "Read Local Web Dir",
					    -command => \&webxref11],
				           ['command' => "Read Index File",
					    -command => \&webxref22]
					    ]);
$webxref3=$f_menu->menu->Menu(-menuitems => [['command' => "Read Local Web Dir",
					    -command => \&webxref111],
				           ['command' => "Read Index File",
					    -command => \&webxref222]
					    ]);
$webxref4=$f_menu->menu->Menu(-menuitems => [['command' => "Read Local Web Dir",
					    -command => \&webxref1111],
				           ['command' => "Read Index File",
					    -command => \&webxref2222]
					    ]);
$mktipo=$f_menu->menu->Menu(-menuitems => [['command' => "Read WebXref Results Site",
					    -command => \&mktipo1]]);
$statonmktipo=$f_menu->menu->Menu(-menuitems => [['command' => "Make stat",
					    -command => \&makestat1]]);
$typwebParseRegExp=$f_menu->menu->Menu(-menuitems => [['command' => "Tag HTML (036)",
					    -command => \&typwebExtractTagHTML],
						   ['command' => "Select Markup",
					    -command => \&mkSelectionMarkup]]);

$typwebParseXML=$f_menu->menu->Menu(-menuitems => [['command' => "Extract TxtBrut",
					    -command => \&typwebExtractTxtBrut],
						   ['command' => "Select Markup",
					    -command => \&typwebMkListBalise]]);

$f_menu->entryconfigure("DownloadSite",-menu =>$mirroringSite);
$f_menu->entryconfigure("WebXref036",-menu =>$webxref);
$f_menu->entryconfigure("WebXref038",-menu =>$webxref2);
$f_menu->entryconfigure("WebXref038-homolWin32",-menu =>$webxref3);
$f_menu->entryconfigure("WebXref038-homolUnix",-menu =>$webxref4);
$f_menu->entryconfigure("WebXref038",-menu =>$webxref2);
$f_menu->entryconfigure("MkCorpusXML036",-menu =>$mktipo);
$f_menu->entryconfigure("StatOnCorpXML036",-menu =>$statonmktipo);
$f_menu->entryconfigure("ParseRegExp",-menu =>$typwebParseRegExp);
$f_menu->entryconfigure("ParseXML",-menu =>$typwebParseXML);
#---------------------------------------------------------------------------------------
splashProgress( "Initialising third bit (dum-de-dum)...", 80 );
sleep 2;
#---------------------------------------------------------------------------------------

$cadre1 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');

$search_string = '';

$w_string = $cadre1->Frame()->pack(-side => 'top', -fill => 'x');

$buttonOpen=$w_string->Button(-text => "Select File",
                -image => $imageSelectFile,
	     -command => sub {&query_file_dialog})->pack(-side => 'left',
						   -anchor => 'e');

$winBalloon->attach($buttonOpen,
                  -balloonmsg => "Select File"
               );

$w_string_button1 = $w_string->Button(-text => 'No Highlight', -image => $imageNoHighlight);
$winBalloon->attach($w_string_button1,
                  -balloonmsg => "Stop HighLight"
               );
$w_string_button1->pack(-side => 'left', -pady => 5, -padx => 10);

$w_string_label = $w_string->Label(-text => 'Search string:', -width => 13, -anchor => 'w');
$saisie2= $w_string_entry = $w_string->Entry(-textvariable => \$search_string);
$w_string_label2 = $w_string->Label(-text => 'Delete string:', -width => 13, -anchor => 'w');
$w_string_entry2 = $w_string->Entry( -textvariable => \$search_string);
$w_string_button = $w_string->Button(-text => 'Highlight', -image => $imageSearch);
$winBalloon->attach($w_string_button,
                  -balloonmsg => "Search and Highlight"
               );

$w_string_button2 = $w_string->Button(-text => 'Delete', -image => $imageDelete);
$winBalloon->attach($w_string_button2,
                  -balloonmsg => "Delete"
               );
$w_string_button3 = $w_string->Button(-text => 'ClearSearch', -image => $imageClearSearch);
$winBalloon->attach($w_string_button3,
                  -balloonmsg => "Clear Search"
               );
$w_string_label->pack(-side => 'left');
$w_string_entry->pack(-side => 'left');
$w_string_label2->pack(-side => 'left');
$w_string_entry2->pack(-side => 'left');
$w_string_button->pack(-side => 'left', -pady => 5, -padx => 10);


$w_string_button2->pack(-side => 'left', -pady => 5, -padx => 10);
$w_string_button3->pack(-side => 'left', -pady => 5, -padx => 10);
$w_string->pack(-side => 'top', -fill => 'x');
$w_string_button->configure(-command => [sub {&text_search($texte, $search_string, 'search')}, $texte]);
$w_string_button1->configure(-command => [sub {&remove_mark_search}]);
$w_string_button2->configure(-command => [sub {&text_delete($texte, $search_string, 'search')}, $texte]);
$w_string_button3->configure(-command => [sub {&remove_search}]);
$w_string_entry->bind('<Return>' => [sub {shift; &text_search($texte, $search_string, 'search')}, $texte]);
$w_string_entry2->bind('<Return>' => [sub {shift; &text_delete($texte, $search_string, 'search')}, $texte]);
$w_string->pack(-side => 'top', -fill => 'x');
if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

$saisie2->delete(0,'end');
#---------------------------------------------------------------------------------------
splashProgress( "Oops, more to do than expected...", 60 );
sleep 2;

#---------------------------------------------------------------------------------------
$cadre11 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
$w_string2 = $cadre11->Frame()->pack(-side => 'top', -fill => 'x');
$w_string2_label = $w_string2->Label(-text => 'Replace with string:', -width => 20, -anchor => 'w');
$saisie3= $w_string2_entry = $w_string2->Entry(-textvariable => \$replace_string);
$w_string2_button = $w_string2->Button(-text => 'Replace', -image => $imageReplace);
$winBalloon->attach($w_string2_button,
                  -balloonmsg => "Replace String"
               );
$w_string2_label->pack(-side => 'left');
$w_string2_entry->pack(-side => 'left');
$w_string2_button->pack(-side => 'left', -pady => 5, -padx => 10);
#$w_string2->pack(-side => 'top', -fill => 'x');
$w_string2_button->configure(-command => [sub {&text_replace($texte, $search_string, $replace_string, 'search')}, $texte]);
$w_string2_entry->bind('<Return>' => [sub {shift; &text_replace($texte, $search_string, $replace_string, 'search')}, $texte]);
$w_string2->pack(-side => 'top', -fill => 'x');
$saisie3->delete(0,'end');
#---------------------------------------------------------------------------------------
$cadre2 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
$cadre2->Label(-text => "File : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
$saisie=$cadre2->Entry(-textvariable => \$nom_fic)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
#$saisie->delete(0,'end');
#$saisie->insert('end',"Nouveau");
$Filename=$texte->FileName($nom_fic);
#$filename = $texte->FileName;
#print "$Filename\n";
$buttonLoad=$cadre2->Button(-text => "Load",
                -image => $imageLoad,
	       -command => sub {&lire_fic})->pack(-side => 'left',
						   -anchor => 'e');
$winBalloon->attach($buttonLoad,
                  -balloonmsg => "Load File"
               );



$buttonSelect=$cadre2->Button(-text => "Select Markup",
                -image => $imageSelect,
	       -command => sub {&mkSelectionMarkup})->pack(-side => 'left',
						   -anchor => 'e');
$winBalloon->attach($buttonSelect,
                  -balloonmsg => "Select Markup"
               );
$buttonExit=$cadre2->Button(-text => "Exit",
                            -image => $imageExit,
	       -command => sub{ConfirmExit2($texte)})->pack(-side => 'right');
$winBalloon->attach($buttonExit,
                  -balloonmsg => "Exit"
               );
$buttonHelp=$cadre2->Button(-text => "Help",
                -image => $imageHelp,
	       -command => sub {&command_help})->pack(-side => 'right',
						   -anchor => 'e');
$winBalloon->attach($buttonHelp,
                  -balloonmsg => "Help"
               );
#	$Mbut_help = $mbar->Menubutton(relief => 'raised', 
#		text => "help",
#		underline => 0);
#	$Mbut_help->pack(-side => 'right');
#	$Mbut_help->command(-label => 'help', -command => \&command_help);
$buttonSave=$cadre2->Button(-text => "Save",
                -image => $imageSave,
	       -command => sub {&sauve_fic})->pack(-side => 'right',
						   -anchor => 'e');
$winBalloon->attach($buttonSave,
                  -balloonmsg => "Save This file"
               );
$buttonText=$cadre2->Button(-text => "New",
            -image => $imageText,
	    -command => sub{ConfirmEmptyDocument2($texte);})->pack(-side => 'right',
						  -anchor => 'e');
$winBalloon->attach($buttonText,
                  -balloonmsg => "New file"
               );
$buttonScan=$cadre2->Button(-text => "Scan",
            -image => $imageScan,
	    -command => sub{&scanner;})->pack(-side => 'right',
						  -anchor => 'e');
$winBalloon->attach($buttonScan,
                  -balloonmsg => "Scan Objets"
               );
#---------------------------------------------------------------------------------------
splashProgress( "Initialising last bit. Nearly there...", 99 );
sleep 2;
#---------------------------------------------------------------------------------------
$mw->Label(-textvariable => \$info,
	   -relief => 'ridge')->pack(-side => 'bottom',
				     -fill => 'x');
#---------------------------------------------------------------------------------------

## Remove splash and pop main window to top...
$splash->destroy;
$mw->deiconify;
$mw->raise;


MainLoop;





#---------------------------------------------------------------------------------------
#Procdures et premiers Niveaux
#---------------------------------------------------------------------------------------

#------------------ Procdures diverses --------------------------
sub splashProgress
{
   my ($text, $pct) = @_;
   $progressText = $text;
   $pctComplete = $pct;
   ## Hourglass cursor...
   $splash->Busy(-recurse => 1);
   ## Pop to top (if not! can be annoying tho')...
   $splash->raise;
   $splash->update;
}
#---------------------------------------------

sub scanner {
my $scanner = $mw->ObjScanner( caller => $texte, 
                                 title=>"windows") -> pack ;
}
#---------------------------------------------
sub scanner1 {
  my $scan = $mw ->Toplevel();
#  my $cadre = $scanner->Frame->pack(-side => 'top',  -fill => 'x');
  $scan -> ObjScanner
  (
   caller 		    => $texte,
   title 		    => 'demo setting the scanner options',
   background 	    => 'white',
   selectbackground => 'beige',
   foldImage 		=> $scan->Photo(-file => Tk->findINC('folder.xpm')),
   openImage 		=> $scan->Photo(-file => Tk->findINC('openfolder.xpm')),
   itemImage 		=> $scan->Photo(-file => Tk->findINC('textfile.xpm')),
  )
  -> pack(expand => 1, fill => 'both') ;
}
#----------------------------------------------------------------
sub GetCWD {
  # -- GetCWD
  # Get the current working directory, make sure it ends with a slash
  # No parameters
  # Returns cwd
  # Modified by Calin MOSUT (the command `pwd` in the original code could not
  # reach the mount point on a Windows machine)
  use Cwd;
  local($dir);

  $dir = getcwd;
  # method from Cwd.pm
  $dir =~ s/\n//g;
  if ($dir !~ m#/$#) {
    $dir = "$dir/";
  }
  return $dir;
}  # GetCWD
#---------------------------------------------------------------------------------------
sub ConfirmDiscard2 {
 my ($w)=@_;
 if ($w->numberChanges)
  {
   my $ans = $w->messageBox(-icon    => 'warning',
                            -type => 'YesNoCancel',
                            -message =>
"The text has been modified without being saved.
Save edits?");

   return 0 if ($ans=~/Cancel/i);
   return 1 if (($ans!~/Yes/i) && ($ans!~/Cancel/i));
   return 0 if (($ans=~/Yes/i) && (!$w->FileSaveAsPopup));
   
}
 else {
 return 1;
 }
}
#---------------------------------------------------------------------------------------
sub ConfirmExit2 {
 my ($w) = @_;
 $texte->toplevel->destroy if ConfirmDiscard2($texte);
}
#---------------------------------------------------------------------------------------
sub ConfirmEmptyDocument2 {
 my ($w)=@_;
 $w->EmptyDocument if ConfirmDiscard2($texte);
 $saisie->delete(0,'end');
 $new_num_doc++;
 my $newDoc = "Nouveau".$new_num_doc.".txt";
 $saisie->insert('end',$newDoc);
 $texte->FileName($nom_fic);
 $info="Chargement du fichier Nouveau...";
}

#---------------------------------------------------------------------------------------
sub ConfirmNewDocument {
 my ($w)=@_;
 if (ConfirmDiscard2($w)) {
     return 1;
     }
 else {
     return 0;
 }
}
#-------------------------- Module FILE ------------------------------------------------
sub IncludedFileInWindow {
    my ($tmpfile,$msg) = @_;
    my $mkWindowForIncludingFile->destroy if Exists($mkWindowForIncludingFile);
    $mkWindowForIncludingFile = $mw->Toplevel();
    my $w = $mkWindowForIncludingFile;
    $w->title("$msg");
    $w->iconname("$msg");
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );
    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkWindowForIncludingFile->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    $w_t->insert('0.0', '');
    $w_t->IncludeFile($tmpfile);
}
#---------------------------------------------
sub lire_fic {
    if (&ConfirmNewDocument($texte)) {
		my $nom = "$nom_fic";
		if (!exists ($Courant{$nom})){
		    $Courant{$nom}++;
		    $num_doc++;
		    push (@courant, $nom);
		    $b_menu->command(-label => "$nom",
				     -command => [ \&load_selected_fic, "$nom"]);
		}
	    $info="Chargement du fichier '$nom_fic'...";
	    $texte->Load($nom_fic);
	    $info = "Fichier '$nom_fic' charg.";
	}
}
#---------------------------------------------------------------------------------------
sub sauve_fic {
    $texte->Save;
    $info= "Fichier sauvegard.";
}
#---------------------------------------------
sub FileLoadPopup {
 my ($w)=@_;
 my $name = $w->CreateFileSelect('getOpenFile',-title => 'File Load');
 $nom_fic=$name;
 return $w->Load($name) if defined($name) and length($name);
 return 0;
}
#---------------------------------------------------------------------------------------
sub new_fic {
    my $nom = "$nom_fic";
	if (!exists ($Courant{$nom})){
	    $Courant{$nom}++;
	    $num_doc++;
	    push (@courant, $nom);
	    $b_menu->command(-label => "$nom",
			     -command => [ \&load_selected_fic, "$nom"]);
	}
    &select_document("Nouveau");
    $info = "Fichier Nouveau charg.";
}
#---------------------------------------------------------------------------------------
sub select_document {
    $texte->delete("1.0","end");
    my ($selection) = @_;
    $saisie->delete(0,'end');
    $saisie->insert('end',"$selection");
}
#---------------------------------------------
sub load_selected_fic {
    ($nom_fic) = @_;
    if (&ConfirmNewDocument($texte)) {
		my $nom = "$nom_fic";
		if (!exists ($Courant{$nom})){
		    $Courant{$nom}++;
		    $num_doc++;
		    push (@courant, $nom);
		    $b_menu->command(-label => "$nom",
				     -command => [ \&load_selected_fic, "$nom"]);
		}
		$info="Chargement du fichier '$nom_fic'...";
		$texte->Load($nom_fic);
		$info = "Fichier '$nom_fic' charg.";
	}
}

#---------------------------------------------
sub attach_selected_fic
{
    ($nom_fic) = @_;
    if (&ConfirmNewDocument($texte)) {
		my $nom = "$nom_fic";
		$info="Chargement du fichier '$nom_fic'...";
		my $tmp_file = "attachedFile.txt";
		$texte->Load($tmp_file);
		$info = "Fichier '$nom_fic' attach et disponible.";
	}
}

#------------------------------------ MODULE SEARCH ---------------------------------------

sub remove_mark_search {

    $texte->tagDelete('search','1.0','end');
}

sub remove_mark_search_map {

    my ($texteMp) = @_;
    $texteMp->tagDelete('search','1.0','end');
}

sub remove_search {

    $texte->tagDelete('search','1.0','end');
    $search_string="";
    $replace_string="";
#    $saisie2->delete(0,'end');
#    $saisie3->delete(0,'end');

}
sub remove_search_map {
    my ($texteMp) = @_;
    $texteMp->tagDelete('search','1.0','end');
    $search_string_map="";
#    $replace_string_map="";


}
#---------------------------------------------
sub search_replace {
    my ($search,$replace) = @_;
    &text_replace($texte, $search, $replace, 'search');
    if ($texte->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche et remplacement dans Fichier '$nom_fic' termine.";
    $saisie2->delete(0,'end');
    $saisie3->delete(0,'end');
#    $pn4->destroy() if Tk::Exists($pn4);

}



#---------------------------------------------
sub i_search {

    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $info="Recherche dans le fichier '$nom_fic'...";
    $texte->tag('remove',  'search', '0.0', 'end');
    my $resultat=$texte->search(-regexp, "$search_string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texte->see($resultat);
    if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche dans Fichier '$nom_fic' termine.";

    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    

}

#---------------------------------------------
sub i_search_2 {

    if ($search_string_map eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $texteMp->tag('remove',  'search', '0.0', 'end');
    my $resultat=$texteMp->search(-regexp, "$search_string_map",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string_map;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texteMp->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texteMp->see($resultat);
    if ($pnDraw->depth > 1) {
	text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }


    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    
    print "ps1 : $position_search\n";
}

#---------------------------------------------
sub i_replace {

    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $info="Recherche dans le fichier '$nom_fic'...";
    $texte->tag('remove',  'search', '0.0', 'end');
    $resultat=$texte->search(-regexp, "$search_string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texte->delete(sprintf("%d.%d",$i,$offset),sprintf("%d.%d",$i,$offset + $lenght));    
    $texte->insert(sprintf("%d.%d", $i, $offset),$replace_string);
    $lenght = length $replace_string;
    $texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texte->see($resultat);
    if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche dans Fichier '$nom_fic' termine.";

    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    

}


#---------------------------------------------
sub i_search2 {

    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $texte->tag('remove',  'search', '0.0', 'end');

    if ($position_search  !~/[0-9]+\.[0-9]+/) {
	&mkPrintMsgInfo("On vous a dj dit qu'il n\'existe aucune chane correspondante pour le motif de recherche donn\n...");
	return;
    }
    $info="Recherche dans le fichier '$nom_fic'...";
    $resultat=$texte->search(-regexp, "$search_string",$position_search,'end');
    print $resultat,"<<<<<<<\n";
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texte->see($resultat);
    if ($pnDraw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche dans Fichier '$nom_fic' termine.";
    
    $position_search= sprintf("%d.%d", $i, $offset+$lenght);

}

#---------------------------------------------
sub i_search2_2 {

    if ($search_string_map eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $texteMp->tag('remove',  'search', '0.0', 'end');

#    print "ps2 : $position_search\n";

    if ($position_search  !~/[0-9]+\.[0-9]+/) {
	&mkPrintMsgInfo("On vous a dj dit qu'il n\'existe aucune chane correspondante pour le motif de recherche donn\n...");
	return;
    }
#    $info="Recherche dans le fichier '$nom_fic'...";
    $resultat=$texteMp->search(-regexp, "$search_string_map",$position_search,'end');
    print $resultat,"<<<<<<<\n";
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string_map;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texteMp->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texteMp->see($resultat);
    if ($pnDraw->depth > 1) {
	text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

#    $info= "Recherche dans Fichier '$nom_fic' termine.";
    
    $position_search= sprintf("%d.%d", $i, $offset+$lenght);

}

#---------------------------------------------
sub i_replace2 {

    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    if ($position_search  !~/[0-9]+\.[0-9]+/) {
	&mkPrintMsgInfo("On vous a dj dit qu'il n\'existe aucune chane correspondante pour le motif de recherche donn\n...");
	return;
    }

    $info="Recherche dans le fichier '$nom_fic'...";
    $texte->tag('remove',  'search', '0.0', 'end');
    $resultat=$texte->search(-regexp, "$search_string",$position_search,'end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texte->delete(sprintf("%d.%d",$i,$offset),sprintf("%d.%d",$i,$offset + $lenght));    
    $texte->insert(sprintf("%d.%d", $i, $offset),$replace_string);
    $lenght = length $replace_string;
    $texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texte->see($resultat);
    if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche dans Fichier '$nom_fic' termine.";

    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    

}

#---------------------------------------------
sub search_in_fic {
    
    $info="Recherche dans le fichier '$nom_fic'...";
    &text_search($texte, $search_string, 'search');
    if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche dans Fichier '$nom_fic' termine.";
    $saisie2->delete(0,'end');
}

#---------------------------------------------
sub search_in_fic_2 {
    
    &text_search($texteMp, $search_string_map, 'search');
    if ($pnDraw->depth > 1) {
	text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

#    $saisie2->delete(0,'end');
}
#---------------------------------------------------------------------------------------
sub replace {
    
    $info="Recherche et remplacement dans le fichier '$nom_fic'...";
    &text_replace($texte, $search_string, $replace_string, 'search');
    if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche et remplacement dans Fichier '$nom_fic' termine.";
    $saisie2->delete(0,'end');
    $saisie3->delete(0,'end');
}

#--------------------------------------------------------------------------------------
sub text_delete {

    # The utility procedure below searches and destroy for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. 
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $tag) = @_;
    my @seenElt=();

    if ($string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;
	}
    my $resultat=$w->search(-regexp, "$string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    my $id = 0;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $w->tag('add', $tag, sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$l));
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend


	for ($i = $#seenElt; $i >= 0; $i--) {
	    $w->delete(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    }
    
    @seenElt=();
}

#---------------------------------------------------------------------------------------
sub text_search {

    # The utility procedure below searches for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. (regexp and so on...)
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $tag) = @_;

    if ($string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;

    }

    my $resultat=$w->search(-regexp, "$string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }

    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $w->tag('add', $tag, sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$l));
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend

} # end text_search

#---------------------------------------------------------------------------------------
sub text_replace {

    # The utility procedure below searches for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. (regexp and so on...)
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $replace, $tag) = @_;
    my @seenElt=();

    if ($string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;

    }

    my $resultat=$w->search(-regexp, "$string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }

    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    my $id = 0;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $w->tag('add', $tag, sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$l));
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l,$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend


	for ($i = $#seenElt; $i >= 0; $i--) {
	    $w->delete(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    $w->insert(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),$replace);
	    my $lenght = length $replace;
	    $w->tag('add', 'search', sprintf("%d.%d", $seenElt[$i][0],$seenElt[$i][1]), sprintf("%d.%d", $seenElt[$i][2],$seenElt[$i][3] + $lenght - $seenElt[$i][4]));

	    }

} # end text_replace


#---------------------------------------------------------------------------------------
sub text_toggle {

    # The procedure below is invoked repeatedly to invoke two commands at periodic intervals.  It normally reschedules itself
    # after each execution but if an error occurs (e.g. because the window was deleted) then it doesn't reschedule itself.
    # Arguments:
    #
    # w -       Text widget reference.
    # cmd1 -	Reference to a list of tag options.
    # sleep1 -	Ms to sleep after executing cmd1 before executing cmd2.
    # cmd2 -	Reference to a list of tag options.
    # sleep2 -	Ms to sleep after executing cmd2 before executing cmd1 again.

    my($w, $cmd1, $sleep1, $cmd2, $sleep2) = @_;
    $w->tag(@{$cmd1});
    $w->after($sleep1, [sub {text_toggle(@_)}, $w, $cmd2, $sleep2, $cmd1, $sleep1]);

} # end text_toggle


#---------------------------- MODULE MARKUP -------------------------------------------

sub extract_text_in_balise {
    my @selection = $listePn2->curselection();
    my $tmp_nomfic=$nom_fic;
    open(TMPCATFILE,">MKCtmp_catExtractTextInMarkup.txt");

    foreach $ind (@selection) {
	my $element=$listePn2->get($ind);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	if ($element=~/<([^ ]+) [^>]*>/) {$tmp=$1}
	my $balise_name = $tmp;
	my $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
#	print "$nom_fic2\n";
	&extract_balise($element);
	open(TMPFILEEXTRACT,$nom_fic2);
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
	}	
    close(TMPCATFILE);

    my $tmpfile="MKCtmp_catExtractTextInMarkup.txt";
    $mkExtractTextInMarkup->destroy if Exists($mkExtractTextInMarkup);
    $mkExtractTextInMarkup = $mw->Toplevel();
    my $w = $mkExtractTextInMarkup;
    $w->title('Extract Text');
    $w->iconname('Extract');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkExtractTextInMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Extract Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);
    $info = "Recherche Markups sur '$nom_fic' termine.";

    
}

sub make_text2map {
    my @selection = $listePn2Map->curselection();
#    if ($#selection > 0) {
#	&mkPrintErreur("ERREUR : le slection ne doit comporter qu\'un seul item\n");
#	return;
#    }
    my $tmp_nomfic=$nom_fic;
    if (!open(TMPCATFILE,(">MKCtmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_catExtractTextInMarkup.txt en criture\n");
	return;
    }
    my %mapSelTag=();
    foreach $ind (@selection) {
	my $element=$listePn2Map->get($ind);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	if ($element=~/<([^ ]+) [^>]*>/) {$tmp=$1}
	my $balise_name = $tmp;

	$mapSelTag{$tmp}=$tmp;

	my $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
#	print "$nom_fic2\n";
	&extract_balise_oneline($element);

	if (!open(TMPFILEEXTRACT,$nom_fic2)) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic2\n");
	    return;
	}
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
	}	
    close(TMPCATFILE);

    if (!open(TMPCATFILE,("MKCtmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_catExtractTextInMarkup.txt en lecture\n");
	return;
    }


    @mapText = ();
    while(<TMPCATFILE>){
	if (/^(<[^>]+>)\#(.+)$/) {
	    my %indMapText=();
	    $indMapText{$1}=$2;
	    push(@mapText,\%indMapText);
#	    print "tag: $1 content: $2\n";
	}
    }	
    close(TMPCATFILE);

#    print %mapSelTag,"\n";
    push(@mapText,\%mapSelTag)
    &drawText(@mapText);
}

sub make_text2map2 {

    my ($tab) = @_;
    my @newtab = @$tab;
    my $tmp=$newtab[0];
    $tmp=~s/(>)/$1\n/gi;
    my $file="MKCtmp_MapFile2.txt";
    if (!open(TMPMAPFILE,(">$file"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	return;
    }
    print TMPMAPFILE $tmp,"\n";
    close(TMPMAPFILE);
    
    my @selection = $listePn2SelectionMarkup2->curselection();
    my $tmp_nomfic=$file;
    if (!open(TMPCATFILE,(">MKCtmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_catExtractTextInMarkup.txt en criture\n");
	return;
	}
    my %mapSelTag=();
    foreach $ind (@selection) {
	my $element=$listePn2SelectionMarkup2->get($ind);
	next if ($element=~/<\//);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	if ($element=~/<([^ ]+) [^>]*>/) {$tmp=$1}
	my $balise_name = $tmp;
	$mapSelTag{$tmp}=$tmp;
	my $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
	&extract_balise_oneline2($element,$file);
	if (!open(TMPFILEEXTRACT,$nom_fic2)) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic2\n");
	    return;
	}
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
    }	
    close(TMPCATFILE);
    
    if (!open(TMPCATFILE,("MKCtmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_catExtractTextInMarkup.txt en lecture\n");
	return;
    }
    
    
    @mapText = ();
    while(<TMPCATFILE>){
	    if (/^(<[^>]+>)\#(.+)$/) {
		my %indMapText=();
		$indMapText{$1}=$2;
		push(@mapText,\%indMapText);
#	    print "tag: $1 content: $2\n";
	    }
	}	
    close(TMPCATFILE);
    
#    print %mapSelTag,"\n";
    push(@mapText,\%mapSelTag)
	&drawText(@mapText);
}



#--- CANVAS subs

sub start_move
{
	my $c=shift;
	
	#find current item...
	my $item = $c->find('withtag','current');

	my $event=$canvas->XEvent;
	($startxx,$startyy)=($event->x,$event->y);

	#get all items with same tags...
	my ($tag)=$c->itemcget($item,-tags);
	my @sametag=$c->find('withtag',$tag);

	#Binding 'all' items is probably overkill?
	$c->bind('all','<Any-Motion>',[\&move_items, \@sametag]);
	$c->bind('all','<ButtonRelease>',\&end_move);
}

sub move_items
{
	my $c=shift;
	my $tagarrayref=shift;

	my $deltaxx;
	my $deltayy;
	my $xoffset;
	my $yoffset;

	my $event=$canvas->XEvent;
	($finalxx,$finalyy)=($event->x,$event->y);

	($xoffset,$yoffset)=&get_corners($c);
	($finalxx,$finalyy)=($finalxx+$xoffset,$finalyy+$yoffset);

	$deltaxx=$finalxx-$startxx;
	$deltayy=$finalyy-$startyy;
	foreach(@$tagarrayref){
		$c->move($_,$deltaxx,$deltayy);
	}
	
	$startxx=$finalxx;
	$startyy=$finalyy;
}

sub end_move
{
	my $c=shift;
	$c->bind('all','<Any-Motion>','');
	$c->bind('all','<ButtonRelease>','');
}

sub get_corners
{
	#returns coords of topleft and bottom right corners of visible area.
	my $c = shift;
	my (@xview) = $c->xview;
	my (@yview) = $c->yview;
	my (@sr) = @{$c->cget(-scrollregion)};
	my $topleftX = $xview[0] * ($sr[2]-$sr[0]) + $sr[0];
	my $topleftY = $yview[0] * ($sr[3]-$sr[1]) + $sr[1];
        my $botrightX = $xview[1] * ($sr[2]-$sr[0]) + $sr[0];
     	my $botrightY = $yview[1] * ($sr[3]-$sr[1]) + $sr[1];

	return ($topleftX, $topleftY, $botrightX, $botrightY);
}


sub liste_alltag_map {

    my ($newtab,$canvas) = @_;

    my %tab = %$newtab;
    my @liste_balises=();
    my %Liste_Markups=();
    my $id = 0; 
    foreach $tagtmp (keys %tab) {
	my $file="MKCtmp_MapFile.txt";
	if (!open(TMPMAPFILE,(">$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	    return;
	}
	my $tmp = $tab{$tagtmp};
	$tmp=~s/(> )/$1\n/g/
	print TMPMAPFILE $tmp,"\n";
	close(TMPMAPFILE);
	if (!open(TMPMAPFILE,("$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en lecture\n");
	    return;
	}
	while(<TMPMAPFILE>) {

	    while (/(<[^>]+>)/g) {
		if (!exists ($Liste_Markups{$1})) {
		    $Liste_Markups{$1}++;
		    $liste_balises[$id]=$1;
		    $id++;
		}
	    }
	}
	close(TMPMAPFILE);
    }

    $pnDrawSelectionMarkup->destroy if Exists($pnDrawSelectionMarkup);
    $pnDrawSelectionMarkup = $mw ->Toplevel();
    $pnDrawSelectionMarkup->title("Slection Markups");
    
    $listePn2SelectionMarkup=$pnDrawSelectionMarkup->Scrolled("Listbox", -scrollbars => "e",
							      -selectmode => "extended",
							      -selectforeground => "red",
							      -setgrid => 1,
							      -width => -1)->pack();
    $pnDrawSelectionMarkup->Button(-text => "Search TAG",
				   -command =>  sub{&search_tag_in_map($newtab,$canvas)})->pack(-side => 'left', -pady => 5, -padx => 10);
    
    $pnDrawSelectionMarkup->Button(-text => "Close",
				   -command =>  sub {$pnDrawSelectionMarkup->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);
    
    $listePn2SelectionMarkup->delete(0,'end');
    $listePn2SelectionMarkup->insert('end',@liste_balises);


}


sub search_tag_in_map2 {

    my ($newtab,$canvas) = @_;
    my $tmpSearchString="";
    my @selection = $listePn2SelectionMarkup2->curselection();
    foreach $ind (@selection) {
#	print $element,"\n";
	my $element=$listePn2SelectionMarkup2->get($ind);
	$tmpSearchString = "$tmpSearchString" ."\($element\)"."|" ;
#	print "TAGTOSEARCHy : $tmpSearchString\n";
	

    }
    chop($tmpSearchString);
    $tmpSearchString=~s/\//\\\//g;
    $tmpSearchString=~s/\"/\\\"/g;
#    print "TAGTOSEARCH : $tmpSearchString\n";
    &searchInTagMap($newtab,$tmpSearchString,$canvas)

    }

sub search_tag_in_map {

    my ($newtab,$canvas) = @_;
    my $tmpSearchString="";
    my @selection = $listePn2SelectionMarkup->curselection();
    foreach $ind (@selection) {
#	print $element,"\n";
	my $element=$listePn2SelectionMarkup->get($ind);
	$tmpSearchString = "$tmpSearchString" ."\($element\)"."|" ;
#	print "TAGTOSEARCHx : $tmpSearchString\n";
	

    }
    chop($tmpSearchString);
    $tmpSearchString=~s/\//\\\//g;
    $tmpSearchString=~s/\"/\\\"/g;
#    print "TAGTOSEARCH : $tmpSearchString\n";
    &searchInTagMap($newtab,$tmpSearchString,$canvas)

    }

sub searchInTagMap {

    my ($newtab,$search_string,$canvas) = @_;
    my %tab = %$newtab;
#	print "RESU1 : $resultat\n";
    foreach $tagtmp (keys %tab) {
#	print "RESU2 : $resultat\n";
	my $file="MKCtmp_MapFile.txt";
	if (!open(TMPMAPFILE,(">$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	    return;
	}
	print TMPMAPFILE $tab{$tagtmp},"\n";
	print TMPMAPFILE "\n";

	close(TMPMAPFILE);
	if (!open(TMPMAPFILE,("$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en lecture\n");
	    return;
	}
	$resultat = "no";
	while (<TMPMAPFILE>) {
	    if ($_=~/$search_string/) {
		$resultat = "yes";
	    }

	}
	close(TMPMAPFILE);
	my $color1="red";
	my $color2="white";

#	print "RESU : $resultat\n";

	if ($resultat eq "yes") {
	    $canvas->itemconfigure($tagtmp, -fill=>$color1);
	}
	else {
	    $canvas->itemconfigure($tagtmp, -fill=>$color2);
	}
    }

    
}

sub drawText {

    my (@tab) = @_;
    my $sel=pop(@tab);
    my %sel2 = %$sel;
    print %sel2,"\n";
    my $nomsel ="";
    foreach $selx (keys %sel2) {
	$nomsel="$nomsel"."<"."$sel2{$selx}".">";
    }
    $pnDraw->destroy if Exists($pnDraw);

    if (! Exists ($pnDraw)) {
	$pnDraw = $mw ->Toplevel();
	$pnDraw->title("Map Text Core");
	my $cadre = $pnDraw->Frame->pack(-side => 'left',
					 -fill => 'both', -expand => 1);
	my $cadre2 = $pnDraw->Frame->pack(-side => 'right',
					 -fill => 'both', -expand => 1);
	my $f_label = $cadre->Frame(
                -bd => 2, 
                -label => "Text Map For ($nomsel) TAGs")->pack(-side => 'top', -fill => 'y');


	my $f0 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f1 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f2 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f3 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');

	$f0->Button(-text => "Close",
		     -command =>  sub {$pnDraw->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

        $f0->Menubutton(-text => "Search in Text",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "I-Search",
					-command => \&i_search_2],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2_2],
				       ['command' => "Global Search",
					-command => \&search_in_fic_2]
					  ])->pack(-side => 'left');

	my $c = $cadre2->Scrolled("Canvas", -cursor => "crosshair")->pack(
								   -side => 'bottom', -fill => 'both', -expand => 1);

	$canvas = $c->Subwidget("canvas");
#-----------------------
	my @textMapFull=();
	%mapTextFull=();
#-----------------------
	$texteMp= $cadre->Scrolled("TextUndo")->pack(-side => 'top',
			      -fill => 'both',
	    		      -expand => 1);
	$texteMp->Text(-setgrid => 'true');
#-----------------------
	$search_string_map='';
	my $w_string_button = $f1->Button(-text => 'Highlight in Text');
	my $w_string_button1 = $f1->Button(-text => 'No Highlight');
	my $w_string_button3 = $f2->Button(-text => 'ClearSearch');
	my $w_string_button4 = $f2->Button(-text => 'TAG List All Square');
	$w_string_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button1->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button3->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button4->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button->configure(-command => [sub {&text_search($texteMp, $search_string_map, 'search')}, $texteMp]);
	$w_string_button1->configure(-command => [sub {&remove_mark_search_map($texteMp)}]);
	$w_string_button3->configure(-command => [sub {&remove_search_map($texteMp)}]);
	$w_string_button4->configure(-command => [sub {&liste_alltag_map(\%mapTextFull,$c)}]);


	my $w_string2_label = $f3->Label(-text => 'search:', -width => 10, -anchor => 'w');
	my $w_string2_entry = $f3->Entry(-textvariable => \$search_string_map);
	my $w_string2_button = $f3->Button(-text => 'search in Map');
	$w_string2_label->pack(-side => 'left');
	$w_string2_entry->pack(-side => 'left');
	$w_string2_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string2_button->configure(-command => [sub {&searchInTagMap(\%mapTextFull,$search_string_map,$c)}]);
	$w_string2_entry->bind('<Return>' => [sub {&searchInTagMap(\%mapTextFull,$search_string_map,$c)}]);


    if ($pnDraw->depth > 1) {
	text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }


#-----------------------
	my $coordx=15;
	my $coordy=15;
	my $mark=0;
	$markname = "car".$mark;
	my $color1="blue";
	my $color2="red";
	my $color3="white";
	my $color4="yellow";
	my $color5="black";
	my $color6="green";
	@color = ($color1,$color2,$color3,$color4,$color5,$color6);
	my %tmpcolor =();
	my $newcolor ="";
	foreach $tagtmp (@tab) {
	    my %tag = %$tagtmp;
	    my @liste = keys(%tag);
	    $liste[0]=~/<([^=]+)=[^>]+>/;
	    my $tmpTagColor = $1;
	    if ($newcolor eq "") {
		$newcolor=$color[0];
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}
	    if (!exists($tmpcolor{$tmpTagColor})) {
		$newcolor=$color[0]; 
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}
	    $id = $canvas->createRectangle($coordx,$coordy,$coordx+10,$coordy+10,-fill=>$newcolor,-tags => $markname);
	    $textMapFull[$mark]=$tag{$liste[0]};
	    $mapTextFull{$id}=$tag{$liste[0]};
	    my %mapTextFull2=();
	    $mapTextFull2{$id}=$tag{$liste[0]};
	    
	    my @tmpTabContent = ();
	    $tmpTabContent[0]= $tag{$liste[0]};
	    $canvas->bind($markname,"<Button-1>", sub {&displayContentTag(\@tmpTabContent,$texteMp)});
	    $canvas->bind($markname,"<Button-3>", sub {&displayTagSquare(\%mapTextFull2,$texteMp,$c,\@tmpTabContent,\%mapTextFull)});
	    $coordx+=15;
	    if ($coordx > 300){ 
		$coordx=15; 
		$coordy+=15;
	    }
	    $mark++;
	    $markname = "car".$mark;
	}

	$canvas->bind('all','<ButtonPress>',\&start_move);

    }
}

#----------------------------------
sub displayTagSquare {

    my ($tab,$texte,$canvas,$tabsquare,$alltabsquare) = @_;
    my %newtab = %$tab;
 
    my @liste_balises=();
    my %Liste_Markups=();
    my $id = 0; 
 
    foreach $tagtmp (keys %newtab) {
#	print $tagtmp,"\n";
#	print $newtab{$tagtmp},"\n";
	$newtab{$tagtmp}=~s/(> )/$1\n/gi;
	my $file="MKCtmp_MapFile.txt";
	if (!open(TMPMAPFILE,(">$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	    return;
	}
	print TMPMAPFILE $newtab{$tagtmp},"\n";
	close(TMPMAPFILE);
	if (!open(TMPMAPFILE,("$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en lecture\n");
	    return;
	}
	while(<TMPMAPFILE>) {
	    while (/(<[^>]+>)/g) {
		if (!exists ($Liste_Markups{$1})) {
		    $Liste_Markups{$1}++;
		    $liste_balises[$id]=$1;
		    $id++;
		}
	    }
	}
	close(TMPMAPFILE);
    }    
    
    $pnDrawSelectionMarkup2->destroy if Exists($pnDrawSelectionMarkup2);
    $pnDrawSelectionMarkup2 = $mw ->Toplevel();
    $pnDrawSelectionMarkup2->title("Slection Markups");
    
    $listePn2SelectionMarkup2=$pnDrawSelectionMarkup2->Scrolled("Listbox", -scrollbars => "e",
							      -selectmode => "extended",
							      -selectforeground => "red",
							      -setgrid => 1,
							      -width => -1)->pack();
    $pnDrawSelectionMarkup2->Button(-text => "Search TAG",
				   -command =>  sub{&search_tag_in_map2($alltabsquare,$canvas)})->pack(-side => 'left', -pady => 5, -padx => 10);
    
    $pnDrawSelectionMarkup2->Button(-text => "Make New Map-TAG",
				   -command =>  sub{&make_text2map2($tabsquare)})->pack(-side => 'left', -pady => 5, -padx => 10);
    
    $pnDrawSelectionMarkup2->Button(-text => "Close",
				   -command =>  sub {$pnDrawSelectionMarkup2->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);
    
    $listePn2SelectionMarkup2->delete(0,'end');
#    print @liste_balises,"\n";
    $listePn2SelectionMarkup2->insert('end',@liste_balises);
    

}

#----------------------------------
sub displayContentTag {

    my ($tab,$texte) = @_;
    my @newtab = @$tab;
#    &mkPrintTagContent($newtab[0]);
    $texte->delete("1.0","end");
    $newtab[0]=~s/(> )/$1\n/gi;
    $texte->insert('0.0', $newtab[0]);
}
#----------------------------------
sub extract_tagtext_in_balise {
    my @selection = $listePntag->curselection();
    my $tmp_nomfic=$nom_fic;
    open(TMPCATFILE,">MKCtmp_catExtractTextInMarkup.txt");

    foreach $ind (@selection) {
	my $element=$listePntag->get($ind);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	my $tmp2="";
	if ($element=~/<([^ ]+) type=\"([^\"]*)\">/) {$tmp=$1;
					    $tmp2=$2;}
	my $balise_name = $tmp."-".$tmp2;
	my $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
#	print "$nom_fic2\n";
	&extract_tagbalise($element);
	open(TMPFILEEXTRACT,$nom_fic2);
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
	}	
    close(TMPCATFILE);

    my $tmpfile="MKCtmp_catExtractTextInMarkup.txt";
    $mkExtractTextInMarkup->destroy if Exists($mkExtractTextInMarkup);
    $mkExtractTextInMarkup = $mw->Toplevel();
    my $w = $mkExtractTextInMarkup;
    $w->title('Extract Text');
    $w->iconname('Extract');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkExtractTextInMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Extract Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);
    $info = "Recherche Markups sur '$nom_fic' termine.";

    
}

#---------------------------------------------
sub delete_selected_balise {

    my @selection = $listePn2->curselection();
    foreach $ind (@selection) {
	my $element=$listePn2->get($ind);
	&text_delete($texte, $element, 'search');
	$element=~/<([^>]+)>/;
	my $new_element="<\/$1>";
	&text_delete($texte, $new_element, 'search');


    }

}
#---------------------------------------------
sub modify_selected_balise {
    my @selection = $listePn2->curselection();
    foreach $ind (@selection) {
	my $element=$listePn2->get($ind);
	&query_replace($element);
    }
}

#---------------------------------------------
sub modify_selected_char {
    my @selection = $listePnChangeChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeChar->get($ind);
	&query_replace($element);
    }
}

#---------------------------------------------
sub modify_selected_Unrochognizedchar {
    my @selection = $listePnChangeUnrocognizedChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeUnrocognizedChar->get($ind);
	&query_replace($element);
    }
}

#---------------------------------------------
sub concordance_char {
    my @selection = $listePnChangeChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeChar->get($ind);
	$search_string="$element";
	$info="Recherche Caractre";
	&text_search($texte, $search_string, 'search');
    }
}

sub concordance_Unrochognizedchar {
    my @selection = $listePnChangeUnrocognizedChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeUnrocognizedChar->get($ind);
	$search_string="$element";
	$info="Recherche Caractre";
	&text_search($texte, $search_string, 'search');
    }
}


#---------------------------------------------
sub delete_selected_char {
    my @selection = $listePnChangeChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeChar->get($ind);
	&text_delete($texte, $element, 'search');
    }
}

#---------------------------------------------
sub delete_selected_Unrochognizedchar {
    my @selection = $listePnChangeUnrocognizedChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeUnrocognizedChar->get($ind);
	&text_delete($texte, $element, 'search');
    }
}

#---------------------------------------------
sub modify_selected_ascii {
    my @selection = $listePnChangeAscii->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeAscii->get($ind);
	&query_replace(chr($element));
    }
}


#---------------------------------------------
sub delete_selected_ascii {
    my @selection = $listePnChangeAscii->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeAscii->get($ind);
	&text_delete($texte, chr($element), 'search');
    }
}

sub concordance_Asciichar {
    my @selection = $listePnChangeAscii->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeAscii->get($ind);
	$search_string=chr($element);
	$info="Recherche Caractre";
	&text_search($texte, $search_string, 'search');
    }
}

#---------------------------------------------
sub del_balise {
    
    $search_string="<[^>]+>";
    $info="Recherche et suppression dans le fichier '$nom_fic'...";
    &text_delete($texte, $search_string, 'search');
    $info= "Suppression dans Fichier '$nom_fic' termine.";
    $saisie2->delete(0,'end');
}

#---------------------------------------------------------------------------------------
sub list_balise {
    
    $search_string="<[^>]+>";
    $info="Recherche dans le fichier '$nom_fic'...";
    &text_balise($texte, $search_string, 'search');
    $info= "Affichage balises dans Fichier '$nom_fic' termine.";
    $saisie2->delete(0,'end');
}

#---------------------------------------------------------------------------------------
sub search_balise {
    
    $search_string="<[^>]+>";
    $info="Recherche balises le fichier '$nom_fic'...";
    &text_search($texte, $search_string, 'search');
    if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $info= "Recherche dans Fichier '$nom_fic' termine.";
    $saisie2->delete(0,'end');

}

#---------------------------------------------------------------------------------------
sub text_balise {

    # The utility procedure below searches and destroy for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. 
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $tag) = @_;
    my $id = 0;
    my @seenElt=();

    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend

    $cpt_file_balises++;
    if (!open(TMPFILE,(">MKCtmp_Mkbalises.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	return;
    }
    $info="Cration du fichier  MKCtmp_Mkbalises.txt...";
    for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	    }
    close(TMPFILE);


    $info="Chargement du fichier  MKCtmp_Mkbalises.txt...";
    my $tmpFile="MKCtmp_Mkbalises.txt";
    &print_list_balise($tmpFile);

}


#---------------------------------------------
sub print_list_balise {

    my ($tmpfile) = @_;
    $mkTextMarkup->destroy if Exists($mkTextMarkup);
    $mkTextMarkup = $mw->Toplevel();
    my $w = $mkTextMarkup;
    $w->title('Markup List');
    $w->iconname('Markup');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );



    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkTextMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Markup Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);
    $info = "Recherche Markups sur '$nom_fic' termine.";
}


#---------------------------------------------
sub extract_balise_i {
    my ($balise_d) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";
    my $resultat=$texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
    $info="Lecture du fichier '$nom_fic'...";
    if (!open(TMPFILE,("$nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    $info="Cration du fichier '$nom_fic2'...";
    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>\n";
			    print TMPFILE2 "$1\n";

		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";
    close(TMPFILE);
    close(TMPFILE2);

    my $tmpfile="MKCtmp_ExtractText_".$balise_name.".txt";
    $mkExtractTextInMarkup->destroy if Exists($mkExtractTextInMarkup);
    $mkExtractTextInMarkup = $mw->Toplevel();
    my $w = $mkExtractTextInMarkup;
    $w->title('Extract Text');
    $w->iconname('Extract');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkExtractTextInMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Extract Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);
    $info = "Recherche Markups sur '$nom_fic' termine.";

}

#---------------------------------------------
sub extract_balise {
    my ($balise_d) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";
    my $resultat=$texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
    $info="Lecture du fichier '$nom_fic'...";
    if (!open(TMPFILE,("$nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    $info="Cration du fichier '$nom_fic2'...";
    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>\n";
			    print TMPFILE2 "$1\n";

		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";
    close(TMPFILE);
    close(TMPFILE2);

}

#---------------------------------------------
sub extract_balise_oneline {
    my ($balise_d) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";
    my $resultat=$texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
    $info="Lecture du fichier '$nom_fic'...";
    if (!open(TMPFILE,("$nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    $info="Cration du fichier '$nom_fic2'...";
    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>#$1\n";
		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>#";
		    chomp($tmp);
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			chomp($ligne);
			print TMPFILE2 " $ligne";
			$ligne=<TMPFILE>;
			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    $tmp=$1;
		    chomp($tmp);
		    print TMPFILE2 " $tmp\n";
		    }
	    }
    close(TMPFILE);
    close(TMPFILE2);

}

#---------------------------------------------
sub extract_balise_oneline2 {
    my ($balise_d,$file) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";

#pb a regler : on travaille pas dans $texte....
    my $resultat=$texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";

    if (!open(TMPFILE,("$file"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$file'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    $info="Cration du fichier '$nom_fic2'...";
    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>#$1\n";
		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>#";
		    chomp($tmp);
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			chomp($ligne);
			print TMPFILE2 " $ligne";
			$ligne=<TMPFILE>;
			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    $tmp=$1;
		    chomp($tmp);
		    print TMPFILE2 " $tmp\n";
		    }
	    }
    close(TMPFILE);
    close(TMPFILE2);

}

#---------------------------------------------
sub extract_tagbalise {
    my ($balise_d) = @_;

    $balise_d=~/<([^ ]+) type=\"([^\"]+)\">/;
    my $tmp=$1;
    my $tmp2 = $2;
    my $search_d= $balise_d."begin\_".$tmp2."</tagHTML>";
    my $balise_f="<\/$tmp>";
    my $search_f= $balise_d."end\_".$tmp2."</tagHTML>";
    my $balise_name = "$tmp"."-"."$tmp2";
    my $markname = "$tmp2";

    print $balise_name, "\n";
    print $search_d, "\n";
    print $search_f, "\n";

    my $resultat=$texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKCtmp_ExtractText_".$balise_name.".txt";
    $info="Lecture du fichier '$nom_fic'...";

    if (!open(TMPFILE,("$nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    my $ind=0;
    $info="Cration du fichier '$nom_fic2'...";
    while ($ligne = <TMPFILE>) { 
#		if ($ligne =~ /$search_d(.*)$search_f/i)
#			{ 
#			    $ind++;
#			    print TMPFILE2 "<$makname=NUM$ind>\n\n";
#			    print TMPFILE2 "$1\n";
#
#		    }
		if (($ligne=~/$search_d(.*)/i) && ($ligne!~/$search_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "\n\n<$markname=NUM$ind>\n\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$search_f/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$search_f/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";
    close(TMPFILE);
    close(TMPFILE2);

}



#----------------------------- MODULE HTML ----------------------------------
sub html0 {

require "mkCorpusModules::MyParser.pm";

# On cre un objet MyParser (qui hrite de tout ce qui faut
# de HTML::Parser)
    my $p= MyParser->new;

# On lance le parsing du fichier pass en argument
# de la ligne de commande par exemple.
# A chaque fois que le parseur va dtecter du texte
# il va appeler la fonction text (dfinie dans toto.pm)

    eval { $p->parse_file($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    my $tmpFile="MKCtmp_formatHtml2text.txt";
    &load_selected_fic($tmpFile);
    $info = "Fichier MKCtmp_formatHtml2text.txt charg.";

}

#---------------------------------------------
sub html1 {

        my $html = parse_htmlfile($nom_fic);
        $formatter = HTML::FormatText->new(leftmargin => 0, rightmargin => 50);
	$formatter = HTML::FormatText->new(leftmargin => 0, rightmargin => 50);
	open(TMPTEXT,">MKCtmp_formatHtml2text.txt");
	print TMPTEXT $formatter->format($html);
	close(TMPTEXT);
	my $tmpFile="MKCtmp_formatHtml2text.txt";
	&load_selected_fic($tmpFile);
	$info = "Fichier MKCtmp_formatHtml2text.txt charg.";
    

}

#---------------------------------------------
sub html2 {

        $html = parse_htmlfile($nom_fic);
        $formatter = new HTML::FormatPS
                         FontFamily => 'Helvetica',
                         PaperSize  => 'Letter';
	open(TMPTEXTPS,">MKCtmp_formatHtml2Postcript.ps");
        print TMPTEXTPS $formatter->format($html);
	close(TMPTEXTPS);
	my $tmpFile="MKCtmp_formatHtml2Postcript.ps";
	&load_selected_fic($tmpFile);
	$info = "Fichier MKCtmp_formatHtml2Postcript.ps charg.";

}

#----------------------------- MODULE XML ----------------------------------

sub printEltAsText {

    my $elt = shift;
    my $doc = new XML::EasyOBJ($nom_fic);
    # iterate over a list of elements
    foreach $x ( $doc->$elt) {
	print $x->getString."\n";
   }


}


#-------XPATH
sub xmlXpath {

    $mkTextXpath->destroy if Exists($mkTextXpath);
    $mkTextXpath = $mw->Toplevel();
    my $w = $mkTextXpath;
    $w->title('XPATH');
    $w->iconname('XPATH');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkTextXpath->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Rsultats XPATH...');
    $w_t->insert("end","\n\n");

    my $xpath;

    my $xmlp = XML::XPath::XMLParser->new( filename => $nom_fic);

    my $time = time;
    my $context = $xmlp->parse;

    
    $xpath = XML::XPath->new(filename => $nom_fic);

    my $nodes = $xpath->find($search_string,$context);
    print $search_string , "\n";
    print $nodes->size , "\n";
    unless ($nodes->isa('XML::XPath::NodeSet')) {
      NOTNODES:
	$w_t->insert("end","Query didn't return a nodeset. Value: ");
	$w_t->insert("end","".print $nodes->value."\n");
	return;
    }

	$nodes = find_more($nodes);
	goto NOTNODES unless $nodes->isa('XML::XPath::NodeSet');

    if ($nodes->size) {
	$w_t->insert("end","Found "." ".$nodes->size." nodes:\n");
	foreach my $node ($nodes->get_nodelist) {
		$w_t->insert("end","-- NODE --\n");
		$w_t->insert("end",$node->toString);
	}
    }
    else {
	$w_t->insert("end","No nodes found");
    }

    $w_t->insert("end","\n");


}
#---------------------------------------------------------
sub xmlXpath2 {

    $mkTextXpath->destroy if Exists($mkTextXpath);
    $mkTextXpath = $mw->Toplevel();
    my $w = $mkTextXpath;
    $w->title('XPATH');
    $w->iconname('XPATH');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkTextXpath->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Rsultats XPATH...');
    $w_t->insert("end","\n\n");

    my $p = XML::DOM::Parser->new;


    my $time = time;
    my $doc = $p->parsefile($nom_fic);
    $w_t->insert("end","Parsed in ".(time - $time)." seconds\n");

    my $time = time;
    my @results;
    for (1..100) {
	@results = ();
	for my $gutbook ($doc->getElementsByTagName('gutbook')) {
	    for my $book ($gutbook->getElementsByTagName('book')) {
		for my $bookbody ($book->getElementsByTagName('bookbody')) {
		    for my $chapter ($bookbody->getElementsByTagName('chapter')) {
			for my $chapheader ($chapter->getElementsByTagName('chapheader')) {
			    for my $title ($chapheader->getElementsByTagName('title')) {
				push @results, $title;
			    }
			}
		    }
		}
	    }
	}
    }

    $w_t->insert("end","found ", scalar(@results), " titles in ".(time - $time)." seconds\n");

}

sub find_more {
	my ($nodes) = @_;
	if (!@ARGV) {
		return $nodes;
	}
	
	my $newnodes = XML::XPath::NodeSet->new;
	
	my $find = shift @ARGV;
	
	foreach my $node ($nodes->get_nodelist) {
		my $new = $xpath->find($find, $node);
		if ($new->isa('XML::XPath::NodeSet')) {
			$newnodes->append($new);
		}
		else {
			warn "Not a nodeset: ", $new->value, "\n";
		}
	}
	
	return find_more($newnodes);
}

#---- FIN XPATH


#---------------------------------------------------------
sub xmlConverter1 {
if (!open(TMPFILE2,(">MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.htm\n");
    return;
}
my $p = XML::Parser->new(Style => 'Tree'); 
my $tree = $p->parsefile($nom_fic); 
$levelxmlConverter1 = 0; 
$indxmlConverter1 = ''; 
$headxmlConverter1 = 1; 
print TMPFILE2 "<html>\n";
print TMPFILE2 "<head>\n"; 
print TMPFILE2 "<title>$tree->[1]->[4]->[2]</title>\n"; 
print TMPFILE2 "</head>\n<body>\n"; 
close (TMPFILE2);
process_node1(@$tree); 
if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.htm\n");
    return;
}
print TMPFILE2 "</body>\n</html>\n"; 
close (TMPFILE2);
my $tmpfile="MKCtmp_xmlConversion.htm";
my $msg="MKCtmp_xmlConversion.htm";
&IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------
sub xmlConverter2 {
if (!open(TMPFILE2,(">MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.pod\n");
	return;
}
my $p = XML::Parser->new(Style => 'Tree'); 
my $tree = $p->parsefile($nom_fic); 
$levelxmlConverter2 = 0; 
$indxmlConverter2 = ''; 
$headxmlConverter2 = 1; 
print TMPFILE2 "=pod\n\n"; 
close (TMPFILE2);
process_node2(@$tree); 
if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.pod\n");
	return;
}
print TMPFILE2 "=cut\n\n"; 
close (TMPFILE2);
my $tmpfile="MKCtmp_xmlConversion.pod";
my $msg="MKCtmp_xmlConversion.pod";
&IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------------------

sub xmlConverter3 {
if (!open(TMPFILE2,(">MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.txt\n");
    return;
}
my $p = XML::Parser->new(Style => 'Tree'); 
my $tree = $p->parsefile($nom_fic); 
$levelxmlConverter3 = 0; 
$indxmlConverter3 = ''; 
$headxmlConverter3 = 1; 
print TMPFILE2 "\n", $tree->[1]->[4]->[2], "\n"; 
print TMPFILE2 '-' x length($tree->[1]->[4]->[2]), "\n\n"; 
close (TMPFILE2);
process_node3(@$tree); 
my $tmpfile="MKCtmp_xmlConversion.txt";
my $msg="MKCtmp_xmlConversion.txt";
&IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------
sub process_node1 { 
  my ($type, $content) = @_; 
  my $indxmlConverter1 = ' ' x $levelxmlConverter1; 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.htm\n");
    return;
}
  if ($type) { # element 
    my $attrs = shift @$content; 
    print TMPFILE2 $indxmlConverter1, $type, ' ['; 
    print TMPFILE2 join(', ', map { "$_: $attrs->{$_}" } keys %{$attrs}); 
    print TMPFILE2 "]\n"; 

    ++$level; 
    while (my @node = splice(@$content, 0, 2)) { 
      process_node1(@node); # Recursively call this subroutine 
    }
    --$level; 
  } else { #text 
    $content =~ s/\n/ /g; 
    $content =~ s/^\s+//; 
    $content =~ s/\s+$//; 
    print TMPFILE2 $indxmlConverter1, $content, "\n"; 
  }

close (TMPFILE2); 
}

#---------------------------------------------------------
sub process_node3 { 
  my ($type, $content) = @_; 
  my $indxmlConverter3 = ' ' x $levelxmlConverter3; 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.txt\n");
    return;
}
  if ($type) { # element 
    my $attrs = shift @$content; 
    print TMPFILE2 $indxmlConverter3, $type, ' ['; 
    print TMPFILE2 join(', ', map { "$_: $attrs->{$_}" } keys %{$attrs}); 
    print TMPFILE2 "]\n"; 

    ++$level; 
    while (my @node = splice(@$content, 0, 2)) { 
      process_node3(@node); # Recursively call this subroutine 
    }
    --$level; 
  } else { #text 
    $content =~ s/\n/ /g; 
    $content =~ s/^\s+//; 
    $content =~ s/\s+$//; 
    print TMPFILE2 $indxmlConverter3, $content, "\n"; 
  }

close (TMPFILE2); 
}

#---------------------------------------------------------
sub process_node2 { 
  my ($type, $content) = @_; 
  my $indxmlConverter2 = ' ' x $levelxmlConverter2; 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.pod\n");
    return;
}
  if ($type) { # element 
    my $attrs = shift @$content; 
    print TMPFILE2 $indxmlConverter2, $type, ' ['; 
    print TMPFILE2 join(', ', map { "$_: $attrs->{$_}" } keys %{$attrs}); 
    print TMPFILE2 "]\n"; 

    ++$level; 
    while (my @node = splice(@$content, 0, 2)) { 
      process_node2(@node); # Recursively call this subroutine 
    }
    --$level; 
  } else { #text 
    $content =~ s/\n/ /g; 
    $content =~ s/^\s+//; 
    $content =~ s/\s+$//; 
    print TMPFILE2 $indxmlConverter2, $content, "\n"; 
  }

close (TMPFILE2); 
}


#---------------------------------------------------------
sub process_node1b { 
  my ($type, $content) = @_;
  print "TYPE = ".$type."\n";
  print "CONTENT = ".$content."\n";
 
  $indxmlConverter1 = ' ' x $levelxmlConverter1; 
  if ($type) { 
    local $_ = $type; 
    my $attrs = shift @$content;   
#    print "ATTR = ".$attrs."\n";
    /^NAME$/ && name1($content); 
    /^SYNOPSIS$/ && synopsis1($content); 
    /^DESCRIPTION$/ && description1(); 
    /^TEXT$/ && text1($content); 
    /^CODE$/ && code1($content); 
    /^HEAD$/ && head1($content); 
    /^LIST$/ && do {list1($attrs, $content); @$content = ()}; 
    /^AUTHOR$/ && author1(); 
    /^ANAME$/ && aname1($content); 
    /^EMAIL$/ && email1($content); 
    /^SEE_ALSO$/ && see_also1($content); 
    while (my @node = splice @$content, 0, 2) { 
      ++$levelxmlConverter1; 
      ++$headxmlConverter1 if $type eq 'SUBSECTION'; 
#       print "NODE = ".@node."\n";
      process_node1b(@node); 
      --$headxmlConverter1 if $type eq 'SUBSECTION'; 
      --$levelxmlConverter1; 
    } 
  } 
} 
#---------------------------------------------------------
sub process_node2b { 
  my ($type, $content) = @_; 
  $indxmlConverter2 = ' ' x $levelxmlConverter2; 
  if ($type) { 
    local $_ = $type; 
    my $attrs = shift @$content; 
    /^NAME$/ && name2($content); 
    /^SYNOPSIS$/ && synopsis2($content); 
    /^DESCRIPTION$/ && description2(); 
    /^TEXT$/ && text2($content); 
    /^CODE$/ && code2($content); 
    /^HEAD$/ && head2($content); 
    /^LIST$/ && do {list2($attrs, $content); @$content = ()}; 
    /^AUTHOR$/ && author2(); 
    /^ANAME$/ && aname2($content); 
    /^EMAIL$/ && email2($content); 
    /^SEE_ALSO$/ && see_also2($content); 
    while (my @node = splice @$content, 0, 2) { 
      ++$levelxmlConverter2; 
      ++$headxmlConverter2 if $type eq 'SUBSECTION'; 
      process_node2b(@node); 
      --$headxmlConverter2 if $type eq 'SUBSECTION'; 
      --$levelxmlConverter2; 
    } 
  } 
} 
#---------------------------------------------------------
sub process_node3b { 
  my ($type, $content) = @_; 
  $indxmlConverter3 = ' ' x $levelxmlConverter3; 
  if ($type) { 
    local $_ = $type; 
    my $attrs = shift @$content; 
    /^NAME$/ && name3($content); 
    /^SYNOPSIS$/ && synopsis3($content); 
    /^DESCRIPTION$/ && description3(); 
    /^TEXT$/ && text3($content); 
    /^CODE$/ && code3($content); 
    /^HEAD$/ && head3($content); 
    /^LIST$/ && do {list3($attrs, $content); @$content = ()}; 
    /^AUTHOR$/ && author3(); 
    /^ANAME$/ && aname3($content); 
    /^EMAIL$/ && email3($content); 
    /^SEE_ALSO$/ && see_also3($content); 
    while (my @node = splice @$content, 0, 2) { 
      ++$levelxmlConverter3; 
      ++$headxmlConverter3 if $type eq 'SUBSECTION'; 
      process_node3b(@node); 
      --$headxmlConverter3 if $type eq 'SUBSECTION'; 
      --$levelxmlConverter3; 
    } 
  } 
} 
#---------------------------------------------------------
sub name1 { 
  my $content = shift; 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.htm\n");
    return;
}  
  print TMPFILE2 "<h1>NAME</h1>\n"; 
  print TMPFILE2 "<p>$content->[1]</p>\n" ;
  close(TMPFILE2);
}
#---------------------------------------------------------
sub name2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "=head1 NAME\n\n"; 
  print TMPFILE2 "$content->[1]\n\n"; 
  close(TMPFILE2);
}
#---------------------------------------------------------
sub name3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "NAME\n\n"; 
  print TMPFILE2 $indxmlConverter3, "$content->[1]\n\n"; 
  close(TMPFILE2);
}
#---------------------------------------------------------
sub synopsis1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<h1>SYNOPSIS</h1>\n"; 
  print TMPFILE2 "<pre>$content->[1]</pre>\n";
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub synopsis2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "=head1 SYNOPSIS\n\n"; 
  print TMPFILE2 "$content->[1]\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub synopsis3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "SYNOPSIS\n"; 
  print TMPFILE2 "$content->[1]\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub description1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.htm\n");
    return;
}
  print TMPFILE2 "<h1>DESCRIPTION</h1>\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub description2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_xmlConversion.pod\n");
    return;
}
  print TMPFILE2 "=head1 DESCRIPTION\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub description3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  print TMPFILE2 "DESCRIPTION\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub text1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print "CONTENT = $content\n";
  print TMPFILE2 "<p>$content->[1]</p>\n";
  print "CONTENT = $content->[1]\n";
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub text2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 wrap('', '', trim($content->[1])), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub text3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 wrap($indxmlConverter3, $indxmlConverter3, trim($content->[1])), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub code1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<pre>$content->[1]</pre>\n";
  close(TMPFILE2);
}
#---------------------------------------------------------
sub code2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "$content->[1]\n"; 
  close(TMPFILE2);
}
#---------------------------------------------------------
sub code3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "$content->[1]\n";
  close(TMPFILE2);
}
#---------------------------------------------------------
sub head1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<h$headxmlConverter1>", trim($content->[1]), "</h$headxmlConverter1>\n" ;
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub head2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "=head$headxmlConverter2 ", trim($content->[1]), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub head3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 trim($content->[1]), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub list1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  my ($attrs, $content) = @_; 
  my %list = (bullet => 'ul', numbered => 'ol');
  my $type = $attrs->{TYPE}; 
  print TMPFILE2 "<$list{$type}>\n"; 
  while (my @node = splice @$content, 0, 2) { 
      if ($node[0] eq 'ITEM') { 
	  print TMPFILE2 "<li>$node[1]->[2]</li>\n"; 
      } 
  } 
  print TMPFILE2 "</$list{$type}>\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub list2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
    return;
}
  my ($attrs, $content) = @_; 
  my %list = (bullet => 'ul', numbered => 'ol');
  my $type = $attrs->{TYPE}; 
  print TMPFILE2 "=over 4\n"; 
  while (my @node = splice @$content, 0, 2) { 
      my $cnt = 1; 
      if ($node[0] eq 'ITEM') { 
	  print TMPFILE2 "=item *\n$node[1]->[2]\n\n"; 
      } 
  } 
  print TMPFILE2 "=back\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub list3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  my ($attrs, $content) = @_; 
  my %list = (bullet => 'ul', numbered => 'ol');
  my $type = $attrs->{TYPE}; 
  while (my @node = splice @$content, 0, 2) { 
      my $cnt = 1; 
      if ($node[0] eq 'ITEM') { 
	  print TMPFILE2 $indxmlConverter3, "* $node[1]->[2]\n"; 
      } 
  } 
  print TMPFILE2 "\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub author1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  print TMPFILE2 "<h1>AUTHOR</h1>\n";
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub author2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
    return;
}
  print TMPFILE2 "=head1 AUTHOR\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub author3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  print TMPFILE2 "AUTHOR\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub aname1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<p>$content->[1]\n" ;
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub aname2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 trim($content->[1]), ' '; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub aname3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 $indxmlConverter3, trim($content->[1]), ' '; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub email1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 '&lt;', trim($content->[1]), "&gt;</p>\n" ;
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub email2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 '<', trim($content->[1]), ">\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub email3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 '<', trim($content->[1]), ">\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub see_also1 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.htm\n");
    return;
}
  print TMPFILE2 "<h1>SEE ALSO</h1>\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub see_also2 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.pod"))) {
      &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.pod\n");
      return;
}
  print TMPFILE2 "=head1 SEE ALSO\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub see_also3 { 
  if (!open(TMPFILE2,(">>MKCtmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_xmlConversion.txt\n");
    return;
}
  print TMPFILE2 "SEE ALSO\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------

sub trim { 
  local $_ = shift; 

  s/\n/ /g; 
  s/^\s+//; 
  s/\s+$//; 
  
  $_; 
}
#---------------------------------------------------------
sub eventXML2 {

    $levelEventXML2 = -1;
    $resultEventXML2 ="";
    my $parse = new XML::Parser(Style => 'tree');

    eval {$parse->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
    }
    else {
	@xmllistEventXML2 = $parse->parsefile($nom_fic);
    }
    print_listEventXML2(@xmllistEventXML2);
    mkPrintMsgInfo("$resultEventXML2");
}

###
#  Subroutines
###

sub print_listEventXML2 {
    my $var;

    foreach $var (@_) {
	if (ref ($var)) {
	    print_refEventXML2($var);
	} else {
	    print_scalarEventXML2($var);
	}
    }
}

sub print_scalarEventXML2 {
    ++$levelEventXML2;
    my $var = shift;
    print_indentedEventXML2($var);
    --$levelEventXML2;
}

sub print_refEventXML2 {
    my $r        = shift;
    my $ref_type = ref($r);

    if ($ref_type eq "ARRAY") {
	print_arrayEventXML2($r);
    } elsif ($ref_type eq "SCALAR") {
	print "Ref -> $r";
	print_scalarEventXML2($$r);
    } elsif ($ref_type eq "HASH") {
	print_hashEventXML2($r);
    } elsif ($ref_type eq "REF") {
	++$levelEventXML2;
	print_indentedEventXML2("Ref -> ($r)");
	print_refEventXML2($$r);
	--$levelEventXML2;
    } else {
	print_indentedEventXML2("$ref_type (not supported)");
    }
}

sub print_arrayEventXML2{
    my ($r_array) = @_;
    ++$levelEventXML2;
    print_indentedEventXML2("[ # $r_array");
    foreach $var (@$r_array) {
	if (ref ($var)) {
	    print_refEventXML2($var);
	} else {
	    print_scalarEventXML2($var);
	}
    }
    print_indentedEventXML2("]");
    --$levelEventXML2;
}

sub print_hashEventXML2 {
    my ($r_hash) = @_;
    my ($key, $val);
    ++$levelEventXML2;
    print_indentedEventXML2("{ # $r_hash");
    while (($key, $val) = each %$r_hash) {
	$val = ($val ? $val : '""');
	++$levelEventXML2;
	if (ref ($val)) {
	    print_indentedEventXML2("$key => ");
	    print_refEventXML2($val);
	} else {
	    print_indentedEventXML2("$key => $val");
	}
	--$levelEventXML2;
    }
    print_indentedEventXML2("}");
    --$levelEventXML2;
}

sub print_indentedEventXML2 {
    $spaces = ":  " x $levelEventXML2;
    $resultEventXML2.= "${spaces}$_[0]\n";
}
#-----------------------------------------
sub eventXML {

$leveleventXML = -1;  # Display item at this indent level

###
#  Create the new parser, set up the various handlers, and
#  parse the XML file.
###

my $parser = new XML::Parser(ErrorContext => 2);

$parser->setHandlers(
    Start => \&start_handlerEventXML,
    Char  => \&char_handlerEventXML,
    End   => \&end_handlerEventXML,
);

$resulteventXML="";

eval {$parser->parsefile($nom_fic)};
if ($@) {
    &mkPrintErreur("Caught Error : $@\n");
}

mkPrintMsgInfo("$resulteventXML");


}
###
#  Character and tag event handlers
###

sub start_handlerEventXML {
    my ($p, $element, %attrib) = @_;
    my $name;
    my $val;

    #  Increment our print level with the Start Tag

    $leveleventXML++;

    #  Display the element name and all the attributes

    $resulteventXML.= "   " x $leveleventXML;
    $resulteventXML.="$element ";
    
    while (($name, $val) = each %attrib) {
	 $resulteventXML.="A:$name=>$val ";
    }

    $resulteventXML.="\n";
}

sub char_handlerEventXML {
    my ($p, $text) = @_;

    #  Only display non-whitespace text

    if ($text =~ /\S+/) {
	++$leveleventXML;

	$text =~ s/^\s+//;  #  Remove beginning whitespace

	$resulteventXML.= "   " x $leveleventXML;
	$resulteventXML.= "Text:[$text]\n";
	--$leveleventXML;
    }
}

sub end_handlerEventXML {
    #  Decrement our print level

    $leveleventXML--;
}

#-----------------------------------------------
sub xmlViewver_2 {

require Tk::HList;

$statusXmlviewer2Value  = "Xml Viewer";

create_ui();

my $parser = new XML::Parser(Style => 'tree');

eval { $parser->parsefile($nom_fic)};
if ($@) {
    $statusXmlviewer2Value="Erreur XML sur le fichier";
    &mkPrintErreur("Caught Error : $@\n");
}
else {
@xmllistXmlviewer2 = $parser->parsefile($nom_fic);
}

fill_list(@xmllistXmlviewer2);
@tagsXmlviewer2;
%tag_countXmlviewer2;
}

sub fill_list {
    my $xml = shift;
    my $tag;
    my $value;

    while (@$xml) {
	$tag   = shift @$xml;
	$value = shift @$xml;

	if ($tag) {
	    $tag_countXmlviewer2{$tag}++;
	    push @tagsXmlviewer2, $tag . "." . $tag_countXmlviewer2{$tag};

	    $listXmlviewer2->add(
		get_name(),
		-text       => $tag,
		-data       => shift @$value,
		-itemtype   => 'text',
	    );

	    fill_list($value);

	    pop @tagsXmlviewer2;
	} else {
	    my $text = $value =~ s/\s+/ /g;

	    $tag_countXmlviewer2{"_value_"}++;

	    $listXmlviewer2->add(
		get_name() . "|value." . $tag_countXmlviewer2{"_value_"},
		-text       => "Value: " . $value,
		-itemtype   => 'text',
	    );
	}
    }
}

sub get_name {
    my $name = join '|', @tagsXmlviewer2;
    return $name;
}

sub create_ui {
    $mainXmlviewer2 = $mw ->Toplevel();

    my $menu_bar = $mainXmlviewer2->Frame()->pack(-side => 'top');

    $listXmlviewer2 = $mainXmlviewer2->Scrolled(
	'HList',
	-drawbranch => 1,
	-separator  => '|',
	-indent     => 15,
	-height     => 20,
	-width      => 70,
    )->pack(
	-fill       => 'both',
	-expand     => 'y',
    );

    $statusXmlviewer2 = $mainXmlviewer2->Frame()->pack(-side => 'bottom');
    $statusXmlviewer2->Label(
	-text => 'Status:'
    )->pack(
	-side => 'left',
	-padx => 2,
    );
    $statusXmlviewer2->Label(
	-textvariable => \$statusXmlviewer2Value,
	-width  => 70,
	-relief => 'sunken',
    )->pack(
	-fill => 'x',
	-padx => 2,
	-pady => 2,
    );
}


#---- XMLVIEWVER
sub xmlViewver {

my $loaded = 1;
my $ok = 1;
print "ok " . $ok++ . "\n";

my $file = "$nom_fic";

my $top = $mw->Toplevel;
$top->title("XML Viewer");
my $t2 = $top->Toplevel;
$t2->withdraw;

my $xmlwidget = $top->Scrolled('XMLViewer' ,
			    -scrollbars => "osoe")->pack;
$xmlwidget->insertXML(-file => $file);
$xmlwidget->XMLMenu;

my $xml_string1 = $xmlwidget->DumpXML;
if ($xml_string1 eq '') { print "not " } print "ok ". $ok++ . "\n";

my $xmlwidget2 = $t2->XMLViewer->pack;
if (!$xmlwidget2->isa('Tk::XMLViewer')) {print "not "} print "ok ".$ok++."\n";


$xmlwidget2->destroy;

# test internals

$xmlwidget->ShowHideRegion(1, -open => 0);
$xmlwidget->ShowHideRegion(1, -open => 1);
$xmlwidget->OpenCloseDepth(1, 0);
$xmlwidget->OpenCloseDepth(1, 1);
$xmlwidget->ShowToDepth(0);
$xmlwidget->ShowToDepth(undef);

if (!defined &Tk::XMLViewer::_convert_from_unicode) {
    print "not ";
}
print "ok " . $ok++ . "\n";

my %info = %{ $xmlwidget->GetInfo };
if ($info{Version} ne "1.0")         { print "not " } print "ok ". $ok++ ."\n";
if ($info{Encoding} ne "ISO-8859-1") { print "not " } print "ok ". $ok++ ."\n";
if ($info{Name} ne "ecollateral")    { print "not " } print "ok ". $ok++ ."\n";
if ($info{Sysid} ne "test.dtd")      { print "not " } print "ok ". $ok++ ."\n";

# definitions for interactive use...

$top->bind("<P>" => sub {
    require Config;
    my $perldir = $Config::Config{'scriptdir'};
    require "$perldir/ptksh";
});

$depth=10;
$f=$top->Frame->pack;
$f->Label(-text => "Depth",
	 #  -command => sub {
	 #      $xmlwidget->ShowToDepth($depth);
	 #  }
	 )->pack(-side => "left");
$f->Scale(-variable => \$depth,
	  -from => 1,
	  -command => sub {
	      $xmlwidget->ShowToDepth($depth);
	  },
	  -to => 10,
	  -orient => 'horiz')->pack(-side => "left");

my $okb = $f->Button(-text => "OK",
		     -command => sub { $t2->destroy; $top->destroy; })->pack(-side => "left");


$okb->focus;
$top->update;
#$top->waitVariable(\$not);

}

#--- FIN XMLVIEWVER

sub parseDTD {
 
    &mkIndisponible();
    return;

  my $parser = new DTD_Parse( Catalog => $catalog );
  $parser->parsefile('test.dtd');
  
  my $element = $parser->get_root;
  my $model = $parser->get_model( $element );
  my @children = $parser->get_children( $element );
  my @attributes = $parser->get_attributes( $element );
  
#  foreach my $att ( @atts ) {
#  print >>ATTS;
#  Name:      $att->{name}
#  Type:      $att->{type}
#  Default:   $att->{default}
#  ATTS
# print "Fixed" if $att->{fixed};
# }

}

#---XML STAT

sub bystruct
{
    my $refa = $xmlStatElements{$a};
    my $refb = $xmlStatElements{$b};

    $refa->{MINLEV} <=> $refb->{MINLEV}
	or $refa->{SEEN} <=> $refb->{SEEN};
}  # End bystruct

#---------------------------------------------
sub xmlStat {

    %xmlStatElements = ();
    my $seen = 0;
    my $root;
    
    my $file = $nom_fic;
    
    $xml_subform =
	'      @<<<<<<<<<<<<<<<      @>>>>';
    die "Can't find file \"$file\""
	unless -f $file;
    
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Start => \&start_handler1,
			 Char  => \&char_handler1);

    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    &set_minlev($root, 0);

    my $el;

    if (!open(FIC,">MKCtmp_xmlstat.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir  MKCtmp_xmlstat.txt\n");
	return;
	}
    close(FIC);
    foreach $el (sort bystruct keys %xmlStatElements)
    {
	if (!open(FIC,">>MKCtmp_xmlstat.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir  MKCtmp_xmlstat.txt\n");
	    return;
	}
	my $ref = $xmlStatElements{$el};
	print FIC "\n================\n$el: ", $ref->{COUNT}, "\n";
	print FIC "Had ", $ref->{CHARS}, " bytes of character data\n"
	    if $ref->{CHARS};
	print FIC "Always empty\n"
	    if $ref->{EMPTY};

	close(FIC);

	my $tmpfile="MKCtmp_xmlstat.txt";
	&showtab('Parents', $ref->{PTAB}, 0,$tmpfile);
	&showtab('Children', $ref->{KTAB}, 1,$tmpfile);
	&showtab('Attributes', $ref->{ATAB}, 0,$tmpfile);
	
    }

    my $tmpfile="MKCtmp_xmlstat.txt";
    my $msg="MKCtmp_xmlstat.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    $info = "Fichier  MKCtmp_xmlstat.txt charg.";

}

#---------------------------------------------
sub start_handler1
{
    my $p = shift;
    my $el = shift;

    my $elinf = $xmlStatElements{$el};

    if (not defined($elinf))
    {
	$xmlStatElements{$el} = $elinf = new Elinfo;
	$elinf->{SEEN} = $seen++;
    }

    $elinf->{COUNT}++;

    my $partab = $elinf->{PTAB};

    my $parent = $p->current_element;
    if (defined($parent))
    {
	$partab->{$parent}++;
	my $pinf = $xmlStatElements{$parent};

	# Increment our slot in parent's child table
	$pinf->{KTAB}->{$el}++;
	$pinf->{EMPTY} = 0;
    }
    else
    {
	$root = $el;
    }

    # Deal with attributes

    my $atab = $elinf->{ATAB};

    while (@_)
    {
	my $att = shift;
	
	$atab->{$att}++;
	shift;	# Throw away value
    }

}  # End start_handler

#---------------------------------------------
sub char_handler1
{
    my ($p, $data) = @_;
    my $inf = $xmlStatElements{$p->current_element};

    $inf->{EMPTY} = 0;
    if ($data =~ /\S/)
    {
	$inf->{CHARS} += length($data);
    }
}  # End char_handler

#---------------------------------------------
sub set_minlev
{
    my ($el, $lev) = @_;

    my $elinfo = $xmlStatElements{$el};
    if (! defined($elinfo->{MINLEV}) or $elinfo->{MINLEV} > $lev)
    {
	my $newlev = $lev + 1;

	$elinfo->{MINLEV} = $lev;
	foreach (keys %{$elinfo->{KTAB}})
	{
	    set_minlev($_, $newlev);
	}
    }
}  # End set_minlev



#---------------------------------------------
sub showtab
{
    my ($title, $table, $dosum,$tmpfile) = @_;

    my @list = sort keys %{$table};

	if (!open(FIC,">>$tmpfile")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir  MKCtmp_xmlstat.txt\n");
	    return;
	}

    if (@list)
    {
	print FIC "\n   $title:\n";

	my $item;
	my $sum = 0;
	foreach $item (@list)
	{
	    my $cnt = $table->{$item};
	    $sum += $cnt;
	    formline($xml_subform, $item, $cnt);
	    print FIC $ACCUMULATOR, "\n";
	    $ACCUMULATOR = '';
	}

	if ($dosum and @list > 1)
	{
	    print FIC "                            =====\n";
	    formline($xml_subform, '', $sum);
	    print FIC $ACCUMULATOR, "\n";
	    $ACCUMULATOR = '';
	}
    }

    close(FIC);
}  # End showtab

#--- FIN XML STAT

#--- XML COMMENTS

sub xmlComment {


    my $file = $nom_fic;
    die "Can't find file \"$file\""
	unless -f $file;
    
    $xml_countComments = 0;
    $xml_comments ="";
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Comment => \&comments);
    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    &mkPrintMsgInfo("Found $xml_countComments comments.\n"."$xml_comments");
    

}

#---------------------------------------------
sub comments
{
    my ($p, $data) = @_;

    my $line = $p->current_line;
    $data =~ s/\n/\n\t/g;
    $xml_comments.="$line:\t<!--$data-->\n";
    $xml_countComments++;

}  # End comments


#---------------------------------------------
sub xmlMkListBalise {

    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handler);
    @liste_xmlBalise = ();
    %Liste_xmlBalise = ();


    

    eval { $parser->parsefile($nom_fic)};
    
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
#	return;
	}

#    print "LISTE BALISE : @liste_xmlBalise\n";
    &mkSelectionXMLMarkup(@liste_xmlBalise);
    $info = "Recherche Markups sur '$nom_fic' termine.";

}


#--- FIN XML COMMENT


sub parseXML {

   my $parser = new XML::Parser(Style => 'Debug');
   eval { $parser->parsefile($nom_fic)};
   if ($@) {
       &mkPrintErreur("Caught Error : $@\n");
       return;
   }
   else {
       &mkPrintMsgInfo("Parsing OK\n");
   }
   
}

#-------------------------------------------------------
sub xml1 {

   my $parser = new XML::Parser(Style => 'Debug');
   eval { $parser->parsefile($nom_fic)};
   if ($@) {
       &mkPrintErreur("Caught Error : $@\n");
       return;
   }
   
}

#---------------------------------------------

sub xml2 {

   my $parser = new XML::Parser(Style => 'Debug');
   eval { $parser->parsefile($nom_fic)};
   if ($@) {
       &mkPrintErreur("Caught Error : $@\n");
       return;
   }
}
#---------------------------------------------
sub xml3 {

   my $parser = new XML::Parser(Style => 'Debug');
   eval { $parser->parsefile($nom_fic)};
   if ($@) {
       &mkPrintErreur("Caught Error : $@\n");
       return;
   }
}

#---------------------------------------------
sub delete_selected_baliseXML {

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXML {

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXML {

    my @selection = $listePnXMLBalise->curselection();


    %listeBaliseXml = ();
    %compteurBaliseXml = ();
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Start => \&start_handler2,
			 Char  => \&char_handler2,
			 Element => \&extracElementXML
			 );

    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    if (!open(FIC,">MKCtmp_xmlExtractContentBalise.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_xmlExtractContentBalise.txt\n");
	return;
    }

    foreach $ind (@selection) {
	my $element=$listePnXMLBalise->get($ind);
	if (exists ($listeBaliseXml{$element})) {
	    print FIC "$listeBaliseXml{$element}";

	}
    }
    close(FIC);
    my $tmpfile="MKCtmp_xmlExtractContentBalise.txt";
    my $msg="MKCtmp_xmlExtractContentBalise.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    $info = "Fichier MKCtmp_xmlExtractContentBalise.txt charg.";


}


#---------------------------------------------
sub delete_selected_baliseXMLLexico2 {

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXMLLexico2 {

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXMLLexico2 {


    my %listeCompteur=();
    my $balise_d="\(";
    my $balise_f="\(";
    my @selection = $listePnXMLLexico2Balise->curselection();

    foreach $ind (@selection) {
	$element=$listePnXMLLexico2Balise->get($ind);
	$listeCompteur{$element}=0;
	$balise_d.="(<$element>)|";
	$balise_f.="(<\/$element>)|";
    }
    chop($balise_d);
    chop($balise_f);
    $balise_d.="\)";
    $balise_f.="\)";
    print $balise_d,"\n";
    print $balise_f,"\n";

    if (!open(TMPFILE,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,">MKCtmp_extractSelectedMarkupForLexico.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_extractSelectedMarkupForLexico.txt\n");
    return;
	}

    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /($balise_d)(.*)($balise_f)/i)
			{ 
			    $balise_name=$1;
			    $balise_name=~s/[\<\>]//g;
			    $ligne =~ /<$balise_name>(.*)<\/$balise_name>/;
			    my $tmp=$1;
			    print $tmp,"\n";
			    print $balise_name,"\n";
			    print TMPFILE2 "<$balise_name=NUM".$listeCompteur{$balise_name}++.">\n";
			    print TMPFILE2 "$tmp\n";

		    }
		if (($ligne=~/($balise_d)(.*)/i) && ($ligne!~/$balise_f/i)){

		    $balise_name=$1;
		    $balise_name=~s/[\<\>]//g;
		    print $balise_name,"\n";
		    $ligne=~/<$balise_name>(.*)/;
		    my $tmp=$1;
		    print TMPFILE2 "<$balise_name=NUM".$listeCompteur{$balise_name}++.">\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/<\/$balise_name>/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)<\/$balise_name>/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";

    close (TMPFILE);
    close (TMPFILE2);

    my $tmpfile="MKCtmp_extractSelectedMarkupForLexico.txt";
    my $msg="MKCtmp_extractSelectedMarkupForLexico.txt";
    &IncludedFileInWindow($tmpfile,$msg);
     

}
#---------------------------------------------
sub delete_selected_baliseXMLLexico {

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXMLLexico {

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXMLLexico {

    my @selection = $listePnXMLLexicoBalise->curselection();


    %listeBaliseXmlLexico = ();
    %compteurBaliseXmlLexico = ();
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Start => \&start_handler3,
			 Char  => \&char_handler3,
			 Element => \&extracElementXML
			 );

    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    if (!open(FIC,">MKCtmp_xmlExtractContentBalise.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_xmlExtractContentBalise.txt\n");
	return;
    }

    foreach $ind (@selection) {
	my $element=$listePnXMLLexicoBalise->get($ind);
	if (exists ($listeBaliseXmlLexico{$element})) {
	    print FIC "$listeBaliseXmlLexico{$element}";

	}
    }
    close(FIC);
    my $tmpfile="MKCtmp_xmlExtractContentBalise.txt";
    my $msg="MKCtmp_xmlExtractContentBalise.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    $info = "Fichier MKCtmp_xmlExtractContentBalise.txt charg.";


}
	

#---------------------------------------------
sub start_handler2 {
    my $p = shift;
    my $el = shift;
    $compteurBaliseXml{$el}++;
    $listeBaliseXml{$el}.="\n<".$el."=NUM".$compteurBaliseXml{$el}.">\n";

}

#---------------------------------------------
sub char_handler2 {
    my $p = shift;
    my $data = shift;
#    $listeBaliseXml{$p->current_element}.="\n<".$p->current_element."=NUM".$compteurBaliseXml{$p->current_element}.">\n";
    $listeBaliseXml{$p->current_element}.=$data;
}

#---------------------------------------------
sub start_handler3 {
    my $p = shift;
    my $el = shift;
    $compteurBaliseXmlLexico{$el}++;
    $listeBaliseXmlLexico{$el}.="\n<".$el."=NUM".$compteurBaliseXmlLexico{$el}.">\n";

}

#---------------------------------------------
sub char_handler3 {
    my $p = shift;
    my $data = shift;
#    $listeBaliseXmlLexico{$p->current_element}.="\n<".$p->current_element."=NUM".$compteurBaliseXmlLexico{$p->current_element}.">\n";
    $listeBaliseXmlLexico{$p->current_element}.=$data;
}

#---------------------------------------------
sub extracElementXML {

}


#---------------------------------------------
sub xmlRex {

    &ShallowParse($nom_fic);
}

#---------------------------------------------
sub ShallowParse { 

# Module REX
# REX/Perl 1.0 
# Robert D. Cameron "REX: XML Shallow Parsing with Regular Expressions",
# Technical Report TR 1998-17, School of Computing Science, Simon Fraser 
# University, November, 1998.
# Copyright (c) 1998, Robert D. Cameron. 
# The following code may be freely used and distributed provided that
# this copyright and citation notice remains intact and that modifications
# or additions are clearly identified.

$TextSE = "[^<]+";
$UntilHyphen = "[^-]*-";
$Until2Hyphens = "$UntilHyphen(?:[^-]$UntilHyphen)*-";
$CommentCE = "$Until2Hyphens>?";
$UntilRSBs = "[^\\]]*](?:[^\\]]+])*]+";
$CDATA_CE = "$UntilRSBs(?:[^\\]>]$UntilRSBs)*>";
$S = "[ \\n\\t\\r]+";
$NameStrt = "[A-Za-z_:]|[^\\x00-\\x7F]";
$NameChar = "[A-Za-z0-9_:.-]|[^\\x00-\\x7F]";
$Name = "(?:$NameStrt)(?:$NameChar)*";
$QuoteSE = "\"[^\"]*\"|'[^']*'";
$DT_IdentSE = "$S$Name(?:$S(?:$Name|$QuoteSE))*";
$MarkupDeclCE = "(?:[^\\]\"'><]+|$QuoteSE)*>";
$S1 = "[\\n\\r\\t ]";
$UntilQMs = "[^?]*\\?+";
$PI_Tail = "\\?>|$S1$UntilQMs(?:[^>?]$UntilQMs)*>";
$DT_ItemSE = "<(?:!(?:--$Until2Hyphens>|[^-]$MarkupDeclCE)|\\?$Name(?:$PI_Tail))|%$Name;|$S";
$DocTypeCE = "$DT_IdentSE(?:$S)?(?:\\[(?:$DT_ItemSE)*](?:$S)?)?>?";
$DeclCE = "--(?:$CommentCE)?|\\[CDATA\\[(?:$CDATA_CE)?|DOCTYPE(?:$DocTypeCE)?";
$PI_CE = "$Name(?:$PI_Tail)?";
$EndTagCE = "$Name(?:$S)?>?";
$AttValSE = "\"[^<\"]*\"|'[^<']*'";
$ElemTagCE = "$Name(?:$S$Name(?:$S)?=(?:$S)?(?:$AttValSE))*(?:$S)?/?>?";
$MarkupSPE = "<(?:!(?:$DeclCE)?|\\?(?:$PI_CE)?|/(?:$EndTagCE)?|(?:$ElemTagCE)?)";
$XML_SPE = "$TextSE|$MarkupSPE";

my($XML_document) = @_;
$XML_document =~ /$XML_SPE/g;

}


#---------------------------------------------
sub xmlGroveTool1 {

    my $doc=$nom_fic;
    my $parser = XML::Parser->new(Style => 'grove');
    
    my $visitor = new MyVisitor;

    my $grove=$parser->parsefile($doc);
    my @context;
    $grove->accept ($visitor, \@context);
}


#---------------------------------------------
sub xmlGroveTool2 {
    my $doc = $nom_fic;
    my $parser = XML::Parser->new(Style => 'grove');
    my $grove=$parser->parsefile($doc);
    &dump_grove ($grove->iter);
}

#---------------------------------------------
sub dump_grove {
    my $element = shift;
    my $item;

    # get the names of each element in our path to the root
    my @context = $element->rootpath;
    # remove Grove object, which has no name
    shift @context;
    foreach $item (@context) {
	$item = $item->name;
    }

    # note an idea in Iter.pm to use a tied-array for the return value
    # of `$item->contents' so one could use this here:
    #
    #     foreach $item ($element->contents) {
    #     }

    $item = $element->first_child;
    while ($item) {
	if (ref ($item) =~ /::Element/) {
	    my @attributes = %{$item->attributes};
	    print STDERR "@context \\\\ (@attributes)\n";
	    dump_grove ($item);
	    print STDERR "@context //\n";
	} elsif (ref ($item) =~ /::PI/) {
	    my $target = $item->target;
	    my $data = $item->data;
	    print STDERR "@context ?? $target($data)\n";
	} elsif (ref ($item) =~ /::Scalar/) {
	    my $text = $item->delegate;
	    $text =~ s/([\x80-\xff])/sprintf "#x%X;", ord $1/eg;
	    $text =~ s/([\t\n])/sprintf "#%d;", ord $1/eg;
	    print STDERR "@context || $text\n";
	} else {
	    print STDERR "@context !! OTHER: $item\n";
	}

	$item = $item->next;
    }
}



#----------------------------- MODULE SGML ----------------------------------

sub sgml1 {

    &mkIndisponible();

}
#---------------------------------------------
sub sgml2 {

    &mkIndisponible();

}

#----------------------------- MODULE TRANSCODEURS ----------------------------------

sub rtf2html {

    &mkIndisponible();
}

#---------------------------------------------
sub rtf2xml {

    &mkIndisponible();
}
#---------------------------------------------
sub txt2html {

    &mkIndisponible();
}
#---------------------------------------------
sub perl2html {

    &mkIndisponible();
}
#---------------------------------------------
sub ps2html {

    &mkIndisponible();
}

#----------------------------- MODULE TOOLS CORPUS ----------------------------------


sub mkPrepHtml2txtOneDir {

# program: txtprep - prepares texts in html pages taken from the internet
# for use by linguistics programs such as concordancers or parsers
#
# reads each file in a directory,
# and for each file,
# strips out the html tags,
# rewrites the file as one sentence per line, 
# numbers each line with the line number and text id, 
# creates a special line zero to put a heading describing the text,
# writes the file out with a new file name
# equal to the old file name with the prefix "corp".
# Then you can
# manually write the text description in the heading.
# (Note: If you run this file multiple times on the files in a
# directory it will skip over the files you previously created 
# prefixed with "corp".)

use Data::Dumper;
$Data::Dumper::Indent = 0;        
my ($dirname,$dirnameOut,$txtnum, $fullTxtName,$init) = @_;
$dirname =~ s/\/$//;
$dirnameOut =~ s/\/$//;
$dirname =~ s/\\$//;
$dirnameOut =~ s/\\$//;
print "ROOT : $dirname\n";
#return;
#iterate over the files in the directory processing each file 

if (!opendir(DIR,("$dirname"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le rpertoire $dirname\n");
    return;
    }
@files = readdir(DIR);
closedir(DIR);


if ($init eq 0) {
    my $fullTxt = "$dirnameOut"."\/"."$fullTxtName";
    if (!open(TMP,(">$fullTxt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $fullTxt\n");
	return;
    }
    close(TMP);
}

foreach $infile (@files) {
       next if $infile =~ /^\.\.?$/;
       $file = "$dirname"."\/"."$infile";
       print "FILETOREAD : $file\n";
       if (-f "$file") { 
#	   print "FILE : $dirname$infile\n";
	   preptxt($infile,$dirname,$dirnameOut,$txtnum,$fullTxtName);
	   print "processing: $infile  text_number: $txtnum\n"; 
	   $txtnum++;
       }
       if (-d $file) {
	   my $newdir="$dirname"."\/". "$infile";
#	   print "FILEDIR : $newdir\n";
	   mkPrepHtml2txtOneDir($newdir, $dirnameOut, $txtnum,$fullTxtName,1);	
       }
   }
FINIS: print "\nEnd of Program\n";

if ($init eq 0) {
    my $tmpfile="$dirnameOut"."\/"."$fullTxtName";
    my $msg="$dirnameOut"."\/"."$fullTxtName";
    &IncludedFileInWindow($tmpfile,$msg);
}
}

#---------------------------------------------------------
# prepare the text in a given file
sub preptxt {
    my($infile,$indir,$dirnameOut,$txtnum,$fullTxt) = @_;

    $filename = "$indir\/$infile";
    print "FILETOPREP : $filename \n";
    if (!open(INFILE,("$filename"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$filename'\n");
	return;
    }
    my $tmpOutfileFull="$dirnameOut"."\/"."$fullTxt";
    if (!open(OUTFILE2,(">>$tmpOutfileFull"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$tmpOutfileFull'\n");
	return;
    }

    my @text = <INFILE>;             # read the whole file into a list
    my $text = join('', @text);    # create a string with the whole file in it
    $text =~ s/<.*?>//gs;       # strip out html tags
    $text =~ s/\s+/ /g;         # substitute spaces for carriage returns 
    
    my @sentences = ($text =~ m/(\S.*?[!?.])(?=\s)/g);  # extract sentences into an array
    
    $tmplinepreptxt = 0;
    my @sentences2 = map($_ = &lineid($_,$txtnum), @sentences);
    unshift(@sentences2,"<$txtnum:0>   ");
    
    my $outfile    = "corp-" . $infile.".prep";
    my $openstring = "$dirnameOut"."\/"."$outfile";

    if (!open(OUTFILE, ">$openstring")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$dirnameOut$outfile'\n");
	return;
    }
    print "FILE writing : $openstring\n";
    print OUTFILE2 "<FILE=$filename>\n";
    foreach $sent (@sentences2) {     
	my $translateSent=&translate($sent);
	print OUTFILE "$translateSent\n";
	print OUTFILE2 "$translateSent\n";
    }
    print OUTFILE2 "</FILE>\n";
    close(OUTFILE);
    close(OUTFILE2);
}

#---------------------------------------------------------
# prefix a text id and a line number
sub lineid {
   my($tmp,$txtnum) = @_;
   $tmplinepreptxt++;
   $tmp = "<$txtnum:$tmplinepreptxt>  " . $_[0];
   return $tmp;
}

#---------------------------------------------------------
sub mkPrepHtml2txtOneFile {


use Data::Dumper;
$Data::Dumper::Indent = 0;        
$txtnum = 1;
&preptxt2($nom_fic,$txtnum);
FINIS: print "\nEnd of Program\n";
}

#---------------------------------------------------------
sub preptxt2 {
    my($infile,$txtnum) = @_;
    if (!open(INFILE,("$infile"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$infile'\n");
	return;
    }
    my @text = <INFILE>;             # read the whole file into a list
    my $text = join('', @text);    # create a string with the whole file in it
    $text =~ s/<.*?>//gs;       # strip out html tags
    $text =~ s/\s+/ /g;         # substitute spaces for carriage returns 
    
    my @sentences = ($text =~ m/(\S.*?[!?.])(?=\s)/g);  # extract sentences into an array
    
    my $tmplinepreptxt = 0;
    my @sentences2 = map($_ = &lineid($_,$txtnum), @sentences);
    unshift(@sentences2,"<$txtnum:0>   ");
    
    $outfile    = $infile.".prep";
    $openstring = $outfile;

    if (!open(OUTFILE, ">$openstring")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$outfile'\n");
	return;
    }

    print "writing: $openstring\n";
    foreach $sent (@sentences2) {     
	my $translateSent=&translate($sent);
	print OUTFILE "$translateSent\n";
    }
    close(OUTFILE);
    my $tmpfile=$infile.".prep" ;
    my $msg=$infile.".prep" ;
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------
sub read_text_forStat { 
  my @file; 
  if (!open(TMPFILE1,("$nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic'\n");
	return;
    }
  push @file, [split] while <TMPFILE1>; 
  close(TMPFILE1);
#  print @file,"\n";
#  return \@file;
  \@file;
}
#---------------------------------------------------------
sub statFile {
    if (!open(TMPFILE,(">MKCtmp_statFile.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKCtmp_statFile.txt\n");
	return;
    }
# Variables to keep track of where we are in the file 
    my ($line, $word, $total_length);
# Variables to store stats 
    my ($num_lines, $num_words); 
    my (%words, %lengths);
    my $text = read_text_forStat();
    $num_lines = scalar @{$text}; 
    foreach $line (@{$text}) { 
	$num_words += scalar @{$line};
	foreach $word (@{$line}) {
	    $words{$word}++;
	    $lengths{length $word}++; 
	    $total_length += length $word; 
	}
    } 

    my @sorted_words = sort { $words{$b} <=> $words{$a} } keys %words;
    my @sorted_lengths = sort { $lengths{$b} <=> $lengths{$a} } keys %lengths;
    print TMPFILE "Your file contains $num_lines lines "; 
    print TMPFILE "and $num_words words\n\n"; 
    printf TMPFILE "The average word length is %.2f\n\n", $total_length / $num_words;
    print TMPFILE "The 10 most popular words were:\n";
    print TMPFILE map { "$_ ($words{$_} times)\n" } @sorted_words[0 .. 10]; 
    print TMPFILE "\nThe 10 most popular word lengths were:\n"; 
    print TMPFILE map { "$_ ($lengths{$_} words)\n" } @sorted_lengths[0 .. 10];
    close (TMPFILE);
    my $tmpfile="MKCtmp_statFile.txt" ;
    my $msg="MKCtmp_statFile.txt" ;
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------
sub readCharInText {

my $AlphaNumerique               = "A-Za-z0-9a-z" ;
my $Accentues                    = "" ;
my $Ponctuation                  = "\[\"{}&~@=*?!;,():<>%\' \+_\/.-" ;
my $Speciaux                     = "\t\r\n" ;
my %CaractereNonPrevu2Frequence  = () ;
my %Caractere2Frequence  = () ;
my %Caractere2Frequence2  = () ;

if (!open(AVERIFIER,"$nom_fic")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
    return;
}

while ($Ligne = <AVERIFIER>){
    $Ligne1 = "$Ligne";
    $Ligne1 =~ s/[$AlphaNumerique$Accentues$Speciaux$Ponctuation]//g ;
    my @ListeCaracteresLus = split(//, $Ligne);
    my @ListeCaracteresLus2 = unpack("C*",$Ligne);

    foreach $CaractereLu (@ListeCaracteresLus) {
	$Caractere2Frequence{$CaractereLu}++ ;
    }
    foreach $CaractereLu (@ListeCaracteresLus2) {
	$Caractere2Frequence2{$CaractereLu}++ ;
    }
    my @ListeCaracteresNonPrevus = split(//, $Ligne1) ;
    foreach $CaractereNonPrevu (@ListeCaracteresNonPrevus) {
	$CaractereNonPrevu2Frequence{$CaractereNonPrevu}++ ;
    }
    
}
close(AVERIFIER) ;

$FichierCaracteresNonPrevus = $nom_fic .  ".VerifieCaracteres" ;
$FichierCaracteres = $nom_fic .  ".Caracteres" ;
$FichierAscii = $nom_fic .  ".Ascii" ;

if (!open(CARACTERES, ">$FichierCaracteresNonPrevus")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteresNonPrevus'\n");
    return;
}
if (!open(CARACTERES1, ">$FichierCaracteres")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
    return;
}
if (!open(CARACTERES2, ">$FichierAscii")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
    return;
}

foreach $CaractereNonPrevu (sort { $CaractereNonPrevu2Frequence{$b} <=> $CaractereNonPrevu2Frequence{$a} } keys %CaractereNonPrevu2Frequence)
{print CARACTERES "$CaractereNonPrevu<>$CaractereNonPrevu2Frequence{$CaractereNonPrevu}\n" ;
}
foreach $CaractereLu (sort { $Caractere2Frequence2{$b} <=> $Caractere2Frequence2{$a} } keys %Caractere2Frequence2)
{print CARACTERES2 "$CaractereLu<>$Caractere2Frequence2{$CaractereLu}\n" ;
}
foreach $CaractereLu (sort { $Caractere2Frequence{$b} <=> $Caractere2Frequence{$a} } keys %Caractere2Frequence){
    if ($CaractereLu =~ /\n/){
	print CARACTERES1 "\\n<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
    elsif ($CaractereLu =~ /\t/) {
	print CARACTERES1 "\\t<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
    elsif ($CaractereLu =~ /\r/) {
	print CARACTERES1 "\\r<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
    else {
	print CARACTERES1 "$CaractereLu<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
}

close(CARACTERES) ;
close(CARACTERES1) ;
close(CARACTERES2) ;

my $tmpfile=$nom_fic .  ".VerifieCaracteres" ;
my $msg="Caractres non reconnus dans : ". $nom_fic .  ".VerifieCaracteres" ;
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$nom_fic .  ".Caracteres" ;
my $msg="Caractres lus dans : ".$nom_fic .  ".Caracteres" ;
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$nom_fic .  ".Ascii" ;
my $msg="Caractres ascii lus dans : ".$nom_fic .  ".Ascii" ;
&IncludedFileInWindow($tmpfile,$msg);

}
#---------------------------------------------
sub changeCharInText {

    if (! Exists ($pnChangeChar)) {
	$pnChangeChar = $mw ->Toplevel();
	$pnChangeChar->title("Slection Char");
	$listePnChangeChar=$pnChangeChar->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnChangeChar->Button(-text => "Delete",
		     -command =>  \&delete_selected_char)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeChar->Button(-text => "Modify",
		     -command =>  \&modify_selected_char)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeChar->Button(-text => "Search",
		     -command =>  \&concordance_char)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeChar->Button(-text => "Close",
		     -command =>  sub {$pnChangeChar->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_char= ();

	$FichierCaracteres = $nom_fic .  ".Caracteres" ;

	if (!open(TMPFILE, "$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n, ce fichier est gnr par l'item Read Char\n");
	    return;
	}
	my $id=0;
	while(<TMPFILE>) {
	    chomp;
	    if ($_=~/^(.*)<>(.*)/) {
		$liste_char[$id]=$1;
		$id++;
	    }
	}
	close(TMPFILE);
	$listePnChangeChar->delete(0,'end');
	$listePnChangeChar->insert('end',@liste_char);

    }
    else {
	$pnChangeChar->deiconify();
	$pnChangeChar->raise();
    }



}
#---------------------------------------------
sub changeUnrocognizedCharInText {

    if (! Exists ($pnChangeUnrocognizedChar)) {
	$pnChangeUnrocognizedChar = $mw ->Toplevel();
	$pnChangeUnrocognizedChar->title("Slection Char");
	$listePnChangeUnrocognizedChar=$pnChangeUnrocognizedChar->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnChangeUnrocognizedChar->Button(-text => "Delete",
		     -command =>  \&delete_selected_Unrochognizedchar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeUnrocognizedChar->Button(-text => "Modify",
		     -command =>  \&modify_selected_Unrochognizedchar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeUnrocognizedChar->Button(-text => "Search",
		     -command =>  \&concordance_Unrochognizedchar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeUnrocognizedChar->Button(-text => "Close",
		     -command =>  sub {$pnChangeUnrocognizedChar->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_char= ();

	$FichierCaracteres = $nom_fic .  ".VerifieCaracteres" ;

	if (!open(TMPFILE, "$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n, ce fichier est gnr par l'item Read Char\n");
	    return;
	}
	my $id=0;
	while(<TMPFILE>) {
	    chomp;
	    if ($_=~/^(.*)<>(.*)/) {
		$liste_char[$id]=$1;
		$id++;
	    }
	}
	close(TMPFILE);
	$listePnChangeUnrocognizedChar->delete(0,'end');
	$listePnChangeUnrocognizedChar->insert('end',@liste_char);

    }
    else {
	$pnChangeUnrocognizedChar->deiconify();
	$pnChangeUnrocognizedChar->raise();
    }



}
#---------------------------------------------
sub applyChangeInTableCharacter1 {

	my @liste_char= ();
	my %liste_charInput= ();

	$FichierCaracteres = $nom_fic .  ".VerifieCaracteres" ;

	if (!open(TMPFILE, "TableCharacter.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TableCharacter.txt\n, ce fichier est indispensable pour cette option\n");
	    return;
	}
	while(<TMPFILE>) {
	    $_=~/^(.)(.)\d/;
	    $liste_charInput{$1}=$2;	    
	    print "$1 devient $2\n";
	}
	close(TMPFILE);

	if (!open(TMPFILE,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Ouverture impossible de $nom_fic\n");
	return;
        }
	$FichierCaracteres = "$nom_fic".".modified";
	if (!open(TMPFILE2, ">$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
	    return;
	}

	my $id=0;
	while($ligne=<TMPFILE>) {
	    $id++;
	    $newline="";
	    $modification="no";
	    while ($ligne=~/(.)/g) {
		$ind=$1;
		if (exists $liste_charInput{$ind}) {
		    $newline.=$liste_charInput{$ind};
		}
		else {
		    $modification="yes";
#		    $newline.=$ind;
		    $newline.=" ";
		}
	    }
	    print TMPFILE2 "$newline\n";
	}
	close(TMPFILE);
	close(TMPFILE2);
	close(TMPFILE3);
	$FichierCaracteres = "$nom_fic".".modified";
	my $tmpfile=$FichierCaracteres;
	my $msg="Modified File : ".$FichierCaracteres;
	&IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------
sub applyChangeInTableCharacter2 {

	my @liste_char= ();
	my %liste_charInput= ();

	$FichierCaracteres = $nom_fic .  ".VerifieCaracteres" ;

	if (!open(TMPFILE, "TableCharacter.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TableCharacter.txt\n, ce fichier est indispensable pour cette option\n");
	    return;
	}
	while(<TMPFILE>) {
	    $_=~/^(.)(.)\d/;
	    $liste_charInput{$1}=$2;	    
	    print "$1 devient $2\n";
	}
	close(TMPFILE);

	if (!open(TMPFILE,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Ouverture impossible de $nom_fic\n");
	return;
        }
	$FichierCaracteres = "$nom_fic".".modified";
	if (!open(TMPFILE2, ">$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
	    return;
	}
	$FichierCaracteres = "$nom_fic".".modification";
	if (!open(TMPFILE3, ">$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
	    return;
	}
	print TMPFILE3 "Liste modifications : \n";
	print TMPFILE3 "--------------------- \n\n";

	my $id=0;
	while($ligne=<TMPFILE>) {
	    $id++;
	    $newline="";
	    $modification="no";
	    while ($ligne=~/(.)/g) {
		$ind=$1;
		if (exists $liste_charInput{$ind}) {
		    $newline.=$liste_charInput{$ind};
		}
		else {
		    $modification="yes";
#		    $newline.=$ind;
		    $newline.=" ";
		    print TMPFILE3 "--------------------------------------------------------\n";
		    print TMPFILE3 "Ligne ($id) ->  modifie : \n";
		    print TMPFILE3 "$ligne";
		    print TMPFILE3 "Caractre remplac par un blanc : char =<$ind> ascii=<".ord($ind)."> \n";
		    
		}
	    }
	    if ($modification eq "yes") {print TMPFILE3 "Ligne ($id) -> Rcriture (entre chevron) :\n<$newline>\n";} 
	    print TMPFILE2 "$newline\n";
	}
	close(TMPFILE);
	close(TMPFILE2);
	close(TMPFILE3);
	$FichierCaracteres = "$nom_fic".".modified";
	my $tmpfile=$FichierCaracteres;
	my $msg="Modified File : ".$FichierCaracteres;
	&IncludedFileInWindow($tmpfile,$msg);
	$FichierCaracteres = "$nom_fic".".modification";
	my $tmpfile=$FichierCaracteres;
	my $msg="Modification : ".$FichierCaracteres;
	&IncludedFileInWindow($tmpfile,$msg);

}


#---------------------------------------------
sub changeAsciiInText {

    if (! Exists ($pnChangeAscii)) {
	$pnChangeAscii = $mw ->Toplevel();
	$pnChangeAscii->title("Slection Char");
	$listePnChangeAscii=$pnChangeAscii->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnChangeAscii->Button(-text => "Delete",
		     -command =>  \&delete_selected_ascii)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeAscii->Button(-text => "Modify",
		     -command =>  \&modify_selected_ascii)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeAscii->Button(-text => "Search",
		     -command =>  \&concordance_Asciichar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeAscii->Button(-text => "Close",
		     -command =>  sub {$pnChangeAscii->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_char= ();

	$FichierCaracteres = $nom_fic .  ".Ascii" ;

	if (!open(TMPFILE, "$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n, ce fichier est gnr par l'item Read Char\n");
	    return;
	}
	my $id=0;
	while(<TMPFILE>) {
	    chomp;
	    if ($_=~/^(.*)<>(.*)/) {
		$liste_char[$id]=$1;
		$id++;
	    }
	}
	close(TMPFILE);
	$listePnChangeAscii->delete(0,'end');
	$listePnChangeAscii->insert('end',@liste_char);
    }
    else {
	$pnChangeAscii->deiconify();
	$pnChangeAscii->raise();
    }
}
#---------------------------------------------
sub makepmap {
    &make_text2map;
}
#---------------------------------------------

sub maketagmap {
    &mkIndisponible();
}

#---------------------------------------------
sub lexico1 {

    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handlerLexico);
    @liste_xmlLexicoBalise = ();
    %Liste_xmlLexicoBalise = ();
    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
#	return;
	}
#    print "LISTE BALISE : @liste_xmlBalise\n";
    &mkSelectionXMLLexicoMarkup(@liste_xmlLexicoBalise);
    $info = "Recherche Markups sur '$nom_fic' termine.";
}
#---------------------------------------------
sub lexico2 {
    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handlerLexico);
    @liste_xmlLexicoBalise2 = ();
    %Liste_xmlLexicoBalise2 = ();
    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
#	return;
	}
    &mkSelectionXMLLexicoMarkup2(@liste_xmlLexicoBalise2);
}
#---------------------------------------------
sub lexico3 {

    &mkIndisponible();

}
#---------------------------------------------
sub help_lexico4 {
    if (! Exists ($pn1)) {
	$pn1 = $mw ->Toplevel();
	$pn1->title("HELP");
	my $texte2 = $pn1->Scrolled("TextUndo")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	my $tmpfile="Doc/lexico4.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

sub lexico4 {

    if (!open(INPUT,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(OUTPUT,">MKCtmp_lexico4.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_lexico4.txt\n");
    return;
	}
    while ($ligne =<INPUT>){
	if ($ligne=~/[A-Z]/){
	    $ligne=~s/<([^>]+)>/<\L$1>/gi;
	    $ligne=~s/([A-Z])/*\l$1/g;
	    $ligne=~s/<([^>]+)>/<\U$1>/gi;

	}
	print OUTPUT $ligne ;
    }
    close (INPUT );
    close (OUTPUT) ;
    my $tmpfile="MKCtmp_lexico4.txt";
    my $msg="MKCtmp_lexico4.txt";
    &IncludedFileInWindow($tmpfile,$msg);


}
#---------------------------------------------
sub help_lexico5 {
    if (! Exists ($pn1)) {
	$pn1 = $mw ->Toplevel();
	$pn1->title("HELP");
	my $texte2 = $pn1->Scrolled("TextUndo")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	my $tmpfile="Doc/lexico5.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

sub lexico5 {

    if (!open(INPUT,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(OUTPUT,">MKCtmp_lexico5.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_lexico5.txt\n");
	return;
    }
    
    while ($ligne =<INPUT>){
	if ($ligne =~ /^\s*\d+\s([^\d]+)(.*).$/){
	    $SegmentOuForme = $1 ;
	    if ($SegmentOuForme   !~ /^$MotsAEnlever /i && $SegmentOuForme   !~ / $MotsAEnlever\s+$/i) {
		print OUTPUT $ligne ;
	    }
	}
	else { 
	    print $ligne ;
	}
    }
    close (INPUT );
    close (OUTPUT) ;
    my $tmpfile="MKCtmp_lexico5.txt";
    my $msg="MKCtmp_lexico4.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------
sub help_lexico6 {
    if (! Exists ($pn1)) {
	$pn1 = $mw ->Toplevel();
	$pn1->title("HELP");
	my $texte2 = $pn1->Scrolled("TextUndo")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	my $tmpfile="Doc/lexico6.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

sub lexico6 {

    if (!open(INPUT,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(OUTPUT,">MKCtmp_lexico6.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_lexico6.txt\n");
	return;
    }
    while ($ligne =<STDIN>){
	if ($ligne =~ /F= +([0-9]+) +(.*)/) {
	    $Frequence = $1 ;
	    $Segment   = $2 ;
	    if ($Segment   !~ /^$MotsAEnlever /i && $Segment   !~ / $MotsAEnlever\r$/i) {
		print OUTPUT "$Frequence $Segment\n" ;
	    }
	}
    }
    close (INPUT );
    close (OUTPUT) ;
    my $tmpfile="MKCtmp_lexico6.txt";
    my $msg="MKCtmp_lexico6.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------
sub alceste1 {

    &mkIndisponible();
}

#---------------------------------------------
sub alceste2 {

    &mkIndisponible();
}
#---------------------------------------------
sub help_cordial {
    if (! Exists ($pnCordial)) {
	$pnCordial = $mw ->Toplevel();
	$pnCordial->title("Aide Cordial");
	my $texte2 = $pnCordial->Scrolled("TextUndo")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);
	$texte2->Text(-setgrid => 'true');
	$texte2->insert("end","##############################################################################\n");
	$texte2->insert("end","B. Habert\n");
	$texte2->insert("end","17.02.00\n");
	$texte2->insert("end","Format d\'entre : \n");
	$texte2->insert("end","     Sorties de Cordial 6 universits avec des tiquettes au format GRACE. Exemple :\n");
	$texte2->insert("end","N mot  mot     lemme   Codegram\n");
	$texte2->insert("end","        ==== DEBUT DE PHRASE ====\n");
	$texte2->insert("end","0       \r<#Art-513-1>\r\n");
	$texte2->insert("end","1       Repenser        repenser        Vmn--\n");
	$texte2->insert("end","2       la      le      Da-fs-d\n");
	$texte2->insert("end","3       loi     loi     Ncfs\n");
	$texte2->insert("end","4       de      de      Sp\n");
	$texte2->insert("end","5       fixation        fixation        Ncfs\n");
	$texte2->insert("end","6       des     de      Da-.p-i\n");
	$texte2->insert("end","7       prix    prix    Ncmp\n");
	$texte2->insert("end","8        \n");
	$texte2->insert("end","        ===== FIN DE PHRASE =====\n");
	$texte2->insert("end","        ==== DEBUT DE PHRASE ====\n");
	$texte2->insert("end","Attention, il s'agit d'un fichier Windows dont les fins de lignes sont marques par \r\n\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","Format de sortie :\n");
	$texte2->insert("end","     Chaque fin de phrase est remplace par la mention de <BLOC>. Pour chaque item, son lemme et sa catgorie, soudes par un sparateur dont il faut vrifier qu'il n'est pas employ dans le texte tiquet. Exemple :\n");
	$texte2->insert("end","repenser_V\n");
	$texte2->insert("end","le_D\n");
	$texte2->insert("end","loi_N\n");
	$texte2->insert("end","de_S\n");
	$texte2->insert("end","fixation_N\n");
	$texte2->insert("end","de_D\n");
	$texte2->insert("end","prix_N\n");
	$texte2->insert("end","<BLOC>\n");
	$texte2->insert("end","le_D\n");
	$texte2->insert("end","article_N\n");
	$texte2->insert("end","45_N\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","NB : pour ne pas parpiller les lemmes, on ne garde que la partie du discours et pas les traits supplmentaires. Sinon, on obtiendrait :\n");

	$texte2->insert("end","\n");
	$texte2->insert("end","repenser_Vmn--\n");
        $texte2->insert("end","le_Da-fs-d\n");
        $texte2->insert("end","loi_Ncfs\n");
        $texte2->insert("end","de_Sp\n");
        $texte2->insert("end","fixation_Ncfs\n");
        $texte2->insert("end","de_Da-.p-i\n");
        $texte2->insert("end","prix_Ncmp\n");
        $texte2->insert("end","<BLOC>\n");
        $texte2->insert("end","le_Da-ms-d\n");
        $texte2->insert("end","article_Ncms\n");
        $texte2->insert("end","45_Ncm.\n");
        $texte2->insert("end","A faire :\n");
        $texte2->insert("end","Bugs et problmes :\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","\n");
	$pnCordial->Button(-text => "Close",
		     -command =>  sub {$pnCordial->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);
	my $w_save=$pnCordial->Button(-text => "Save",
			   -image => $imageSave,
			   -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pnCordial->deiconify();
	$pnCordial->raise();
    }
}

#---------------------------------------------
sub cordial2 {


    if (!open(RES1,(">".$start_dir."cordial/cordial_format1.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format1.txt\n");
	return;
    }
    if (!open(RES2,(">".$start_dir."cordial/cordial_format2.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format2.txt\n");
	return;
    }
    if (!open(RES3,(">".$start_dir."cordial/cordial_format3.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format3.txt\n");
	return;
    }
    if (!open(TMPFILE,$nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic\n");
	return;
    }

#ouvrir la sortie de cordial6 et lui donner un nom ETIQUETTE comme handle de #fichier

my @lines = <TMPFILE>;

close (TMPFILE);

# on stocke la sortie de Cordial6 dans @lines et ferme la liste

#ouvrir trois nouveaux fichiers. Chaque fichier contiendra un rsultat diffrent

my $text="";
my $text1="";
my $text2="";


# initialiser trois variables. On y colle les lments de la liste. 

foreach $line(@lines){ # traiter chaque lment de @lines

chomp ($line);

#supprimer des retours de chariot 

$line =~ s/^\s+[\w \W]*//;

# effacer toutes les lignes qui ne commencent par des espaces
# cest  dire des marqueurs de ligne 

$line =~ s/^\d+[^< > \( \)=\.,!?:+]+([< > \( \)=\.,!?:+]).*/$1/; 

# conserver  < > = :,!?+ mais jeter leur lemme et leur catgorie.

$line =~ s/^\d+\s+([\w        '  ]+)\s+([\w        '  ]+)\s+(\w+)/$1#$2#$3/;

# combiner les mots et leurs lemmes et leurs catgories par un unificateur #  #  # En franais, on doit tenir compte des accents

$text .=" $line"; 

# concatner chaque lment  $text # construire une ligne de texte

} # la fin de loop foreach

$text =~ s/<\s([\w        ']+)#([\w        ']+)#(\w+)\s+= ([\w        ']+)#([\w        ']+)#(\w+)\s+>/<$1 = $4>/g;

# les motifs < mot#lemme#catgorie = mot#lemme#catgorie > sont remplacer # par <mot = mot(numro)> # les cls sont redevenues en forme comme <jour = 1> 

$text =~ s/ ([\. , ? ! : ])/$1/g;

#supprimer un espace devant les caractres. Cet espace a t ajout au # moment de la concatnation. Remarquons quil y a un espace devant $line # de $text .=  $line  ; 

$text =~ s/([> \w \.])\s*</$1\n\n</g;

$text =~ s/>/>\n/g;

# pour la raison de lisibilit des fichiers de sortie, changer la ligne aprs la # cl

$text2=$text1=$text;

# crer 2 copies de $text

$text =~ s/([\w        '  ]+)#([\w        '  ]+)#(\w+)/$1_$3/g;

# chaque mot et leur catgorie sunifient de lunificateur -

$text1 =~ s/([\w        '   ]+)#([\w        '  ]+)#(\w+)/ $2_$3/g;

# chaque lemme et leur catgorie sunifient

$text2 =~ s/([\w        '  ]+)#([\w        '  ]+)#(\w+)/ $3/g;

# on ne garde que les catgories

print RES1 $text;
print RES2 $text1;
print RES3 $text2;

#enregistrer le rsultat dans les trois fichiers en criture 

close (RES1);
close (RES2);
close (RES3);

#fermer ces trois fichiers

my $tmpfile=$start_dir."cordial/cordial_format1.txt";
my $msg=$start_dir."cordial/cordial_format1.txt";
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$start_dir."cordial/cordial_format2.txt";
my $msg=$start_dir."cordial/cordial_format2.txt";
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$start_dir."cordial/cordial_format3.txt";
my $msg=$start_dir."cordial/cordial_format3.txt";
&IncludedFileInWindow($tmpfile,$msg);
 
}


#---------------------------------------------
sub cordial {


my $Forme      = "" ;
my $Lemme      = "" ;
my $Categorie  = "" ;
my $Separateur = "_" ;

    if (!open(RES1,(">".$start_dir."cordial/cordial_format1.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format1.txt\n");
	return;
    }
    if (!open(RES2,(">".$start_dir."cordial/cordial_format2.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format2.txt\n");
	return;
    }
    if (!open(RES3,(">".$start_dir."cordial/cordial_format3.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format3.txt\n");
	return;
    }
    if (!open(RES4,(">".$start_dir."cordial/cordial_format4.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format4.txt\n");
	return;
    }
    if (!open(RES5,(">".$start_dir."cordial/cordial_format5.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format5.txt\n");
	return;
    }
    if (!open(TMPFILE,$nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic\n");
	return;
    }


while ($Ligne = <TMPFILE>){
 if ($Ligne =~ /DEBUT DE PHRASE/ 
     ||
     $Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
     ||
     $Ligne =~ /^0\t/
     ||
     $Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
     ||
     $Ligne =~ /Mc\.\./
     ||
     $Ligne =~ /^[0-9]+[\t ]+\r/)
  # Ce sont des lignes qu'on limine
  { 
  }
  elsif ($Ligne =~ /FIN DE PHRASE/)
        {
         print RES1 "<BLOC>\n" ; 
         print RES2 "<BLOC>\n" ; 
         print RES3 "<BLOC>\n" ; 
         print RES4 "<BLOC>\n" ; 
         print RES5 "<BLOC>\n" ; 
        }
  elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t(.)([^\r]+)/)
        {$Forme = $1 ;
         $Lemme = $2 ;
         $Categorie = $3 ;
         $Traits    = $4 ;
         print RES1 "$Lemme$Separateur$Forme$Separateur$Categorie$Traits " ;
         print RES2 "$Lemme$Separateur$Categorie " ;
         print RES3 "$Forme$Separateur$Categorie " ;
         print RES4 "$Forme " ;
         print RES5 "$Categorie$Traits$Separateur$Lemme$Separateur$Forme " ;
        }
}


close RES1;
close RES2;
close RES3;
close RES4;
close RES5;
close TMPFILE;

my $tmpfile=$start_dir."cordial/cordial_format1.txt";
my $msg=$start_dir."cordial/cordial_format1.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordial_format2.txt";
my $msg=$start_dir."cordial/cordial_format2.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordial_format3.txt";
my $msg=$start_dir."cordial/cordial_format3.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordial_format4.txt";
my $msg=$start_dir."cordial/cordial_format4.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordial_format5.txt";
my $msg=$start_dir."cordial/cordial_format5.txt";
&IncludedFileInWindow($tmpfile,$msg);


}


#---------------------------------------------
sub cordial2Lexico {


my $Forme      = "" ;
my $Lemme      = "" ;
my $Categorie  = "" ;
my $Separateur = "_" ;

    if (!open(RES1,(">".$start_dir."cordial/cordialLemCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemCat.txt\n");
	return;
    }
    if (!open(RES2,(">".$start_dir."cordial/cordialFormCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialFormCat.txt\n");
	return;
    }
    if (!open(RES3,(">".$start_dir."cordial/cordialCateg.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
	return;
    }
    if (!open(RES4,(">".$start_dir."cordial/cordialForme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
	return;
    }
    if (!open(RES5,(">".$start_dir."cordial/cordialLemme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
	return;
    }
    if (!open(TMPFILE,$nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic\n");
	return;
    }


while ($Ligne = <TMPFILE>){
    $Ligne =~ s/\r//g;
    if ($Ligne =~ /DEBUT DE PHRASE/ 
	||
	$Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
	||
	$Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
	||
	$Ligne =~ /Mc\.\./
	||
	$Ligne =~ /^[0-9]+[\t ]+\r/)
	# Ce sont des lignes qu'on limine
    { 
    }
    elsif ($Ligne =~ /^[0-9]+\t.*</) {
	my $baliseAgarder="<";
	$Ligne=<TMPFILE>;
	until ($Ligne=~/>/){
	    $Ligne =~ /^[0-9]+\t([^\t]+)/;
	    my $tmp=$1;
	    chomp($tmp);
	    $baliseAgarder.=$tmp;
	    $Ligne=<TMPFILE>;
	    break if $Ligne == EOF;
	}
	$baliseAgarder.=">";
	if ($baliseAgarder!~/<[^=]+=[^=>]+>/) {
	    if ($baliseAgarder=~/<[^=-]+-[^-=>]+>/) {
		$baliseAgarder=~s/(<[^=-]+)-([^-=>]+>)/$1=$2/;
	    }
	}
	print RES1 "$baliseAgarder" ;
	print RES2 "$baliseAgarder" ;
	print RES3 "$baliseAgarder" ;
	print RES4 "$baliseAgarder" ;
	print RES5 "$baliseAgarder" ;
	next;
    }
    elsif ($Ligne =~ /FIN DE PHRASE/)
    {
	print RES1 "\n" ; 
	print RES2 "\n" ; 
	print RES3 "\n" ; 
	print RES4 "\n" ; 
	print RES5 "\n" ; 
    }
    elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t([^\t]+)/)
    {
	$Forme = $1 ;
	$Lemme = $2 ;
	$Categorie = $3 ;
	print RES1 "$Lemme$Separateur$Categorie " ;
	print RES2 "$Forme$Separateur$Categorie " ;
	if (($Categorie=~/PCTFORTE/) || ($Categorie=~/PCTFAIB/)) {
	    print RES3 "$Categorie $Forme " ;
	}
	else {
	    print RES3 "$Categorie " ;
	}
	print RES4 "$Forme " ;
	print RES5 "$Lemme " ;
    }
}

close RES1;
close RES2;
close RES3;
close RES4;
close RES5;
close TMPFILE;

if (!open(RESFULL,(">".$start_dir."cordial/cordial2lexico.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial2lexico.txt\n");
    return;
}
if (!open(RES5,($start_dir."cordial/cordialCateg.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($start_dir."cordial/cordialForme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
    return;
    }
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($start_dir."cordial/cordialLemme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
close (RESFULL);


my $tmpfile=$start_dir."cordial/cordialLemCat.txt";
my $msg=$start_dir."cordial/cordialLemCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialFormCat.txt";
my $msg=$start_dir."cordial/cordialFormCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialCateg.txt";
my $msg=$start_dir."cordial/cordialCateg.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialForme.txt";
my $msg=$start_dir."cordial/cordialForme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialLemme.txt";
my $msg=$start_dir."cordial/cordialLemme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordial2lexico.txt";
my $msg=$start_dir."cordial/cordial2lexico.txt";
&IncludedFileInWindow($tmpfile,$msg);


&mkPrintMsgInfo("Gnration des sorties Cordial->Lexico termine\n,\nFichiers contenus dans ". $start_dir."cordial/ : \ncordialCateg.txt, cordialForme.txt, cordialLemme.txt, cordialFormCat.txt, cordialLemCat.txt, cordial2lexico.txt.\n");

}


#---------------------------------------------
sub cordial2Lexico2 {


my $Forme      = "" ;
my $Lemme      = "" ;
my $Categorie  = "" ;
my $Separateur = "_" ;

    if (!open(RES1,(">".$start_dir."cordial/cordialLemCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemCat.txt\n");
	return;
    }
    if (!open(RES2,(">".$start_dir."cordial/cordialFormCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialFormCat.txt\n");
	return;
    }
    if (!open(RES3,(">".$start_dir."cordial/cordialCateg.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
	return;
    }
    if (!open(RES4,(">".$start_dir."cordial/cordialForme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
	return;
    }
    if (!open(RES5,(">".$start_dir."cordial/cordialLemme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
	return;
    }
    if (!open(TMPFILE,$nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic\n");
	return;
    }


while ($Ligne = <TMPFILE>){
    $Ligne =~ s/\r//g;
    if ($Ligne =~ /DEBUT DE PHRASE/ 
	||
	$Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
	||
	$Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
	||
	$Ligne =~ /Mc\.\./
	||
	$Ligne =~ /^[0-9]+[\t ]+\r/)
	# Ce sont des lignes qu'on limine
    { 
    }
    elsif ($Ligne =~ /^[0-9]+\t.*</) {
	my $baliseAgarder="<";
	$Ligne=<TMPFILE>;
	until ($Ligne=~/>/){
	    $Ligne =~ /^[0-9]+\t([^\t]+)/;
	    my $tmp=$1;
	    chomp($tmp);
	    $baliseAgarder.=$tmp;
	    $Ligne=<TMPFILE>;
	    break if $Ligne == EOF;
	}
	$baliseAgarder.=">";
	if ($baliseAgarder!~/<[^=]+=[^=>]+>/) {
	    if ($baliseAgarder=~/<[^=-]+-[^-=>]+>/) {
		$baliseAgarder=~s/(<[^=-]+)-([^-=>]+>)/$1=$2/;
	    }
	}
	print RES1 "$baliseAgarder" ;
	print RES2 "$baliseAgarder" ;
	print RES3 "$baliseAgarder" ;
	print RES4 "$baliseAgarder" ;
	print RES5 "$baliseAgarder" ;
	next;
    }
    elsif ($Ligne =~ /FIN DE PHRASE/)
    {
	print RES1 "\n" ; 
	print RES2 "\n" ; 
	print RES3 "\n" ; 
	print RES4 "\n" ; 
	print RES5 "\n" ; 
    }
    elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t([^\t]+)/)
    {
	$Forme = $1 ;
	$Lemme = $2 ;
	$Categorie = $3 ;
	print RES1 "$Lemme$Separateur$Categorie " ;
	print RES2 "$Forme$Separateur$Categorie " ;
	if (($Categorie=~/PCTFORTE/) || ($Categorie=~/PCTFAIB/)) {
	    print RES3 "~1$Categorie $Forme " ;
	}
	else {
	    print RES3 "~1$Categorie " ;
	}
	print RES4 "$Forme " ;
	if (($Categorie=~/PCTFORTE/) || ($Categorie=~/PCTFAIB/)) {
	    print RES5 "$Lemme " ;
	}
	else {
	    print RES5 "~2$Lemme " ;
	}
    }
}

close RES1;
close RES2;
close RES3;
close RES4;
close RES5;
close TMPFILE;

if (!open(RESFULL,(">".$start_dir."cordial/cordial2lexico.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial2lexico.txt\n");
    return;
}
if (!open(RES5,($start_dir."cordial/cordialCateg.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($start_dir."cordial/cordialForme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
    return;
    }
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($start_dir."cordial/cordialLemme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
close (RESFULL);


my $tmpfile=$start_dir."cordial/cordialLemCat.txt";
my $msg=$start_dir."cordial/cordialLemCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialFormCat.txt";
my $msg=$start_dir."cordial/cordialFormCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialCateg.txt";
my $msg=$start_dir."cordial/cordialCateg.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialForme.txt";
my $msg=$start_dir."cordial/cordialForme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordialLemme.txt";
my $msg=$start_dir."cordial/cordialLemme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$start_dir."cordial/cordial2lexico.txt";
my $msg=$start_dir."cordial/cordial2lexico.txt";
&IncludedFileInWindow($tmpfile,$msg);


&mkPrintMsgInfo("Gnration des sorties Cordial->Lexico termine\n,\nFichiers contenus dans ". $start_dir."cordial/ : \ncordialCateg.txt, cordialForme.txt, cordialLemme.txt, cordialFormCat.txt, cordialLemCat.txt, cordial2lexico.txt.\n");

}

#----------------------------- MODULE TYPWEB ----------------------------------
sub loadUploading {

    &mkIndisponible();
    return;

my $debug      = 1;
my $remserver  = undef;
my $remport    = '21';
my $user       = 'anonymous';
my $password   = 'me@foo.bar';
my $dir        = '.';
my $localdir   = './';
my $curxfermode = 'ASCII';

unless (GetOptions("d" => \$debug,
                   "s=s" => \$remserver,
                   "r=s" => \$dir,
                   "p=i" => \$remport,
                   "u=s" => \$user,
                   "w=s" => \$password,
                   "l=s" => \$localdir
                   ))
{
    usageUploading();
}

usageUploading() unless $remserver;

$localdir = './' unless ($localdir);
my $ftp = Net::FTP->new($remserver, 'Port' => $remport);
die "Could not connect to $remserver" unless $ftp;
$ftp->login($user, $password) 
    or die "Couldn't login to $remserver";
$ftp->cwd($dir) 
    or die "Invalid directory ($dir) on FTP Server";
$ftp->ascii()
    or warn "Couldn't change default xfer mode, continuing";

chdir($localdir);
my $currentdir = getcwd();
find(\&sendfile,'.');

$ftp->quit();


}
sub sendfile
{
    my $file      =  $File::Find::name;
    $file         =~ s#^\./##g;
    my $localfile =  "$currentdir/$file";
    $localfile    =~ s#//#/#g;
    my $remfile   =  $file;

    print "Processing $localfile rem($remfile)\n" if $debug;

    if (-d $localfile)
    {
        my $remcurdir = $ftp->pwd();
        unless($ftp->cwd($remfile))
        {
            unless ($localfile eq '..')
            {
                print "Attempting to make directory $remfile\n";
                $ftp->mkdir($remfile,1) or 
                    die "Couldn't make directory $remfile";
            }
        }
        else
        {
            $ftp->cwd($remcurdir) or
                die "Couldn't change to directory $currentdir";
        }
    }
    else
    {
        my ($remtime,$localtime,$upload) = (undef,undef,0);
        unless($remtime = $ftp->mdtm($remfile))
        {
            $remtime = 0;
        }
        $localtime = (stat($file))[9];
        if (defined($localtime) and defined($remtime))
        {
            if ($localtime > $remtime)
            {
                $upload=1;
            }
        }
        else
        {
            $upload=1;
        }
        if ($upload)
        {
            if (-B $localfile)
            {
                if ($curxfermode eq 'ASCII')
                {
                    if ($ftp->binary())
                    {
                        $curxfermode = 'BIN';
                        print "Changed mode to BINary\n" 
                            if $debug;
                    }
                    else
                    {
                        warn "Couldn't change transfer mode";
                    }
                }
            }
            else
            {
                if ($curxfermode eq 'BIN')
                {
                    if ($ftp->ascii())
                    {
                        $curxfermode = 'ASCII';
                        print "Changed mode to ASCII\n" 
                            if $debug;
                    }
                    else
                    {
                        warn "Couldn't change transfer mode";
                    }
                }
            }
            print "Uploading $localfile to $remfile\n" if $debug;
            $ftp->put($localfile,$remfile) 
                or warn "Couldn't upload $remfile";
        }
        else
        {
            print "File $remfile appears to be up to date\n" 
                if $debug;
        }
    }
}

sub loadWget {
    my ($host,$localdir);
    system("Program/wget/bin/wget $host");

}

#------------------------DEBUT MIRRORING---------------
sub loadMirroring {
    my ($file,$host,$localdir,$curhost);
#    my ($url, $specdir, $quiet, $silent, $inchost, $unrestrict) = @_;
    my ($url, $specdir) = @_;
    print $url, "1\n";
    print $specdir, "1\n";
    $quiet = 0;
    $silent = 1;
    my %fullurl;
#    my @urlstack = ($url);
    @urlstack = ($url);
#    my @urls = ();
    @urls = ();
    my $p = HTML::LinkExtor->new(\&callback);
    print @urls, "\n";
    my $ua = new LWP::UserAgent;
  
    print $url, "2\n";
    print $specdir, "2\n";

    my $res = $ua->request(HTTP::Request->new(GET => $url));
    print $res, "3\n";
    print $url, "3\n";
    print $specdir, "3\n";

    eval { $res->base };
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    my $base = $res->base;

    print $url, "4\n";
    print $specdir, "4\n";

    $curhost = $host = url($url,'')->host;
    print "Retrieving from $url to $specdir", ($inchost ? "$host\n" : "\n") unless ($silent);
    while ($url = pop(@urlstack)){
	$host = url($url,'')->host;
	if ($host ne $curhost) {
	    my $ua = new LWP::UserAgent;
	    my $res = $ua->request(HTTP::Request->new(GET => $url));
	    my $base = $res->base;
	    $host = url($url,'')->host;
	    $curhost = $host;
	    print "Changing host to $host\n" unless $quiet;
	} 
	$localdir = ($inchost ? "$specdir$host/" : "$specdir/");
	$file = url($url,$base)->full_path;
	if ($file =~ /\/$/) {$file .= "index.html" };
	$file =~ s/^\//$localdir/;
	print "Retrieving: $url to $file\n" unless ($quiet);
	my $dir = dirname($file);
	unless (-d $dir)
	{
	    mkdirhier($dir);
	}
	getfile($url,$file);
	if (-e $file)
	{
	    $p->parse_file($file);
	    @urls = map { $_ = url($_, $base)->abs; } @urls;
	    addtostack(@urls);
	}
    }
}

sub loadMirroringPage {

    my ($url, $specdir) = @_;
    print $url, "1\n";
    print $specdir, "1\n";
    my $page_contents = get("$url");
    if (!open(RES5,(">".$start_dir."loadMirroringPage.htm"))) {
	&mkPrintErreur("ERREUR : Impossible de crer le fichier loadMirroringPage.htm\n");
	return;
    }
    print RES5 $page_contents;
    close (RES5);
    my $file = $start_dir."loadMirroringPage.htm";
    my $msg = $start_dir."loadMirroringPage.htm";
    &IncludedFileInWindow($file,$msg);

}
#---------------------------------------
sub addtostack {
    my (@urllist) = @_;
    for my $url (@urllist) {
        next if ($url =~ /\#/);
	next unless ($url =~ /^http/);
	my $urlhost = url($url,$base)->host;
	unless (defined($unrestrict)) { next unless ($urlhost eq $host); };
        push(@urlstack,$url) unless(defined($fullurl{$url}));
        $fullurl{$url} = 1;
    }
}
#---------------------------------------
sub callback {
    my($tag, %attr) = @_;
    push(@urls, values %attr);
}
#---------------------------------------
sub getfile {
    my ($url,$file) = @_;
    my $rc = mirror($url, $file);
    
    if ($rc == 304) {
        print "File is up to date\n" unless ($quiet);
    } 
    elsif (!is_success($rc)){
        warn "sitemirr: $rc ", status_message($rc), " ($url)\n" 
            unless ($silent);
        return(0);
    }
}
#---------------------------------------
sub mkdirhier {
    my ($fullpath) = @_;
    my $path;
    for my $dir (split("/",$fullpath)){
        unless (-d "$path$dir") {
            mkdir("$path$dir",0777) 
                or die "Couldn't make directory $path/$dir: $!";
        }
        $path .= "$dir/";
    }
}

#------------------------FIN MIRRORING---------------
#--------------------------------------------------------------------------
sub webxref1 {
    &query_dir_webxref;
}

#---------------------------------------------
sub webxref2 {
        $nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref.pl -html  $nom_fic\n";
	eval { system("perl $dir0"."webxref.pl -html  $nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	$info="Gnration des rapports HTML via WebXref termine";

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }

sub webxref11 {
    &query_dir_webxref2;
}

sub webxref111 {
    &query_dir_webxref22;
}
sub webxref1111 {
    &query_dir_webxref222;
}

#---------------------------------------------
sub webxref22 {
        $nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref2.pl -html  $nom_fic\n";
	eval { system("perl $dir0"."webxref2.pl -html  $nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	$info="Gnration des rapports HTML via WebXref termine";

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }

#---------------------------------------------
sub webxref222 {
        $nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref3.pl -html  $nom_fic\n";
	eval { system("perl $dir0"."webxref3.pl -html  $nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	$info="Gnration des rapports HTML via WebXref termine";

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
#---------------------------------------------
sub webxref2222 {
        $nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref3.pl -html -lynx $nom_fic\n";
	eval { system("perl $dir0"."webxref3.pl -html -lynx  $nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	$info="Gnration des rapports HTML via WebXref termine";

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }

#---------------------------------------------
sub mktipo1 {

    &query_dir_mktipo;

}

#---------------------------------------------
sub makestat1 {

    &query_dir_makestat1;

}

#---------------------------------------------
sub loadwebxref {

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref.pl -html -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref.pl -html -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	$info="Gnration des rapports HTML via WebXref termine";
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------
sub loadwebxref2 {

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref2.pl -html -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref2.pl -html -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	$info="Gnration des rapports HTML via WebXref termine";
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------
sub loadwebxref22 {

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref3.pl -html -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref3.pl -html -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	$info="Gnration des rapports HTML via WebXref termine";
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}
#---------------------------------------------
sub loadwebxref222 {

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref3.pl -html -lynx -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref3.pl -html -lynx -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	$info="Gnration des rapports HTML via WebXref termine";
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------
sub loadMktipo {

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."mktipo.pl $dir1"."$sitename \n";
	system("perl $dir0"."mktipo.pl $dir1"."$sitename");
	$info="Gnration du corpus XML via Mktipo termine";
	&mkPrintMsgInfo("Gnration du corpus XML via Mktipo termine dans rpertoire de travail\n");
	$sitename=~/res1\(([^\)]+)\)/;
	my $sitename2=$1;
	my $file="$dir1"."corp-$sitename2".".xml";
	&load_selected_fic($file);
    }
    else {
	&mkPrintErreur("Problme au lancement de MkTipo : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------
sub loadMkStatXML {

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;
    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	
	print "perl $dir0"."mkStatCorpXML.pl $dir1"."$sitename \n";
	system("perl $dir0"."mkStatCorpXML.pl $dir1"."$sitename"." $sitename");
	sleep(2);
	$wd->unShow;
	$info="Stat sur corpus XML via mkStatCorpXML termine";
	&mkPrintMsgInfo("Stat sur corpus XML via mkStatCorpXML termine\nFichiers gnrs : index (indexFile.txt),\n stat globale (StatWordFull.txt),\n stat par fichier (StatWordByFile.txt), \n et corpus brut textuel (corp-XML2TxtBrut.txt).\n");
	my $tmpfile="$dir0"."corp-XML2TxtBrut\(".$sitename."\).txt";
	my $msg="$dir0"."corp-XML2TxtBrut\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile="$dir0"."StatWordFull\(".$sitename."\).txt";
	my $msg="$dir0"."StatWordFull\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile="$dir0"."StatWordByFile\(".$sitename."\).txt";
	my $msg="$dir0"."StatWordByFile\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile="$dir0"."indexFile\(".$sitename."\).txt";
	my $msg="$dir0"."indexFile\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
    }
    else {
	&mkPrintErreur("Problme au lancement de MkStatCorpXML : vrifier prsence programme, input, output\n");
    }

}


#---------------------------------------------
sub typwebExtractTagHTML {

    if (! Exists ($pntag)) {
	$pntag = $mw ->Toplevel();
	$pntag->title("Slection Markups");
	$listePntag=$pntag->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pntag->Button(-text => "Extract Text",
		     -command =>  \&extract_tagtext_in_balise)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pntag->Button(-text => "Close",
		     -command =>  sub {$pntag->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my($w, $string, $tag) = ($texte,"<tagHTML[^>]+>",'search');
	my $id=0;
	my @seenElt=();
	$w->tag('remove',  $tag, '0.0', 'end');
	(my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
	for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend

	$cpt_file_balises++;
	if (!open(TMPFILE,(">MKCtmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	    return;
	}
	$info="Cration du fichier  MKCtmp_Mkbalises.txt...";
	for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	}
	close(TMPFILE);

	$info="Ecriture du fichier  MKCtmp_Mkbalises.txt...";
	if (!open(TMPFILE,("MKCtmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	    return;
	}


	my @liste_balises=();
	my %Liste_Markups=();
	my $id = 0; 
	while(<TMPFILE>) {
	    chomp;
	    if ($_!~/\//) {
		if (!exists ($Liste_Markups{$_})) {
		    $Liste_Markups{$_}++;
		    $liste_balises[$id]=$_;
		    $id++;
		}
	    }
	    
	}

	close(TMPFILE);
	$listePntag->delete(0,'end');
	$listePntag->insert('end',@liste_balises);
	$info = "Fichier  MKCtmp_Mkbalises.txt gnr.";

	

    }
    else {
	$pntag->deiconify();
	$pntag->raise();
    }

}

#---------------------------------------------
sub typwebExtractTxtBrut {

    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(Char  => \&char_handler);
    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}
    $mkXML2TxtBrut->destroy if Exists($mkXML2TxtBrut);
    $mkXML2TxtBrut = $mw->Toplevel();
    my $w = $mkXML2TxtBrut;
    $w->title('XML2TxtBrut');
    $w->iconname('XML2TxtBrut...');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
			-balloonmsg => "Save"
			);


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);

    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkXML2TxtBrut->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    if (!open(TMPFILE,("MKCtmp_xml2txtbrut.txt"))) {
	$w_t->insert("end","ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	return;
	}
    close(TMPFILE);

    my $file="MKCtmp_xml2txtbrut.txt";
    $w_t->insert('0.0', 'Rsultats XML2TxtBrut...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($file);

}

#-----------------------
sub typwebMkListBalise {
    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handler);
    @liste_xmlBalise = ();
    %Liste_xmlBalise = ();
    eval { $parser->parsefile($nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	}

    &mkSelectionXMLMarkup(@liste_xmlBalise);
    $info = "Recherche Markups sur '$nom_fic' termine.";
}

#-----------------------
sub mkSelectionXMLMarkup {
    if (! Exists ($pnXMLBalise)) {
	&mkWaitBox;
	$pnXMLBalise = $mw ->Toplevel();
	$pnXMLBalise->title("Slection Markups");

	$listePnXMLBalise=$pnXMLBalise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLBalise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXML)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXML)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXML)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlBalise;
	&removeWaitBox;
	$listePnXMLBalise->delete(0,'end');
	$listePnXMLBalise->insert('end',@liste_balises);
	$info = "Liste XML Markup gnres";

    }
    else {
	$pnXMLBalise->deiconify();
	$pnXMLBalise->raise();
    }

}

#-----------------------
sub mkSelectionXMLLexicoMarkup {
    if (! Exists ($pnXMLLexicoBalise)) {
	&mkWaitBox;
	$pnXMLLexicoBalise = $mw ->Toplevel();
	$pnXMLLexicoBalise->title("Slection Markups");
	$listePnXMLLexicoBalise=$pnXMLLexicoBalise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLLexicoBalise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXMLLexico)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexicoBalise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXMLLexico)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexicoBalise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXMLLexico)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLLexicoBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLLexicoBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlLexicoBalise;
	&removeWaitBox;
	$listePnXMLLexicoBalise->delete(0,'end');
	$listePnXMLLexicoBalise->insert('end',@liste_balises);
	$info = "Liste XML Markup gnres";

    }
    else {
	$pnXMLLexicoBalise->deiconify();
	$pnXMLLexicoBalise->raise();
    }

}

#-----------------------
sub mkSelectionXMLLexicoMarkup2 {
    if (! Exists ($pnXMLLexico2Balise)) {
	&mkWaitBox;
	$pnXMLLexico2Balise = $mw ->Toplevel();
	$pnXMLLexico2Balise->title("Slection Markups");
	$listePnXMLLexico2Balise=$pnXMLLexico2Balise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLLexico2Balise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXMLLexico2)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexico2Balise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXMLLexico2)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexico2Balise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXMLLexico2)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLLexico2Balise->Button(-text => "Close",
		     -command =>  sub {$pnXMLLexico2Balise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlLexicoBalise;
	&removeWaitBox;
	$listePnXMLLexico2Balise->delete(0,'end');
	$listePnXMLLexico2Balise->insert('end',@liste_balises);
	$info = "Liste XML Markup gnres";

    }
    else {
	$pnXMLLexico2Balise->deiconify();
	$pnXMLLexico2Balise->raise();
    }

}
#---------------------------- Module XWORD -------------------------------
sub mkXWord {
    system("perl Program/xword.pl");
}
#---------------------------- Module NLPTOOLS -------------------------------
sub capitalizeWord {

    &mkIndisponible;
}

sub wordPosition {
##############################################################################
# outputs all the words that match the given pattern, with their positions
##############################################################################
    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKCtmp_wordPosition.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_wordPosition.txt\n");
    return;
	}

    $pat = $search_string;

    while (<FIC>) {
	s/^ *//;
	my @token = split;
	for ($i = 0; $i < @token; $i++) {
	    if ($token[$i] =~ /$pat/) {
		my $hit = $base + $i;
		print FIC2 "$token[$i] $hit\n";
	    };
	};
	$base += @token;
    }

    close(FIC);
    close(FIC2);
    my $tmpfile="MKCtmp_wordPosition.txt";
    my $msg="MKCtmp_wordPosition.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

sub bigrammesUniques2Distance {

    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKCtmp_bigrammesUniques2Distance.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_wordPosition.txt\n");
	return;
	
    }
    print FIC2 "<indice de Dice> <nombre de bigrammes partags> <nombre de bigrammes mot1 seulement> <nombre de bigrammes mot2 seulement>  <mot1> <mot2> <bigrammes mot1> <bigrammes mot2>\n\n";
    close(FIC2);
    @ListeBigrammesMot1 =();
    @ListeBigrammesMot2 =();
    my @Mots                    = () ;
    my @BigrammesUniques        = () ;
    my $MinimumBigrammesUniques = 2 ;
    my @ListeBigrammes = ();
    my $Ligne;

# Mmorisation de tous les mots et de tous les bigrammes uniques

    while ($Ligne =<FIC>){
	$Ligne =~ /([^\t]+)\t(.*)/ ;
	my $Mot = $1 ;
	my $ChaineDeBigrammes = $2 ;
	@ListeBigrammes = split(/ /, $ChaineDeBigrammes) ;
	push(@Mots, $Mot) ;
	# La liste de bigrammes est mmorise comme une liste, 
	# pour ne pas avoir  la redcomposer  chaque comparaison.
	push(@BigrammesUniques, [ @ListeBigrammes ]) ;
    }

# Pour chaque mot, calcul de la distance de ses bigrammes uniques 
# avec les bigrammes uniques de TOUS les autres mots
# Condition : chacun des mots compars a au moins le
# nombre minimal requis de bigrammes uniques.

    for (my $i = 0 ; $i <= $#Mots ; $i++) {
	@ListeBigrammesMot1 = @{ $BigrammesUniques[$i] } ;
	for (my $j = $i + 1 ; $j <= $#Mots ; $j++) {
	    @ListeBigrammesMot2 = @{ $BigrammesUniques[$j] } ;
	    if ($#ListeBigrammesMot1 > $MinimumBigrammesUniques 
		&& 
		$#ListeBigrammesMot2 > $MinimumBigrammesUniques) {
		DistanceEntreBigrammes() ;
		if (!open(FIC2,">>MKCtmp_bigrammesUniques2Distance.txt")) {
		    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_wordPosition.txt\n");
		    return;
		}
		print FIC2 "\t$Mots[$i]\t$Mots[$j]\t@ListeBigrammesMot1\t@ListeBigrammesMot2\n" ;
		close (FIC2)
	    }
	}
    }
    close (FIC);
#    close (FIC2);
    my $tmpfile="MKCtmp_bigrammesUniques2Distance.txt";
    my $msg="MKCtmp_bigrammesUniques2Distance.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

sub DistanceEntreBigrammes{ 
    if (!open(FIC2,">>MKCtmp_bigrammesUniques2Distance.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_wordPosition.txt\n");
	return;
    }

# Un dictionnaire Bigramme / Emploi stocke les correspondances : 
#  1 - employ dans mot1 seulement ;
#  2 - employ dans mot1 et mot2 ;
#  0 - employ dans mot2 seulement.
# Le total de chacun des cas permet de calculer l'indice de Dice.
    my %Bigramme2Emploi = () ;
    for (my $k = 0 ; $k <= $#ListeBigrammesMot1 ; $k++) {
	$Bigramme2Emploi{$ListeBigrammesMot1[$k]} = 1 ;
    }
    for (my $l = 0 ; $l <= $#ListeBigrammesMot2 ; $l++) {
	if (exists $Bigramme2Emploi{$ListeBigrammesMot2[$l]}) {
	    $Bigramme2Emploi{$ListeBigrammesMot2[$l]} = 0 ; 
	}
	else {
	    $Bigramme2Emploi{$ListeBigrammesMot2[$l]} = 2 ; 
	}
    }
    my $BigrammesMot1Seulement = 0 ;
    my $BigrammesMot2Seulement = 0 ;
    my $BigrammesPartages = 0 ;
    for my $Bigramme (keys %Bigramme2Emploi) {
	if ($Bigramme2Emploi{$Bigramme} == 0) { 
	    $BigrammesPartages++ ; 
	}
	if ($Bigramme2Emploi{$Bigramme} == 1) { 
	    $BigrammesMot1Seulement++ ; 
	}
	if ($Bigramme2Emploi{$Bigramme} == 2) { 
	    $BigrammesMot2Seulement++ ; 
	}
    }
    my $IndiceDice;
    if (($BigrammesMot1Seulement + $BigrammesMot2Seulement) > 0) {
	$IndiceDice = ($BigrammesPartages * 2)/ ($BigrammesMot1Seulement + $BigrammesMot2Seulement) ; 
    }
    else {
	$IndiceDice = 0 ; 
    }
    printf FIC2 "%1.2f\t", $IndiceDice ;
    print FIC2 "$BigrammesPartages $BigrammesMot1Seulement $BigrammesMot2Seulement\t" ;

    close (FIC2);
}

#---------------------------------------------
sub help_bigramChar {
    if (! Exists ($pn1)) {
	$pn1 = $mw ->Toplevel();
	$pn1->title("HELP");
	my $texte2 = $pn1->Scrolled("TextUndo")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	my $tmpfile="Doc/helpBigramChar.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}


sub makeIndex {

    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(DIC1,">MKCtmp_index.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_wordPosition.txt\n");
	return;
    }
    my %dico1=();
    my $i = 0;
    my $Ligne = 0;
    my %Lignes=();
    my @Mots=();

  READ: while(<FIC>)
  {  
      #saute les lignes vides
      next READ if (/^$/);
      s/[\(\)\[\]\"]//g;	
# nettoyage
      s/,/ ,/g;		
# on isole les ,
      chop;
      $Ligne++;
      $Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
      for my $mot (@Mots) {
	  $mot =~ /\D/ or next ;
	  print "$mot \n";
	  if (! exists $dico1{$mot}) {
	      $dico1{$mot}++;
	  }
      }
  }
    
    print "Lecture/Ecriture dico1 \n";
    foreach $mot (keys %dico1)
    {
	print "mot in dico1 : $mot\n";
	print DIC1 "$mot\n";
    }
    close(DIC1);
    close(FIC);
    my $tmpfile="MKCtmp_index.txt";
    my $msg="MKCtmp_index.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    
}

sub mots2Distance {
    
    system("cp $nom_fic MKC_index-trie-full.txt");
    system("perl Program/Mot2BigrammesUniques.pl < MKC_index-trie-full.txt | perl Program/BigrammesUniques2Distance.pl | sort -n -r > MKC_tmpmots2distances.txt ");
    my $tmpfile="MKC_tmpmots2distances.txt";
    my $msg="MKC_tmpmots2distances.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}


sub mots2BigramUniques {
    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(FIC1,">MKCtmp_mots2BigramUniques.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_wordPosition.txt\n");
	return;
    }
    my $Ligne;
    my $Mot;
    my @ListeLettres =();
    while ($Ligne =<FIC>){
	$Mot = $Ligne ;
	chop($Mot) ;
	@ListeLettres = split(//, $Mot) ;
	print FIC1 "$Mot\t" ;
	# Pour chaque lettre successive du mot, impression de cette lettre, de la suivante et d'un blanc
	for (my $i = 0 ; $i < $#ListeLettres ; $i++) {
	    print FIC1 "$ListeLettres[$i]$ListeLettres[$i+1] " ;
	}
	print FIC1 "\n" ;
    }
    close(FIC);
    close(FIC1);
    my $tmpfile="MKCtmp_mots2BigramUniques.txt";
    my $msg="MKCtmp_mots2BigramUniques.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}


sub mkBigramWord {
#program: bigramcount - counts the number of bigrams in a text,
#                        prints them out in order of decreasing frequency

    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKCtmp_bigram.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_bigram.txt\n");
    return;
	}


    while(<FIC>) {
	chop;
	tr/A-Z/a-z/;
	tr/.,:;!?\"(){}//d;
	foreach $word1 (split) {
	    $bigram = "$word2 $word1";  
	    $word2  = $word1;          
	    $count{$bigram}++;         
	}
    }
    foreach $bigram (sort numerically keys %count) { 
	print FIC2 "$count{$bigram} $bigram\n";               
    }
        close(FIC);
    close(FIC2);
    my $tmpfile="MKCtmp_bigram.txt";
    my $msg="MKCtmp_bigram.txt";
    &IncludedFileInWindow($tmpfile,$msg);
   
}
#-------------------------------------------
sub numerically {                    # compare two words numerically
   $count{$b} <=> $count{$a};        # decreasing order
   # $count{$b} <=> $count{$a};      # increasing order
}
#-------------------------------------------
sub mkFourgramWord {
########################################################################
# Tallies 4-grams in each line
########################################################################

    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKCtmp_fourgram.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_fourgram.txt\n");
    return;
	}
    while (<FIC>) {
	# remove parens and tokenize
	s/\(/ /g;
	s/\)/ /g;
	@token = split;
	# count 4-grams
	for($i=0; $i < @token - 3; $i++) {
		$count{"@token[$i] @token[$i+1] @token[$i+2] @token[$i+3]"}++;
	};
};
# output
while (($key, $value) = each %count) {
        print FIC2 "$value $key\n";
}
    close(FIC);
    close(FIC2);
    my $tmpfile="MKCtmp_fourgram.txt";
    my $msg="MKCtmp_fourgram.txt";
    &IncludedFileInWindow($tmpfile,$msg);
   
}
#-----------------------------------------------
sub mkWordCount {
    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKCtmp_wordcount.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_wordcount.txt\n");
    return;
	}
    while(<FIC>) {
	chop;                
	tr/A-Z/a-z/;             # convert to lower case
	tr/.,:;!?\"(){}//d;       
# strip out punctuation
	foreach $word (split) {  
# split line into words 
	    $count{$word}++;     # count words, put count into hash (word is key, count is value)
	}
    }
    foreach $word (sort keys %count) {   # sort hash by the value of the key
	print FIC2 "word:<$word>\tcount:<$count{$word}>\n";    # print out the hash in key order
    }
    close(FIC);
    close(FIC2);
    my $tmpfile="MKCtmp_wordcount.txt";
    my $msg="MKCtmp_wordcount.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#-----------------------------------------------
sub mkCollocate {
# program: collocate - 
# Creates a KWIC (key word in context) listing of collocations,
# aligning the context around the word in the center.
#
# Such KWIC listings are found in books like 
# Sinclair (1991) Corpus, Concordance, Collocation. (Oxford) 
# The program reads in a file, finds all instances of a word
# along with the context of the word, i.e. 4 words to the right
# (the right context or $right) and 4 words to the left of the 
# word (the left context or $left)and then prints the word out 
# in context centered around the word. 
# 
# The tricky part:
# To center the left and right contexts around the word the program 
# has to find the maximum length of all left contexts and then right 
# align each left context in a string of spaces equal to this maximum length.
# 


if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	    return;
	}

my $word = $search_string;
if (!open(FILE,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
if (!open(FIC2,">MKCtmp_collocate.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_collocate.txt\n");
    return;
	}

my @lines=();
@lines = <FILE>;
my $lines = join("",@lines);
$lines =~ s/\n/ /g;
$lines =~ s/\r/ /g;

@words=();
@contexts3=();

@words = ($lines =~ /(\S+)\s+/gi);     

my $max = 0;
for ($i = 0; $i < @words; $i++) {
   if ($words[$i] eq $word) {
      my @collocates = ();
      push(@collocates,&collocate(\@words,$i,-4));
      push(@collocates,&collocate(\@words,$i,-3));
      push(@collocates,&collocate(\@words,$i,-2));
      push(@collocates,&collocate(\@words,$i,-1));
      push(@collocates,&collocate(\@words,$i,0));
      push(@collocates,&collocate(\@words,$i,1));
      push(@collocates,&collocate(\@words,$i,2));
      push(@collocates,&collocate(\@words,$i,3));
      push(@collocates,&collocate(\@words,$i,4));
      my $left   = join(" ", splice(@collocates,0,4));
      my $middle = splice(@collocates,0,1);
      my $right  = join(" ", splice(@collocates,0,4));
      my @tmp = ($left,$middle,$right);
      push(@contexts3,[ @tmp ]);
      $max = (length($left) > $max) ? length($left) : $max;
   }
}

# create a string filled with blanks equal to the max left context
my $dummy = "";
for ($i=1; $i < $max; $i++) { 
   $dummy .= " ";
} 

# |<-----$remainder------->|<---------------$lenleft----------->|
# |<---------------------------$max---------------------------->|
foreach $context (@contexts3) {
   $lenleft = length($context->[0]);
   $remainder = $max - $lenleft;
   $spacer = $dummy;
   substr($spacer,$remainder,$lenleft) = substr($context->[0],0,$lenleft);
   print FIC2 "$spacer   $context->[1]   $context->[2]\n";
}
FINIS: print "\nEnd of Program\n";
close(FILE);
close(FIC2);
    my $tmpfile="MKCtmp_collocate.txt";
    my $msg="MKCtmp_collocate.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#-----------------------------------------------
sub collocate {
   my($words,$i,$delta) = @_;
   my($target);
   # check bounds
   $target = $i + $delta;
   if (($target < 0) || ($target > @words - 1)) {
      #print "out of bounds\n";
      return "";
   } 
   #print "in bounds: $words->[$target]\n";
   return $words->[$target];
}
#------------------------------------------------
sub concordanceFormat {
$concordance_TOP  =
'Mot         nLigne # Extrait Contenu Ligne
';
    $concordance_subform =
'@<<<<<<<<<<< @>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<                  ';
#'@<<<<<<<<<<< @>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<                  ';
    my($Mot, %Exclude);
#for $Mot ("un", "le", "la", "une", "les") {
#    $Exclude{$Mot} = 1;
#}
    my(@Mots,$Mot,%Concord);
    my($Ligne) = 0;
    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
  READ: while(<FIC>)
{  
   #saute les lignes vides
   next READ if (/^$/);
   s/[ ]+/ /g;
   chop;
   $Ligne++;
   $::Lignes[$Ligne] = $_ ;
   @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
   for $Mot (@Mots) {
        $Mot =~ /\D/ or next ;
        $Exclude{"\L$Mot "} and next ;
        push(@{$Concord{$Mot}},$Ligne);
       }
}
if (!open(FIC2,">MKCtmp_concordanceformat.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir  MKCtmp_concordanceformat.txt\n");
    return;
	}
formline($concordance_TOP);
for $::Mot (sort keys %Concord) {
    for $::Ligne (@{$Concord{$::Mot}})
    {
#	formline($concordance_subform, $::Ligne);
	formline($concordance_subform, $::Mot,$::Ligne, $::Lignes[$ ::Ligne]);
	print FIC2 $ACCUMULATOR, "\n";
	$ACCUMULATOR = '';
	$::Mot = "";
    }
}
    close(FIC2);
    close(FIC);
    my $tmpfile="MKCtmp_concordanceformat.txt";
    my $msg="MKCtmp_concordanceformat.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------
sub mkConcordanceOneWord2 {
    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	    return;
	}
    $mkTextConcordance->destroy if Exists($mkTextConcordance);
    $mkTextConcordance = $mw->Toplevel();
    my $w = $mkTextConcordance;
    $w->title('Concordance');
    $w->iconname('Text Concordance');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
			-balloonmsg => "Save"
			);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkTextConcordance->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    if (!open(FIC,"$nom_fic")) {
	$w_t->insert("end","ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    $w_t->insert('0.0', 'Rsultats Concordance...');
    $w_t->insert("end","\n\n");
    my %Lignes=();
    my %Concord=();
    my $Ligne = 0;
    my @Mots=();
  READ: while(<FIC>)
  {  
      #saute les lignes vides
      next READ if (/^$/);
      s/[ ]+/ /g;
      chop;
      $Ligne++;
      $Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
      for $Mot (@Mots) {
	  $Mot =~ /\D/ or next ;
	$Mot =~ /$search_string/ or next ;
	  push(@{$Concord{$Mot}},$Ligne);
      }
  }
    for $Mot (sort keys %Concord) {
	$w_t->insert("end","-------------------------------------------------\n");
	$w_t->insert("end","Mot : $Mot \n");
	for $Ligne (@{$Concord{$Mot}})
	{
            $w_t->insert("end","\tLigne n$Ligne: $Lignes[$Ligne]\n");
	}
	
    }
    close(FIC);
    $info = "Concordance sur '$nom_fic' termine.";
}

#---------------------------------------------
sub mkConcordanceOneWord3 {
    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	    return;
	}
    $mkTextConcordance->destroy if Exists($mkTextConcordance);
    $mkTextConcordance = $mw->Toplevel();
    my $w = $mkTextConcordance;
    $w->title('Concordance');
    $w->iconname('Text Concordance');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
			-balloonmsg => "Save"
			);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkTextConcordance->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    if (!open(FIC,"$nom_fic")) {
	$w_t->insert("end","ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }
    $w_t->insert('0.0', 'Rsultats Concordance...');
    $w_t->insert("end","\n\n");
    my %Lignes=();
    my %Concord=();
    my $Ligne = 0;
    my @Mots=();
  READ: while(<FIC>)
  {  
      #saute les lignes vides
      next READ if (/^$/);
      s/[ ]+/ /g;
      chop;
      $Ligne++;
      $Lignes[$Ligne] = $_ ;
	  if ($Lignes[$Ligne]=~/$search_string/) {
	  $w_t->insert("end","\tLigne ($Ligne) : $Lignes[$Ligne] \n");
	  }
  }

    close(FIC);
    $info = "Concordance sur '$nom_fic' termine.";
}
#---------------------------------------------
sub mkConcordanceOneWord {
    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
$concordance_TOP  =
'Mot         nLigne # Extrait Contenu Ligne
';
    $concordance_subform =
'@<<<<<<<<<<< @>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<                  ';
    my($Mot, %Exclude);
#for $Mot ("un", "le", "la", "une", "les") {
#    $Exclude{$Mot} = 1;
#}
    my(@Mots,$Mot,%Concord);
    my($Ligne) = 0;

    if (!open(FIC,"$nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }

  READ: while(<FIC>)
{  
   #saute les lignes vides
   next READ if (/^$/);
   s/[ ]+/ /g;
   chop;
   $Ligne++;
   $::Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
   for $Mot (@Mots) {
        $Mot =~ /\D/ or next ;
	$Mot =~ /$search_string/ or next ;
        $Exclude{"\L$Mot "} and next ;
        push(@{$Concord{$Mot}},$Ligne);
       }
}
if (!open(FIC2,">MKCtmp_concordanceformat.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir  MKCtmp_concordanceformat.txt\n");
    return;
	}
formline($concordance_TOP);
for $::Mot (sort keys %Concord) {
    for $::Ligne (@{$Concord{$::Mot}})
    {
#	formline($concordance_subform, $::Ligne);
	formline($concordance_subform, $::Mot,$::Ligne, $::Lignes[$ ::Ligne]);
	print FIC2 $ACCUMULATOR, "\n";
	$ACCUMULATOR = '';
	$::Mot = "";
    }
}
    close(FIC2);
    close(FIC);
    my $tmpfile="MKCtmp_concordanceformat.txt";
    my $msg="MKCtmp_concordanceformat.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------
sub mkConcordance {
    $mkTextConcordance->destroy if Exists($mkTextConcordance);
    $mkTextConcordance = $mw->Toplevel();
    my $w = $mkTextConcordance;
    $w->title('Concordance');
    $w->iconname('Text Concordance');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winBalloon->attach($w_save,
			-balloonmsg => "Save"
			);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkTextConcordance->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    if (!open(FIC,"$nom_fic")) {
	$w_t->insert("end","ERREUR : Impossible d\'ouvrir '$nom_fic'\n");
	return;
    }

    $w_t->insert('0.0', 'Rsultats Concordance...');
    $w_t->insert("end","\n\n");

    my %Lignes=();
    my %Concord=();
    my $Ligne = 0;
    my @Mots=();
  READ: while(<FIC>)
  {  
      #saute les lignes vides
      next READ if (/^$/);
      s/[ ]+/ /g;
      chop;
      $Ligne++;
      $Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
      for $Mot (@Mots) {
	  $Mot =~ /\D/ or next ;
	  push(@{$Concord{$Mot}},$Ligne);
      }
  }
    for $Mot (sort keys %Concord) {
	$w_t->insert("end","-------------------------------------------------\n");
	$w_t->insert("end","Mot : $Mot \n");
	for $Ligne (@{$Concord{$Mot}})
	{
            $w_t->insert("end","\tLigne n$Ligne: $Lignes[$Ligne]\n");
	}
    }
    close(FIC);
    $info = "Concordance sur '$nom_fic' termine.";
}
#---------------------------------------------
#---------------------------------------------------------------------
# Premiers niveaux
#---------------------------------------------------------------------
#PN0
sub trt_en_cours {
    my ($trt,$message)=@_;
    if (! Exists ($pn0)) {
	$pn0 = $mw ->Toplevel();
	$pn0->title("Traitement en cours");
	$pn0->Label(-text => 'Traitement '.$trt.' dbut', -width => -1, -anchor => 'w')->pack;
	$pn0->Label(-text => $message, -width => -1, -anchor => 'w')->pack;
	$pn0->Button(-text => "OK",
		     -command =>  sub {$pn0->destroy()})->pack;
    }
    else {
	$pn0->deiconify();
	$pn0->raise();
    }
}
#---------------------------------------------
sub trt_fini {
    my ($trt,$message)=@_;
    if (! Exists ($pn0_1)) {
	$pn0_1 = $mw ->Toplevel();
	$pn0_1->title("Traitement fini");
	$pn0_1->Label(-text => 'Traitement '.$trt.' fini', -width => -1, -anchor => 'w')->pack;
	$pn0_1->Label(-text => $message, -width => -1, -anchor => 'w')->pack;
	$pn0_1->Button(-text => "OK",
		     -command =>  sub {$pn0_1->destroy()})->pack;
    }
    else {
	$pn0_1->deiconify();
	$pn0_1->raise();
    }
}
#-----------------------------------
#PN1
sub command_help {
	use Pod::Text ();
	my $tl = $mw->Toplevel();
	$tl->title("Help MKCORPUS");
	$tl->Label(-image => $logoMKC)->pack(-side => 'right');
	my $f = $tl->Frame();
	$f->pack(-side => 'top', -fill => 'x');
	$f->Button(-text => 'OK', 
		-command => sub { $tl->destroy }
	)->pack(-side => 'left');
	my $txt = `pod2text $0`;
	$f = $tl->Frame();
	$f->pack(-side => 'top', -fill => 'both');
	$f->Scrolled('Label', 
		-text => $txt, 
		-justify => 'left', 
		-scrollbars => 'se')->pack();
}
#-----------------------------------
sub mkSelectionMarkup {
    if (! Exists ($pn2)) {
	&mkWaitBox;
	$pn2 = $mw ->Toplevel();
	$pn2->title("Slection Markups");

	$listePn2=$pn2->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pn2->Button(-text => "Delete",
		     -command =>  \&delete_selected_balise)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pn2->Button(-text => "Modify",
		     -command =>  \&modify_selected_balise)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pn2->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_balise)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pn2->Button(-text => "Close",
		     -command =>  sub {$pn2->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my($w, $string, $tag) = ($texte,"<[^>]+>",'search');
	my $id=0;
	my @seenElt=();
	$w->tag('remove',  $tag, '0.0', 'end');
	(my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
	for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}
	} # whilend
    } # forend
	$cpt_file_balises++;
	if (!open(TMPFILE,(">MKCtmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	    return;
	}
	$info="Cration du fichier  MKCtmp_Mkbalises.txt...";
	for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	}
	close(TMPFILE);

	$info="Ecriture du fichier  MKCtmp_Mkbalises.txt...";
	if (!open(TMPFILE,("MKCtmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	    return;
	}
	my @liste_balises=();
	my %Liste_Markups=();
	my $id = 0; 
	while(<TMPFILE>) {
	    chomp;
	    if ($_!~/\//) {
		if (!exists ($Liste_Markups{$_})) {
		    $Liste_Markups{$_}++;
		    $liste_balises[$id]=$_;
		    $id++;
		}
	    }   
	}
	close(TMPFILE);
	&removeWaitBox;
	$listePn2->delete(0,'end');
	$listePn2->insert('end',@liste_balises);
	$info = "Fichier  MKCtmp_Mkbalises.txt gnr.";
    }
    else {
	$pn2->deiconify();
	$pn2->raise();
    }
}
#-----------------------------------
sub makeTextToMap {
    if (! Exists ($pn2Map)) {
	&mkWaitBox;
	$pn2Map = $mw ->Toplevel();
	$pn2Map->title("Slection Markups");
	$listePn2Map=$pn2Map->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();
	$pn2Map->Button(-text => "Text 2 Map",
		     -command =>  \&make_text2map)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pn2Map->Button(-text => "Close",
		     -command =>  sub {$pn2Map->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my($w, $string, $tag) = ($texte,"<[^>]+>",'search');
	my $id=0;
	my @seenElt=();
	$w->tag('remove',  $tag, '0.0', 'end');
	(my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
	for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend
	$cpt_file_balises++;
	if (!open(TMPFILE,(">MKCtmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	    return;
	}
	$info="Cration du fichier  MKCtmp_Mkbalises.txt...";
	for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	}
	close(TMPFILE);

	$info="Ecriture du fichier  MKCtmp_Mkbalises.txt...";
	if (!open(TMPFILE,("MKCtmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier  MKCtmp_Mkbalises.txt\n");
	    return;
	}
	my @liste_balises=();
	my %Liste_Markups=();
	my $id = 0; 
	while(<TMPFILE>) {
	    chomp;
	    if ($_!~/\//) {
		if (!exists ($Liste_Markups{$_})) {
		    $Liste_Markups{$_}++;
		    $liste_balises[$id]=$_;
		    $id++;
		}
	    }   
	}
	close(TMPFILE);
	&removeWaitBox;
	$listePn2Map->delete(0,'end');
	$listePn2Map->insert('end',@liste_balises);
	$info = "Fichier  MKCtmp_Mkbalises.txt gnr.";
    }
    else {
	$pn2Map->deiconify();
	$pn2Map->raise();
    }
}
#-----------------------------------
#PN3
sub query_search_replace {
    if (! Exists ($pn3)) {
	$pn3 = $mw ->Toplevel();
	$pn3->title("Query Replace");
	my $cadre = $pn3->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre->Label(-text => "Search : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $search="";
	my $saisie_1=$cadre->Entry(-textvariable => \$search)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Label(-text => "Replace : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $replace="";
	my $saisie_2=$cadre->Entry(-textvariable => \$replace)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Button(-text => "Search&Replace",
	       -command => sub {&search_replace($search,$replace)})->pack(-side => 'right',
						   -anchor => 'e');
	$pn3->Button(-text => "Close",
		     -command =>  sub {$pn3->destroy()})->pack;
    }
    else {
	$pn3->deiconify();
	$pn3->raise();
    }
}
#-----------------------------------
#PN4
sub query_replace {
    if (! Exists ($pn4)) {
	my ($search) = @_;
	my $pn4 = $mw ->Toplevel();
	$pn4->title("Query Replace");
	my $cadre = $pn4->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre->Label(-text => "Search : $search ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre->Label(-text => "Replace : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $replace="";
	my $saisie_2=$cadre->Entry(-textvariable => \$replace)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Button(-text => "Search&Replace",
	       -command => sub {&search_replace($search,$replace)})->pack(-side => 'right',
						   -anchor => 'e');
	$pn4->Button(-text => "Close",
		     -command =>  sub {$pn4->destroy()})->pack;
    }
    else {
	$pn4->deiconify();
	$pn4->raise();
    }
}
#-----------------------------------
#PN5
sub open_dir {
    if (! Exists ($pn5)) {
	my $pn5 = $mw ->Toplevel();
	my $dl  = $pn5->Scrolled('DirTree')->pack(-expand => 1 , -fill => 'both');
    }
    else {
	$pn5->deiconify();
	$pn5->raise();
    }
}
#-----------------------------------
sub viewAndSelectDir {
 my $dir = $mw->DirSelect->Show;
 return $dir;
}
#-----------------------------------
#PN6
sub fileDialog {
    my $w = shift;
    my $ent = shift;
    my $operation = shift;
    my $types;
    my $file;
    #   Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    @types =
      (
       ["(HT/X/SG)ML files",           [qw/.xml .html .sgml .htm .dtd/]],
       ["Text files",           [qw/.txt .doc/]],
       ["Text files",           '',             'TEXT'],
       ["Perl Scripts",         '.pl',		'TEXT'],
       ["C Source Files",	['.c', '.h']],
       ["All Source Files",     [qw/.tcl .c .h/]],
       ["Image Files",		'.gif'],
       ["Image Files",		['.jpeg', '.jpg']],
       ["Image Files",   	'',		[qw/GIFF JPEG/]],
       ["All files",		'*']
      );
    if ($operation eq 'open') {
	$file = $w->getOpenFile(-filetypes => \@types);
	if (defined $file and $file ne '') {&load_selected_fic($file);}
	if (Exists ($pn9)) {$pn9->destroy();}
    } else {
	$file = $w->getSaveFile(-filetypes => \@types,
				-initialfile => 'Untitled',
				-defaultextension => '.txt');
	if (Exists ($pn9)) {$pn9->destroy();}
    }
}
#----------------------------------------------
sub fileDialog2 {
    my $w = shift;
    my $ent = shift;
    my $operation = shift;
    my $types;
    my $file;
    #   Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    @types =
      (
       ["(HT/X/SG)ML files",           [qw/.xml .html .sgml/]],
       ["Text files",           [qw/.txt .doc/]],
       ["Text files",           '',             'TEXT'],
       ["Perl Scripts",         '.pl',		'TEXT'],
       ["C Source Files",	['.c', '.h']],
       ["All Source Files",     [qw/.tcl .c .h/]],
       ["Image Files",		'.gif'],
       ["Image Files",		['.jpeg', '.jpg']],
       ["Image Files",   	'',		[qw/GIFF JPEG/]],
       ["All files",		'*']
      );
    if ($operation eq 'open') {
	$file = $w->getOpenFile(-filetypes => \@types);
	if (defined $file and $file ne '') {&attach_selected_fic($file);}
	if (Exists ($pn11)) {$pn11->destroy();}
    } else {
	$file = $w->getSaveFile(-filetypes => \@types,
				-initialfile => 'Untitled',
				-defaultextension => '.txt');
	if (Exists ($pn11)) {$pn11->destroy();}
    }
}
#-----------------------------------
#PN7
sub query_search_text_in_balise {
    if (! Exists ($pn7)) {
	$pn7 = $mw ->Toplevel();
	$pn7->title("Text-Extractor");
	my $cadre = $pn7->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre->Label(-text => "Search : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $search="";
	my $saisie_1=$cadre->Entry(-textvariable => \$search)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Button(-text => "Extract Text",
	       -command => sub {&extract_balise_i($search)})->pack(-side => 'right',
						   -anchor => 'e');
	$pn7->Button(-text => "Close",
		     -command =>  sub {$pn7->destroy()})->pack;
    }
    else {
	$pn7->deiconify();
	$pn7->raise();
    }
}
#-----------------------------------
#PN8
sub query_dir_prepOneDir {
    if (! Exists ($pn8)) {
	$pn8 = $mw ->Toplevel();
	$pn8->title("Query Dir");
	my $cadre1 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load mkPrepHtml2txtOneDir",
	       -command => sub {&mkPrepHtml2txtOneDir($workdirin,$workdirout, 0, "corpFull.txt", 0);
			    $pn8->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#-----------------------------------
#PN8
sub query_dir_webxref {
    if (! Exists ($pn8)) {
	$pn8 = $mw ->Toplevel();
	$pn8->title("Query Dir");
	my $cadre1 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {&loadwebxref($webxrefdir,$workdirin,$sitename,$workdirout);
			    $pn8->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#---------------------------------------------
sub query_dir_webxref2 {
    if (! Exists ($pn8)) {
	$pn8 = $mw ->Toplevel();
	$pn8->title("Query Dir");
	my $cadre1 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {&loadwebxref2($webxrefdir,$workdirin,$sitename,$workdirout);
			    $pn8->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#---------------------------------------
sub query_dir_webxref22 {
    if (! Exists ($pn8)) {
	$pn8 = $mw ->Toplevel();
	$pn8->title("Query Dir");
	my $cadre1 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {&loadwebxref22($webxrefdir,$workdirin,$sitename,$workdirout);
			    $pn8->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
sub query_dir_webxref222 {
    if (! Exists ($pn8)) {
	$pn8 = $mw ->Toplevel();
	$pn8->title("Query Dir");
	my $cadre1 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {&loadwebxref222($webxrefdir,$workdirin,$sitename,$workdirout);
			    $pn8->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#-----------------------------------
#PN8Bis
sub query_dir_mktipo {
    if (! Exists ($pn8b)) {
	$pn8b = $mw ->Toplevel();
	$pn8b->title("Query Dir");
	my $cadre1 = $pn8b->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8b->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8b->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8b->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8b->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "Where is Mktipo : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $mktipodir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$mktipodir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="res1(GiveSiteName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
#	my $workdirout=&GetCWD;
	my $workdirout=$workdirin;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MkTipo",
	       -command => sub {&loadMktipo($mktipodir,$workdirin,$sitename,$workdirout);
			    $pn8b->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8b->Button(-text => "Close",
		     -command =>  sub {$pn8b->destroy()})->pack;
    }
    else {
	$pn8b->deiconify();
	$pn8b->raise();
    }
}
#-----------------------------------
#PN8Ter
sub query_dir_makestat1 {
    if (! Exists ($pn8c)) {
	$pn8c = $mw ->Toplevel();
	$pn8c->title("Query Dir");
	my $cadre1 = $pn8c->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8c->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8c->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8c->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8c->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "Where is MkStatCorpXML : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $mkStatXMLdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$mkStatXMLdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "CorpusXML Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="corp-GiveSiteName.xml";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
#	my $workdirout=&GetCWD;
	my $workdirout=$workdirin;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MkStatXML",
	       -command => sub {&loadMkStatXML($mkStatXMLdir,$workdirin,$sitename,$workdirout);
			    $pn8c->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8c->Button(-text => "Close",
		     -command =>  sub {$pn8c->destroy()})->pack;
    }
    else {
	$pn8c->deiconify();
	$pn8c->raise();
    }
}
#-----------------------------------
#PN8Quat
sub query_loadMirroring {
    if (! Exists ($pn8d)) {
	$pn8d = $mw ->Toplevel();
	$pn8d->title("Query Dir");
	my $cadre1 = $pn8d->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8d->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8d->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8d->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8d->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "URL address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MirroringSite",
	       -command => sub {&loadMirroring ($urlAddress,$workdirout);
			    $pn8d->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8d->Button(-text => "Close",
		     -command =>  sub {$pn8d->destroy()})->pack;
    }
    else {
	$pn8d->deiconify();
	$pn8d->raise();
    }
}
#-----------------------------------
#PN8Quatb
sub query_loadPageMirroring {
    if (! Exists ($pn8db)) {
	$pn8db = $mw ->Toplevel();
	$pn8db->title("Query Dir");
	my $cadre1 = $pn8db->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8db->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8db->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8db->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8db->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "URL-File address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $urlAddress = "http://";
	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	$cadre4->Button(-text => "Load MirroringPage",
	       -command => sub {&loadMirroringPage ($urlAddress,$workdirout);
			    $pn8db->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8db->Button(-text => "Close",
		     -command =>  sub {$pn8db->destroy()})->pack;
    }
    else {
	$pn8db->deiconify();
	$pn8db->raise();
    }
}
#-----------------------------------
#PN8Quatc
sub query_wget {
    if (! Exists ($pn8de)) {
	$pn8de = $mw ->Toplevel();
	$pn8de->title("Query Dir");
	my $cadre1 = $pn8de->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8de->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8de->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8de->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8de->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "URL address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load wget",
	       -command => sub {&loadWget ($urlAddress,$workdirout);
			    $pn8de->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8de->Button(-text => "Close",
		     -command =>  sub {$pn8de->destroy()})->pack;
    }
    else {
	$pn8de->deiconify();
	$pn8de->raise();
    }
}
#-----------------------------------
#PN8Cinq
sub query_uploading {
    if (! Exists ($pn8e)) {
	$pn8e = $mw ->Toplevel();
	$pn8e->title("Query Dir");
	my $cadre1 = $pn8e->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre2 = $pn8e->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre5 = $pn8e->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre3 = $pn8e->Frame->pack(-side => 'top',
			  -fill => 'x');
	my $cadre4 = $pn8e->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre1->Label(-text => "URL address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MirroringSite",
	       -command => sub {&loadUploading ($urlAddress,$workdirout);
			    $pn8e->destroy();})->pack(-side => 'right',
						   -anchor => 'e');
	$pn8e->Button(-text => "Close",
		     -command =>  sub {$pn8e->destroy()})->pack;
    }
    else {
	$pn8e->deiconify();
	$pn8e->raise();
    }
}
#-----------------------------------
#PN9
sub  query_file_dialog {

    if (! Exists ($pn9)) {


	$pn9 = $mw ->Toplevel();
    foreach my $i (qw(open)) {
	my $f = $pn9->Frame;
	my $lab = $f->Label(-text => "Select a file to $i: ",
			    -anchor => 'e');
	my $ent = $f->Entry(-width => 20);
	my $but = $f->Button(-text => "Browse ...",
			     -command => sub { fileDialog($pn9, $ent, $i)});
	$lab->pack(-side => 'left');
	$ent->pack(-side => 'left',-expand => 'yes', -fill => 'x');
	$but->pack(-side => 'left');
	$f->pack(-fill => 'x', -padx => '1c', -pady => 3);
    }

    my $cbf = $pn9->Frame->pack(-fill => 'x', -padx => '1c', -pady => 3);
    my $fd;
    $cbf->Radiobutton
      (-text => 'FileSelect',
       -variable => \$fd,
       -value => 'FileSelect',
       -command => sub { local($^W) = 0;
			 require Tk::FileSelect;
			 Tk::FileSelect->import('as_default');
			 # XXX remove cached dialogs
			 my $pn9 = $pn9->MainWindow;
			 delete $pn9->{'tk_getOpenFile'};
#			 delete $pn9->{'tk_getSaveFile'};
		     })->pack(-side => 'left');
    my $fdb = $cbf->Radiobutton
      (-text => 'FBox',
       -variable => \$fd,
       -value => 'FBox',
       -command => sub { local($^W) = 0;
			 require Tk::FBox;
			 Tk::FBox->import('as_default');
			 # XXX remove cached dialogs
			 my $pn9 = $pn9->MainWindow;
			 delete $pn9->{'tk_getOpenFile'};
#			 delete $pn9->{'tk_getSaveFile'};
		     })->pack(-side => 'left');
    $fdb->invoke;
    }
}
#-----------------------------------
#PN10
sub  query_file_dialog2 {
    $texte->FileSaveAsPopup();
}
#-----------------------------------
#PN11
sub  query_file_dialog3 {

    if (! Exists ($pn11)) {
	$pn11 = $mw ->Toplevel();
	foreach my $i (qw(open)) {
	    my $f = $pn11->Frame;
	    my $lab = $f->Label(-text => "Select a file to $i: ",
				-anchor => 'e');
	    my $ent = $f->Entry(-width => 20);
	    my $but = $f->Button(-text => "Browse ...",
				 -command => sub { fileDialog2($pn11, $ent, $i)});
	    $lab->pack(-side => 'left');
	    $ent->pack(-side => 'left',-expand => 'yes', -fill => 'x');
	    $but->pack(-side => 'left');
	    $f->pack(-fill => 'x', -padx => '1c', -pady => 3);
	}
	
	my $cbf = $pn11->Frame->pack(-fill => 'x', -padx => '1c', -pady => 3);
	my $fd;
	$cbf->Radiobutton
	(-text => 'FileSelect',
	 -variable => \$fd,
	 -value => 'FileSelect',
	 -command => sub { local($^W) = 0;
			   require Tk::FileSelect;
			 Tk::FileSelect->import('as_default');
			   # XXX remove cached dialogs
			   my $pn11 = $pn11->MainWindow;
			   delete $pn11->{'tk_getOpenFile'};
#			 delete $pn11->{'tk_getSaveFile'};
		       })->pack(-side => 'left');
	my $fdb = $cbf->Radiobutton
	    (-text => 'FBox',
	     -variable => \$fd,
	     -value => 'FBox',
	     -command => sub { local($^W) = 0;
			       require Tk::FBox;
			     Tk::FBox->import('as_default');
			       # XXX remove cached dialogs
			       my $pn11 = $pn11->MainWindow;
			       delete $pn11->{'tk_getOpenFile'};
#			 delete $pn11->{'tk_getSaveFile'};
			   })->pack(-side => 'left');
	$fdb->invoke;
    }
}
#-----------------------------------
sub  mkIndisponible {
    $mw->Dialog(
		-title => "Indisponible",
		-text  => "Indisponible pour le moment... "
		)->Show();
}
#-----------------------------------
sub  mkWaitBox {
	$waitBoxWidget = $mw->Toplevel();
	$waitBoxWidget->title("Work In Progress");
	$waitBoxWidget->Label(-image => $logoMKC)->pack(-side => 'right');
	my $txt = "MKCorpus is working for you...";
	$waitBoxWidget->Label(-text => $txt)->pack(-side => 'top');

}
sub removeWaitBox {

   $waitBoxWidget->destroy if Exists($waitBoxWidget);
}
#-----------------------------------
# ErrBox
#
# A error occured, show a small dialog
#
# in:  Message
# out: -

sub mkPrintErreur
{
   my $msg = shift;

   $mw->Dialog(
      -title => "ERROR !",
      -text  => $msg
   )->Show();
}

#-----------------------------------
sub  mkPrintMsgInfo {
    my $msg = shift;
    $mw->Dialog(
		-title => "Info : ",
		-text  => $msg
		)->Show();
}


#-------------------------XML PARSER routines-------------------------
sub char_handler {
    my ($p, $data) = @_;
    if ($::state::store_contents) {
      $::state::storage{$::state::store_contents} .= $data;
    } else {
       # print $data;
    }
}
#---------------------------------------------
sub start_handler {
    my $expat=shift;
    my $element=shift;
    if (!exists ($Liste_xmlBalise{$element})) {
		    $Liste_xmlBalise{$element}=1;
		    push (@liste_xmlBalise, $element);
		}
}
#---------------------------------------------
sub start_handlerLexico {
    my $expat=shift;
    my $element=shift;
    if (!exists ($Liste_xmlLexicoBalise{$element})) {
		    $Liste_xmlLexicoBalise{$element}=1;
		    push (@liste_xmlLexicoBalise, $element);
		}
    if (!exists ($Liste_xmlLexicoBalise2{$element})) {
		    $Liste_xmlLexicoBalise2{$element}=1;
		    push (@liste_xmlLexicoBalise2, $element);
		}
}
#---------------------------------------------
sub end_handler {
    my $expat = shift; my $element = shift;
}
#---------------------------------------------
sub usageUploading {
	print STDERR join("\n", @_) . "\n" if @_;
#	print STDERR $Usage;
}
#---------------------------------------------
sub translate {
  # this is taken from HTML::Entities.pm

  %entity2char = (
  # Some normal chars that have special meaning in SGML context
 amp    => '&',  # ampersand 
'gt'    => '>',  # greater than
'lt'    => '<',  # less than
 quot   => '"',  # double quote


 # PUBLIC ISO 8879-1986//ENTITIES Added Latin 1//EN//HTML
 AElig	=> '',  # capital AE diphthong (ligature)
 Aacute	=> '',  # capital A, acute accent
 Acirc	=> '',  # capital A, circumflex accent
 Agrave	=> '',  # capital A, grave accent
 Aring	=> '',  # capital A, ring
 Atilde	=> '',  # capital A, tilde
 Auml       => '',  # capital A, dieresis or umlaut mark
 Ccedil	=> '',  # capital C, cedilla
 ETH        => '',  # capital Eth, Icelandic
 Eacute	=> '',  # capital E, acute accent
 Ecirc	=> '',  # capital E, circumflex accent
 Egrave	=> '',  # capital E, grave accent
 Euml       => '',  # capital E, dieresis or umlaut mark
 Dstrok     => '',  # capital 
 Iacute	=> '',  # capital I, acute accent
 Icirc	=> '',  # capital I, circumflex accent
 Igrave	=> '',  # capital I, grave accent
 Iuml       => '',  # capital I, dieresis or umlaut mark
 Ntilde	=> '',  # capital N, tilde
 Oacute	=> '',  # capital O, acute accent
 Ocirc	=> '',  # capital O, circumflex accent
 OElig      => '',  # capital , diphtong
 Ograve	=> '',  # capital O, grave accent
 Oslash	=> '',  # capital O, slash
 Otilde	=> '',  # capital O, tilde
 Ouml       => '',  # capital O, dieresis or umlaut mark
 THORN	=> '',  # capital THORN, Icelandic
 Uacute	=> '',  # capital U, acute accent
 Ucirc	=> '',  # capital U, circumflex accent
 Ugrave	=> '',  # capital U, grave accent
 Uuml       => '',  # capital U, dieresis or umlaut mark
 Yacute	=> '',  # capital Y, acute accent
 aelig      => '',  # small , diphtong
 aacute	=> '',  # small a, acute accent
 acirc	=> '',  # small a, circumflex accent
 aelig	=> '',  # small ae diphthong (ligature)
 agrave	=> '',  # small a, grave accent
 aring	=> '',  # small a, ring
 atilde	=> '',  # small a, tilde
 auml       => '',  # small a, dieresis or umlaut mark
 ccedil	=> '',  # small c, cedilla
 eacute	=> '',  # small e, acute accent
 ecirc	=> '',  # small e, circumflex accent
 egrave	=> '',  # small e, grave accent
 eth        => '',  # small eth, Icelandic
 euml       => '',  # small e, dieresis or umlaut mark
 iacute	=> '',  # small i, acute accent
 icirc	=> '',  # small i, circumflex accent
 igrave	=> '',  # small i, grave accent
 iuml       => '',  # small i, dieresis or umlaut mark
 ntilde	=> '',  # small n, tilde
 oacute	=> '',  # small o, acute accent
 ocirc	=> '',  # small o, circumflex accent
 ograve	=> '',  # small o, grave accent
 oslash	=> '',  # small o, slash
 otilde	=> '',  # small o, tilde
 ouml       => '',  # small o, dieresis or umlaut mark
 pound	=> '',  # symbol
 szlig	=> '',  # small sharp s, German (sz ligature)
 thorn	=> '',  # small thorn, Icelandic
 uacute	=> '',  # small u, acute accent
 ucirc	=> '',  # small u, circumflex accent
 ugrave	=> '',  # small u, grave accent
 uuml       => '',  # small u, dieresis or umlaut mark
 yacute	=> '',  # small , acute accent
 yuml       => '',  # small , circumflex accent

 acute  => '',
 brkbar => '',
 cedil  => '',
 cent   => '',
 copy   => '(c)',
 curren => '',
 deg    => '',
 divide => '',
 emdash => '-',
 endash => '',
 frac14 => '1/4',
 frac12 => '1/2',
 frac34 => '3/4',
 hellip => '...',
 hibar  => '',
 iexcl  => '',
 iquest => '',
 laquo  => '"',
 macr   => '',
 micro  => '',
 middot => '',
 nbsp   => ' ',
 not    => '',
 ordf   => '',
 ordm   => '',
 para   => '',
 plusmn => '',
 raquo  => '"',
 reg    => '(r)',
 sect   => '',
 shy    => '',
 sup1   => '',
 sup2   => '',
 sup3   => '',
'times' => '',    # times is a keyword in perl
 uml    => '',
 yen    => '',
);

  # Make the oposite mapping
  while (($entity, $char) = each(%entity2char)) {
    $char2entity{$char} = "&$entity;";
  }

  # Fill inn missing entities
  for (0 .. 255) {
    next if exists $char2entity{chr($_)};
    $char2entity{chr($_)} = "&#$_;";
  }

  my $array;
  if (defined wantarray) {
    $array = [@_]; # copy
  }
  else {
    $array = \@_;  # modify in-place
  }
  my $c;
  for (@$array) {
    s/&amp;?/&/g;

    s/(&\#(\d+);?)/$2 < 256 ? chr($2) : $1/eg;
    s/(&\#[xX]([0-9a-fA-F]+);?)/$c = hex($2); $c < 256 ? chr($c) : $1/eg;
    s/(&(\w+);?)/$entity2char{$2} || "$1;"/eg;

    s/&Oelig;?//g;
    s/&oelig;?//g;
    s/&eaacute;?//g;
    s/&\#9484;?//g;
    s/&ecric;?//g;
    s/&laqno;?/"/g;
    s#\s+# #sg;

    # local spelling
  }
  wantarray ? @$array : $array->[0];
}
